#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 12
#define STATE_COUNT 685
#define LARGE_STATE_COUNT 234
#define SYMBOL_COUNT 101
#define ALIAS_COUNT 0
#define TOKEN_COUNT 51
#define EXTERNAL_TOKEN_COUNT 2
#define FIELD_COUNT 14
#define MAX_ALIAS_SEQUENCE_LENGTH 7

enum {
  sym_symbol = 1,
  sym_line_comment = 2,
  anon_sym_LPAREN = 3,
  anon_sym_RPAREN = 4,
  anon_sym_LBRACK = 5,
  anon_sym_RBRACK = 6,
  anon_sym_AT_LPAREN = 7,
  anon_sym_AT_LBRACK = 8,
  anon_sym_LBRACE = 9,
  anon_sym_RBRACE = 10,
  anon_sym_AT_LBRACE = 11,
  anon_sym_set = 12,
  anon_sym_def = 13,
  anon_sym_var = 14,
  anon_sym_quote = 15,
  anon_sym_splice = 16,
  anon_sym_quasiquote = 17,
  anon_sym_unquote = 18,
  anon_sym_break = 19,
  anon_sym_if = 20,
  anon_sym_do = 21,
  anon_sym_while = 22,
  anon_sym_fn = 23,
  anon_sym_upscope = 24,
  sym_variadic_marker = 25,
  sym_optional_marker = 26,
  sym_keys_marker = 27,
  anon_sym_SQUOTE = 28,
  anon_sym_SEMI = 29,
  anon_sym_TILDE = 30,
  anon_sym_COMMA = 31,
  anon_sym_PIPE = 32,
  anon_sym_defn = 33,
  anon_sym_defn_DASH = 34,
  anon_sym_varfn = 35,
  anon_sym_varfn_DASH = 36,
  anon_sym_defmacro = 37,
  anon_sym_defmacro_DASH = 38,
  sym_str_literal = 39,
  sym_buffer_literal = 40,
  aux_sym_number_literal_token1 = 41,
  aux_sym_number_literal_token2 = 42,
  aux_sym_number_literal_token3 = 43,
  anon_sym_true = 44,
  anon_sym_false = 45,
  sym_nil_literal = 46,
  sym_escape_sequence = 47,
  sym_keyword = 48,
  sym__long_str = 49,
  sym__long_buffer = 50,
  sym_source_file = 51,
  sym__expr = 52,
  sym_tuple = 53,
  sym_sqr_tuple = 54,
  sym_array = 55,
  sym_sqr_array = 56,
  sym_struct = 57,
  sym_table = 58,
  sym__struct_tables_commom = 59,
  sym_peg_set = 60,
  sym__special_forms = 61,
  sym_def = 62,
  sym_var = 63,
  sym_quote = 64,
  sym_splice = 65,
  sym_quasiquote = 66,
  sym_unquote = 67,
  sym_break = 68,
  sym_set = 69,
  sym_if = 70,
  sym_do = 71,
  sym_while = 72,
  sym_fn = 73,
  sym_upscope = 74,
  sym__parameters = 75,
  sym_parameters = 76,
  sym_tuple_parameters = 77,
  sym__shorthand = 78,
  sym_short_quote = 79,
  sym_short_splice = 80,
  sym_short_quasiquote = 81,
  sym_short_unquote = 82,
  sym_short_fn = 83,
  sym__specials = 84,
  sym_extra_defs = 85,
  sym__literals = 86,
  sym_long_str_literal = 87,
  sym_long_buffer_literal = 88,
  sym_number_literal = 89,
  sym_bool_literal = 90,
  sym_metadata = 91,
  sym__name = 92,
  sym_body = 93,
  sym__identifier = 94,
  aux_sym_source_file_repeat1 = 95,
  aux_sym_tuple_repeat1 = 96,
  aux_sym_struct_repeat1 = 97,
  aux_sym_def_repeat1 = 98,
  aux_sym_while_repeat1 = 99,
  aux_sym_parameters_repeat1 = 100,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_symbol] = "symbol",
  [sym_line_comment] = "line_comment",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_AT_LPAREN] = "@(",
  [anon_sym_AT_LBRACK] = "@[",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_AT_LBRACE] = "@{",
  [anon_sym_set] = "set",
  [anon_sym_def] = "def",
  [anon_sym_var] = "var",
  [anon_sym_quote] = "quote",
  [anon_sym_splice] = "splice",
  [anon_sym_quasiquote] = "quasiquote",
  [anon_sym_unquote] = "unquote",
  [anon_sym_break] = "break",
  [anon_sym_if] = "if",
  [anon_sym_do] = "do",
  [anon_sym_while] = "while",
  [anon_sym_fn] = "fn",
  [anon_sym_upscope] = "upscope",
  [sym_variadic_marker] = "variadic_marker",
  [sym_optional_marker] = "optional_marker",
  [sym_keys_marker] = "keys_marker",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_SEMI] = ";",
  [anon_sym_TILDE] = "~",
  [anon_sym_COMMA] = ",",
  [anon_sym_PIPE] = "|",
  [anon_sym_defn] = "defn",
  [anon_sym_defn_DASH] = "defn-",
  [anon_sym_varfn] = "varfn",
  [anon_sym_varfn_DASH] = "varfn-",
  [anon_sym_defmacro] = "defmacro",
  [anon_sym_defmacro_DASH] = "defmacro-",
  [sym_str_literal] = "str_literal",
  [sym_buffer_literal] = "buffer_literal",
  [aux_sym_number_literal_token1] = "number_literal_token1",
  [aux_sym_number_literal_token2] = "number_literal_token2",
  [aux_sym_number_literal_token3] = "number_literal_token3",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [sym_nil_literal] = "nil_literal",
  [sym_escape_sequence] = "escape_sequence",
  [sym_keyword] = "keyword",
  [sym__long_str] = "_long_str",
  [sym__long_buffer] = "_long_buffer",
  [sym_source_file] = "source_file",
  [sym__expr] = "_expr",
  [sym_tuple] = "tuple",
  [sym_sqr_tuple] = "sqr_tuple",
  [sym_array] = "array",
  [sym_sqr_array] = "sqr_array",
  [sym_struct] = "struct",
  [sym_table] = "table",
  [sym__struct_tables_commom] = "_struct_tables_commom",
  [sym_peg_set] = "peg_set",
  [sym__special_forms] = "_special_forms",
  [sym_def] = "def",
  [sym_var] = "var",
  [sym_quote] = "quote",
  [sym_splice] = "splice",
  [sym_quasiquote] = "quasiquote",
  [sym_unquote] = "unquote",
  [sym_break] = "break",
  [sym_set] = "set",
  [sym_if] = "if",
  [sym_do] = "do",
  [sym_while] = "while",
  [sym_fn] = "fn",
  [sym_upscope] = "upscope",
  [sym__parameters] = "_parameters",
  [sym_parameters] = "parameters",
  [sym_tuple_parameters] = "tuple_parameters",
  [sym__shorthand] = "_shorthand",
  [sym_short_quote] = "short_quote",
  [sym_short_splice] = "short_splice",
  [sym_short_quasiquote] = "short_quasiquote",
  [sym_short_unquote] = "short_unquote",
  [sym_short_fn] = "short_fn",
  [sym__specials] = "_specials",
  [sym_extra_defs] = "extra_defs",
  [sym__literals] = "_literals",
  [sym_long_str_literal] = "long_str_literal",
  [sym_long_buffer_literal] = "long_buffer_literal",
  [sym_number_literal] = "number_literal",
  [sym_bool_literal] = "bool_literal",
  [sym_metadata] = "metadata",
  [sym__name] = "_name",
  [sym_body] = "body",
  [sym__identifier] = "_identifier",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_tuple_repeat1] = "tuple_repeat1",
  [aux_sym_struct_repeat1] = "struct_repeat1",
  [aux_sym_def_repeat1] = "def_repeat1",
  [aux_sym_while_repeat1] = "while_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_symbol] = sym_symbol,
  [sym_line_comment] = sym_line_comment,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_AT_LPAREN] = anon_sym_AT_LPAREN,
  [anon_sym_AT_LBRACK] = anon_sym_AT_LBRACK,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_AT_LBRACE] = anon_sym_AT_LBRACE,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_def] = anon_sym_def,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_quote] = anon_sym_quote,
  [anon_sym_splice] = anon_sym_splice,
  [anon_sym_quasiquote] = anon_sym_quasiquote,
  [anon_sym_unquote] = anon_sym_unquote,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_fn] = anon_sym_fn,
  [anon_sym_upscope] = anon_sym_upscope,
  [sym_variadic_marker] = sym_variadic_marker,
  [sym_optional_marker] = sym_optional_marker,
  [sym_keys_marker] = sym_keys_marker,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_defn] = anon_sym_defn,
  [anon_sym_defn_DASH] = anon_sym_defn_DASH,
  [anon_sym_varfn] = anon_sym_varfn,
  [anon_sym_varfn_DASH] = anon_sym_varfn_DASH,
  [anon_sym_defmacro] = anon_sym_defmacro,
  [anon_sym_defmacro_DASH] = anon_sym_defmacro_DASH,
  [sym_str_literal] = sym_str_literal,
  [sym_buffer_literal] = sym_buffer_literal,
  [aux_sym_number_literal_token1] = aux_sym_number_literal_token1,
  [aux_sym_number_literal_token2] = aux_sym_number_literal_token2,
  [aux_sym_number_literal_token3] = aux_sym_number_literal_token3,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [sym_nil_literal] = sym_nil_literal,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_keyword] = sym_keyword,
  [sym__long_str] = sym__long_str,
  [sym__long_buffer] = sym__long_buffer,
  [sym_source_file] = sym_source_file,
  [sym__expr] = sym__expr,
  [sym_tuple] = sym_tuple,
  [sym_sqr_tuple] = sym_sqr_tuple,
  [sym_array] = sym_array,
  [sym_sqr_array] = sym_sqr_array,
  [sym_struct] = sym_struct,
  [sym_table] = sym_table,
  [sym__struct_tables_commom] = sym__struct_tables_commom,
  [sym_peg_set] = sym_peg_set,
  [sym__special_forms] = sym__special_forms,
  [sym_def] = sym_def,
  [sym_var] = sym_var,
  [sym_quote] = sym_quote,
  [sym_splice] = sym_splice,
  [sym_quasiquote] = sym_quasiquote,
  [sym_unquote] = sym_unquote,
  [sym_break] = sym_break,
  [sym_set] = sym_set,
  [sym_if] = sym_if,
  [sym_do] = sym_do,
  [sym_while] = sym_while,
  [sym_fn] = sym_fn,
  [sym_upscope] = sym_upscope,
  [sym__parameters] = sym__parameters,
  [sym_parameters] = sym_parameters,
  [sym_tuple_parameters] = sym_tuple_parameters,
  [sym__shorthand] = sym__shorthand,
  [sym_short_quote] = sym_short_quote,
  [sym_short_splice] = sym_short_splice,
  [sym_short_quasiquote] = sym_short_quasiquote,
  [sym_short_unquote] = sym_short_unquote,
  [sym_short_fn] = sym_short_fn,
  [sym__specials] = sym__specials,
  [sym_extra_defs] = sym_extra_defs,
  [sym__literals] = sym__literals,
  [sym_long_str_literal] = sym_long_str_literal,
  [sym_long_buffer_literal] = sym_long_buffer_literal,
  [sym_number_literal] = sym_number_literal,
  [sym_bool_literal] = sym_bool_literal,
  [sym_metadata] = sym_metadata,
  [sym__name] = sym__name,
  [sym_body] = sym_body,
  [sym__identifier] = sym__identifier,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_tuple_repeat1] = aux_sym_tuple_repeat1,
  [aux_sym_struct_repeat1] = aux_sym_struct_repeat1,
  [aux_sym_def_repeat1] = aux_sym_def_repeat1,
  [aux_sym_while_repeat1] = aux_sym_while_repeat1,
  [aux_sym_parameters_repeat1] = aux_sym_parameters_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_symbol] = {
    .visible = true,
    .named = true,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_quote] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_splice] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_quasiquote] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unquote] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_upscope] = {
    .visible = true,
    .named = false,
  },
  [sym_variadic_marker] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_marker] = {
    .visible = true,
    .named = true,
  },
  [sym_keys_marker] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defn_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_varfn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_varfn_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defmacro] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defmacro_DASH] = {
    .visible = true,
    .named = false,
  },
  [sym_str_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_buffer_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_number_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_number_literal_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_number_literal_token3] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [sym_nil_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword] = {
    .visible = true,
    .named = true,
  },
  [sym__long_str] = {
    .visible = false,
    .named = true,
  },
  [sym__long_buffer] = {
    .visible = false,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__expr] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_sqr_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_sqr_array] = {
    .visible = true,
    .named = true,
  },
  [sym_struct] = {
    .visible = true,
    .named = true,
  },
  [sym_table] = {
    .visible = true,
    .named = true,
  },
  [sym__struct_tables_commom] = {
    .visible = false,
    .named = true,
  },
  [sym_peg_set] = {
    .visible = true,
    .named = true,
  },
  [sym__special_forms] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_def] = {
    .visible = true,
    .named = true,
  },
  [sym_var] = {
    .visible = true,
    .named = true,
  },
  [sym_quote] = {
    .visible = true,
    .named = true,
  },
  [sym_splice] = {
    .visible = true,
    .named = true,
  },
  [sym_quasiquote] = {
    .visible = true,
    .named = true,
  },
  [sym_unquote] = {
    .visible = true,
    .named = true,
  },
  [sym_break] = {
    .visible = true,
    .named = true,
  },
  [sym_set] = {
    .visible = true,
    .named = true,
  },
  [sym_if] = {
    .visible = true,
    .named = true,
  },
  [sym_do] = {
    .visible = true,
    .named = true,
  },
  [sym_while] = {
    .visible = true,
    .named = true,
  },
  [sym_fn] = {
    .visible = true,
    .named = true,
  },
  [sym_upscope] = {
    .visible = true,
    .named = true,
  },
  [sym__parameters] = {
    .visible = false,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__shorthand] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_short_quote] = {
    .visible = true,
    .named = true,
  },
  [sym_short_splice] = {
    .visible = true,
    .named = true,
  },
  [sym_short_quasiquote] = {
    .visible = true,
    .named = true,
  },
  [sym_short_unquote] = {
    .visible = true,
    .named = true,
  },
  [sym_short_fn] = {
    .visible = true,
    .named = true,
  },
  [sym__specials] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_extra_defs] = {
    .visible = true,
    .named = true,
  },
  [sym__literals] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_long_str_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_long_buffer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_bool_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_metadata] = {
    .visible = true,
    .named = true,
  },
  [sym__name] = {
    .visible = false,
    .named = true,
  },
  [sym_body] = {
    .visible = true,
    .named = true,
  },
  [sym__identifier] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_def_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_while_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum {
  field_body = 1,
  field_condition = 2,
  field_else = 3,
  field_form = 4,
  field_item = 5,
  field_key = 6,
  field_l_value = 7,
  field_metadata = 8,
  field_name = 9,
  field_parameter = 10,
  field_parameters = 11,
  field_r_value = 12,
  field_then = 13,
  field_value = 14,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_body] = "body",
  [field_condition] = "condition",
  [field_else] = "else",
  [field_form] = "form",
  [field_item] = "item",
  [field_key] = "key",
  [field_l_value] = "l_value",
  [field_metadata] = "metadata",
  [field_name] = "name",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_r_value] = "r_value",
  [field_then] = "then",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[32] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 2},
  [3] = {.index = 3, .length = 1},
  [4] = {.index = 4, .length = 1},
  [5] = {.index = 5, .length = 1},
  [6] = {.index = 6, .length = 1},
  [7] = {.index = 7, .length = 2},
  [8] = {.index = 9, .length = 2},
  [9] = {.index = 11, .length = 2},
  [10] = {.index = 13, .length = 4},
  [11] = {.index = 17, .length = 1},
  [12] = {.index = 18, .length = 1},
  [13] = {.index = 19, .length = 2},
  [14] = {.index = 21, .length = 1},
  [15] = {.index = 22, .length = 1},
  [16] = {.index = 23, .length = 1},
  [17] = {.index = 24, .length = 2},
  [18] = {.index = 26, .length = 2},
  [19] = {.index = 28, .length = 2},
  [20] = {.index = 30, .length = 2},
  [21] = {.index = 32, .length = 2},
  [22] = {.index = 34, .length = 2},
  [23] = {.index = 36, .length = 2},
  [24] = {.index = 38, .length = 2},
  [25] = {.index = 40, .length = 3},
  [26] = {.index = 43, .length = 3},
  [27] = {.index = 46, .length = 1},
  [28] = {.index = 47, .length = 3},
  [29] = {.index = 50, .length = 3},
  [30] = {.index = 53, .length = 2},
  [31] = {.index = 55, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_item, 0},
  [1] =
    {field_key, 0, .inherited = true},
    {field_value, 0, .inherited = true},
  [3] =
    {field_body, 1},
  [4] =
    {field_form, 0},
  [5] =
    {field_form, 0, .inherited = true},
  [6] =
    {field_item, 1, .inherited = true},
  [7] =
    {field_item, 0, .inherited = true},
    {field_item, 1, .inherited = true},
  [9] =
    {field_key, 0},
    {field_value, 1},
  [11] =
    {field_key, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [13] =
    {field_key, 0, .inherited = true},
    {field_key, 1, .inherited = true},
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [17] =
    {field_metadata, 0},
  [18] =
    {field_body, 2},
  [19] =
    {field_form, 0, .inherited = true},
    {field_form, 1, .inherited = true},
  [21] =
    {field_condition, 2},
  [22] =
    {field_parameter, 0},
  [23] =
    {field_parameters, 2},
  [24] =
    {field_l_value, 2},
    {field_r_value, 3},
  [26] =
    {field_name, 2},
    {field_value, 3},
  [28] =
    {field_metadata, 0, .inherited = true},
    {field_metadata, 1, .inherited = true},
  [30] =
    {field_condition, 2},
    {field_then, 3},
  [32] =
    {field_condition, 2},
    {field_form, 3, .inherited = true},
  [34] =
    {field_parameter, 0, .inherited = true},
    {field_parameter, 1, .inherited = true},
  [36] =
    {field_body, 3},
    {field_parameters, 2},
  [38] =
    {field_name, 2},
    {field_parameters, 3},
  [40] =
    {field_metadata, 3, .inherited = true},
    {field_name, 2},
    {field_value, 4},
  [43] =
    {field_condition, 2},
    {field_else, 4},
    {field_then, 3},
  [46] =
    {field_parameter, 2, .inherited = true},
  [47] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3},
  [50] =
    {field_metadata, 3, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
  [53] =
    {field_parameter, 1, .inherited = true},
    {field_parameter, 3, .inherited = true},
  [55] =
    {field_body, 5},
    {field_metadata, 3, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
};

static TSSymbol ts_alias_sequences[32][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static inline bool sym_symbol_character_set_1(int32_t c) {
  return (c < ','
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? c == '"'
        : c <= ')')))
    : (c <= ',' || (c < ']'
      ? (c < '['
        ? c == ';'
        : c <= '[')
      : (c <= ']' || (c < '{'
        ? c == '`'
        : c <= '~')))));
}

static inline bool sym_symbol_character_set_2(int32_t c) {
  return (c < '\''
    ? (c < '\r'
      ? (c < '\t'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < '"'
        ? c == ' '
        : c <= '"')))
    : (c <= ')' || (c < '['
      ? (c < ';'
        ? c == ','
        : c <= ';')
      : (c <= '[' || (c < '`'
        ? c == ']'
        : c <= '~')))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(23);
      if (lookahead == '"') ADVANCE(3);
      if (lookahead == '#') ADVANCE(24);
      if (lookahead == '&') ADVANCE(35);
      if (lookahead == '\'') ADVANCE(38);
      if (lookahead == '(') ADVANCE(26);
      if (lookahead == ')') ADVANCE(27);
      if (lookahead == ',') ADVANCE(41);
      if (lookahead == '.') ADVANCE(75);
      if (lookahead == '0') ADVANCE(45);
      if (lookahead == ':') ADVANCE(59);
      if (lookahead == ';') ADVANCE(39);
      if (lookahead == '@') ADVANCE(60);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(68);
      if (lookahead == ']') ADVANCE(29);
      if (lookahead == '{') ADVANCE(32);
      if (lookahead == '|') ADVANCE(42);
      if (lookahead == '}') ADVANCE(33);
      if (lookahead == '~') ADVANCE(40);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(21)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (lookahead != 0 &&
          lookahead != '`') ADVANCE(83);
      END_STATE();
    case 1:
      if (lookahead == '"') ADVANCE(3);
      if (lookahead == '#') ADVANCE(24);
      if (lookahead == '&') ADVANCE(35);
      if (lookahead == '\'') ADVANCE(38);
      if (lookahead == '(') ADVANCE(26);
      if (lookahead == ')') ADVANCE(27);
      if (lookahead == ',') ADVANCE(41);
      if (lookahead == '.') ADVANCE(75);
      if (lookahead == '0') ADVANCE(45);
      if (lookahead == ':') ADVANCE(59);
      if (lookahead == ';') ADVANCE(39);
      if (lookahead == '@') ADVANCE(60);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == ']') ADVANCE(29);
      if (lookahead == '{') ADVANCE(32);
      if (lookahead == '|') ADVANCE(42);
      if (lookahead == '~') ADVANCE(40);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(1)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (lookahead != 0 &&
          lookahead != '`' &&
          lookahead != '}') ADVANCE(83);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(3);
      if (lookahead == '#') ADVANCE(24);
      if (lookahead == '\'') ADVANCE(38);
      if (lookahead == '(') ADVANCE(26);
      if (lookahead == ',') ADVANCE(41);
      if (lookahead == ':') ADVANCE(59);
      if (lookahead == ';') ADVANCE(39);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == '{') ADVANCE(32);
      if (lookahead == '~') ADVANCE(40);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(2)
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != ']' &&
          lookahead != '`' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(83);
      END_STATE();
    case 3:
      if (lookahead == '"') ADVANCE(43);
      if (lookahead == '\\') ADVANCE(5);
      if (lookahead != 0) ADVANCE(3);
      END_STATE();
    case 4:
      if (lookahead == '"') ADVANCE(44);
      if (lookahead == '\\') ADVANCE(6);
      if (lookahead != 0) ADVANCE(4);
      END_STATE();
    case 5:
      if (lookahead == 'u') ADVANCE(7);
      if (lookahead == 'x') ADVANCE(18);
      if (lookahead != 0) ADVANCE(3);
      END_STATE();
    case 6:
      if (lookahead == 'u') ADVANCE(8);
      if (lookahead == 'x') ADVANCE(19);
      if (lookahead != 0) ADVANCE(4);
      END_STATE();
    case 7:
      if (lookahead == '{') ADVANCE(16);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(13);
      END_STATE();
    case 8:
      if (lookahead == '{') ADVANCE(17);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(20);
      END_STATE();
    case 9:
      if (lookahead == '}') ADVANCE(3);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(9);
      END_STATE();
    case 10:
      if (lookahead == '}') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(10);
      END_STATE();
    case 11:
      if (lookahead == '}') ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(11);
      END_STATE();
    case 12:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(3);
      END_STATE();
    case 13:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(18);
      END_STATE();
    case 14:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(10);
      END_STATE();
    case 15:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(4);
      END_STATE();
    case 16:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(9);
      END_STATE();
    case 17:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(11);
      END_STATE();
    case 18:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(12);
      END_STATE();
    case 19:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(15);
      END_STATE();
    case 20:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(19);
      END_STATE();
    case 21:
      if (eof) ADVANCE(23);
      if (lookahead == '"') ADVANCE(3);
      if (lookahead == '#') ADVANCE(24);
      if (lookahead == '&') ADVANCE(35);
      if (lookahead == '\'') ADVANCE(38);
      if (lookahead == '(') ADVANCE(26);
      if (lookahead == ')') ADVANCE(27);
      if (lookahead == ',') ADVANCE(41);
      if (lookahead == '.') ADVANCE(75);
      if (lookahead == '0') ADVANCE(45);
      if (lookahead == ':') ADVANCE(59);
      if (lookahead == ';') ADVANCE(39);
      if (lookahead == '@') ADVANCE(60);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == ']') ADVANCE(29);
      if (lookahead == '{') ADVANCE(32);
      if (lookahead == '|') ADVANCE(42);
      if (lookahead == '}') ADVANCE(33);
      if (lookahead == '~') ADVANCE(40);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(21)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (lookahead != 0 &&
          lookahead != '`') ADVANCE(83);
      END_STATE();
    case 22:
      if (eof) ADVANCE(23);
      if (lookahead == '"') ADVANCE(3);
      if (lookahead == '#') ADVANCE(24);
      if (lookahead == '\'') ADVANCE(38);
      if (lookahead == '(') ADVANCE(26);
      if (lookahead == ')') ADVANCE(27);
      if (lookahead == ',') ADVANCE(41);
      if (lookahead == '.') ADVANCE(75);
      if (lookahead == '0') ADVANCE(45);
      if (lookahead == ':') ADVANCE(59);
      if (lookahead == ';') ADVANCE(39);
      if (lookahead == '@') ADVANCE(60);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == ']') ADVANCE(29);
      if (lookahead == '{') ADVANCE(32);
      if (lookahead == '|') ADVANCE(42);
      if (lookahead == '}') ADVANCE(33);
      if (lookahead == '~') ADVANCE(40);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(22)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (lookahead != 0 &&
          lookahead != '`') ADVANCE(83);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '"' ||
          ('\'' <= lookahead && lookahead <= ')') ||
          lookahead == ',' ||
          lookahead == ';' ||
          lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '~')) ADVANCE(25);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(24);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(25);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_AT_LPAREN);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_AT_LBRACK);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_AT_LBRACE);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(sym_variadic_marker);
      if (lookahead == 'k') ADVANCE(64);
      if (lookahead == 'o') ADVANCE(65);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(sym_optional_marker);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(sym_keys_marker);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(sym_str_literal);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(sym_buffer_literal);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '.') ADVANCE(49);
      if (lookahead == '_') ADVANCE(48);
      if (lookahead == 'r') ADVANCE(62);
      if (lookahead == 'x') ADVANCE(63);
      if (lookahead == '&' ||
          lookahead == 'E' ||
          lookahead == 'e') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(47);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '.') ADVANCE(49);
      if (lookahead == '_') ADVANCE(48);
      if (lookahead == 'r') ADVANCE(62);
      if (lookahead == '&' ||
          lookahead == 'E' ||
          lookahead == 'e') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(47);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '.') ADVANCE(49);
      if (lookahead == 'r') ADVANCE(62);
      if (lookahead == '&' ||
          lookahead == 'E' ||
          lookahead == 'e') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(48);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '.') ADVANCE(49);
      if (lookahead == '&' ||
          lookahead == 'E' ||
          lookahead == 'e') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(48);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '&' ||
          lookahead == 'E' ||
          lookahead == 'e') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(49);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(50);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (lookahead == '&') ADVANCE(73);
      if (lookahead == '.') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (lookahead == '&') ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(aux_sym_number_literal_token3);
      if (lookahead == '&') ADVANCE(72);
      if (lookahead == '.') ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(54);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(aux_sym_number_literal_token3);
      if (lookahead == '&') ADVANCE(72);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(55);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(aux_sym_number_literal_token3);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(56);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(sym_keyword);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(59);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '"') ADVANCE(4);
      if (lookahead == '(') ADVANCE(30);
      if (lookahead == '[') ADVANCE(31);
      if (lookahead == '{') ADVANCE(34);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead)) ADVANCE(83);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '.') ADVANCE(75);
      if (lookahead == '0') ADVANCE(45);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '.') ADVANCE(81);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(54);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '.') ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == 'e') ADVANCE(69);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == 'p') ADVANCE(67);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == 's') ADVANCE(37);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == 't') ADVANCE(36);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == 'u') ADVANCE(70);
      if (lookahead == 'x') ADVANCE(79);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '"' ||
          ('\'' <= lookahead && lookahead <= ')') ||
          lookahead == ',' ||
          lookahead == ';' ||
          lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '~')) ADVANCE(57);
      if (lookahead != 0) ADVANCE(58);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == 'y') ADVANCE(66);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '{') ADVANCE(14);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead)) ADVANCE(83);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(74);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(50);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(82);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(56);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(78);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(50);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(49);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(79);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(58);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(77);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(55);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(56);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_symbol);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'b') ADVANCE(1);
      if (lookahead == 'd') ADVANCE(2);
      if (lookahead == 'f') ADVANCE(3);
      if (lookahead == 'i') ADVANCE(4);
      if (lookahead == 'n') ADVANCE(5);
      if (lookahead == 'q') ADVANCE(6);
      if (lookahead == 's') ADVANCE(7);
      if (lookahead == 't') ADVANCE(8);
      if (lookahead == 'u') ADVANCE(9);
      if (lookahead == 'v') ADVANCE(10);
      if (lookahead == 'w') ADVANCE(11);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'r') ADVANCE(12);
      END_STATE();
    case 2:
      if (lookahead == 'e') ADVANCE(13);
      if (lookahead == 'o') ADVANCE(14);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(15);
      if (lookahead == 'n') ADVANCE(16);
      END_STATE();
    case 4:
      if (lookahead == 'f') ADVANCE(17);
      END_STATE();
    case 5:
      if (lookahead == 'i') ADVANCE(18);
      END_STATE();
    case 6:
      if (lookahead == 'u') ADVANCE(19);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(20);
      if (lookahead == 'p') ADVANCE(21);
      END_STATE();
    case 8:
      if (lookahead == 'r') ADVANCE(22);
      END_STATE();
    case 9:
      if (lookahead == 'n') ADVANCE(23);
      if (lookahead == 'p') ADVANCE(24);
      END_STATE();
    case 10:
      if (lookahead == 'a') ADVANCE(25);
      END_STATE();
    case 11:
      if (lookahead == 'h') ADVANCE(26);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(27);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(28);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 15:
      if (lookahead == 'l') ADVANCE(29);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_fn);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 18:
      if (lookahead == 'l') ADVANCE(30);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 20:
      if (lookahead == 't') ADVANCE(33);
      END_STATE();
    case 21:
      if (lookahead == 'l') ADVANCE(34);
      END_STATE();
    case 22:
      if (lookahead == 'u') ADVANCE(35);
      END_STATE();
    case 23:
      if (lookahead == 'q') ADVANCE(36);
      END_STATE();
    case 24:
      if (lookahead == 's') ADVANCE(37);
      END_STATE();
    case 25:
      if (lookahead == 'r') ADVANCE(38);
      END_STATE();
    case 26:
      if (lookahead == 'i') ADVANCE(39);
      END_STATE();
    case 27:
      if (lookahead == 'a') ADVANCE(40);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_def);
      if (lookahead == 'm') ADVANCE(41);
      if (lookahead == 'n') ADVANCE(42);
      END_STATE();
    case 29:
      if (lookahead == 's') ADVANCE(43);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(sym_nil_literal);
      END_STATE();
    case 31:
      if (lookahead == 's') ADVANCE(44);
      END_STATE();
    case 32:
      if (lookahead == 't') ADVANCE(45);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 34:
      if (lookahead == 'i') ADVANCE(46);
      END_STATE();
    case 35:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 36:
      if (lookahead == 'u') ADVANCE(48);
      END_STATE();
    case 37:
      if (lookahead == 'c') ADVANCE(49);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_var);
      if (lookahead == 'f') ADVANCE(50);
      END_STATE();
    case 39:
      if (lookahead == 'l') ADVANCE(51);
      END_STATE();
    case 40:
      if (lookahead == 'k') ADVANCE(52);
      END_STATE();
    case 41:
      if (lookahead == 'a') ADVANCE(53);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_defn);
      if (lookahead == '-') ADVANCE(54);
      END_STATE();
    case 43:
      if (lookahead == 'e') ADVANCE(55);
      END_STATE();
    case 44:
      if (lookahead == 'i') ADVANCE(56);
      END_STATE();
    case 45:
      if (lookahead == 'e') ADVANCE(57);
      END_STATE();
    case 46:
      if (lookahead == 'c') ADVANCE(58);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 48:
      if (lookahead == 'o') ADVANCE(59);
      END_STATE();
    case 49:
      if (lookahead == 'o') ADVANCE(60);
      END_STATE();
    case 50:
      if (lookahead == 'n') ADVANCE(61);
      END_STATE();
    case 51:
      if (lookahead == 'e') ADVANCE(62);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 53:
      if (lookahead == 'c') ADVANCE(63);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_defn_DASH);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 56:
      if (lookahead == 'q') ADVANCE(64);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_quote);
      END_STATE();
    case 58:
      if (lookahead == 'e') ADVANCE(65);
      END_STATE();
    case 59:
      if (lookahead == 't') ADVANCE(66);
      END_STATE();
    case 60:
      if (lookahead == 'p') ADVANCE(67);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_varfn);
      if (lookahead == '-') ADVANCE(68);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 63:
      if (lookahead == 'r') ADVANCE(69);
      END_STATE();
    case 64:
      if (lookahead == 'u') ADVANCE(70);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_splice);
      END_STATE();
    case 66:
      if (lookahead == 'e') ADVANCE(71);
      END_STATE();
    case 67:
      if (lookahead == 'e') ADVANCE(72);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_varfn_DASH);
      END_STATE();
    case 69:
      if (lookahead == 'o') ADVANCE(73);
      END_STATE();
    case 70:
      if (lookahead == 'o') ADVANCE(74);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_unquote);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_upscope);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_defmacro);
      if (lookahead == '-') ADVANCE(75);
      END_STATE();
    case 74:
      if (lookahead == 't') ADVANCE(76);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_defmacro_DASH);
      END_STATE();
    case 76:
      if (lookahead == 'e') ADVANCE(77);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_quasiquote);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 22, .external_lex_state = 1},
  [2] = {.lex_state = 22, .external_lex_state = 1},
  [3] = {.lex_state = 22, .external_lex_state = 1},
  [4] = {.lex_state = 22, .external_lex_state = 1},
  [5] = {.lex_state = 22, .external_lex_state = 1},
  [6] = {.lex_state = 22, .external_lex_state = 1},
  [7] = {.lex_state = 22, .external_lex_state = 1},
  [8] = {.lex_state = 1, .external_lex_state = 1},
  [9] = {.lex_state = 1, .external_lex_state = 1},
  [10] = {.lex_state = 1, .external_lex_state = 1},
  [11] = {.lex_state = 1, .external_lex_state = 1},
  [12] = {.lex_state = 1, .external_lex_state = 1},
  [13] = {.lex_state = 22, .external_lex_state = 1},
  [14] = {.lex_state = 22, .external_lex_state = 1},
  [15] = {.lex_state = 22, .external_lex_state = 1},
  [16] = {.lex_state = 22, .external_lex_state = 1},
  [17] = {.lex_state = 22, .external_lex_state = 1},
  [18] = {.lex_state = 22, .external_lex_state = 1},
  [19] = {.lex_state = 22, .external_lex_state = 1},
  [20] = {.lex_state = 22, .external_lex_state = 1},
  [21] = {.lex_state = 22, .external_lex_state = 1},
  [22] = {.lex_state = 22, .external_lex_state = 1},
  [23] = {.lex_state = 22, .external_lex_state = 1},
  [24] = {.lex_state = 22, .external_lex_state = 1},
  [25] = {.lex_state = 22, .external_lex_state = 1},
  [26] = {.lex_state = 22, .external_lex_state = 1},
  [27] = {.lex_state = 22, .external_lex_state = 1},
  [28] = {.lex_state = 22, .external_lex_state = 1},
  [29] = {.lex_state = 22, .external_lex_state = 1},
  [30] = {.lex_state = 22, .external_lex_state = 1},
  [31] = {.lex_state = 22, .external_lex_state = 1},
  [32] = {.lex_state = 22, .external_lex_state = 1},
  [33] = {.lex_state = 22, .external_lex_state = 1},
  [34] = {.lex_state = 22, .external_lex_state = 1},
  [35] = {.lex_state = 22, .external_lex_state = 1},
  [36] = {.lex_state = 22, .external_lex_state = 1},
  [37] = {.lex_state = 22, .external_lex_state = 1},
  [38] = {.lex_state = 22, .external_lex_state = 1},
  [39] = {.lex_state = 22, .external_lex_state = 1},
  [40] = {.lex_state = 22, .external_lex_state = 1},
  [41] = {.lex_state = 22, .external_lex_state = 1},
  [42] = {.lex_state = 22, .external_lex_state = 1},
  [43] = {.lex_state = 22, .external_lex_state = 1},
  [44] = {.lex_state = 22, .external_lex_state = 1},
  [45] = {.lex_state = 22, .external_lex_state = 1},
  [46] = {.lex_state = 22, .external_lex_state = 1},
  [47] = {.lex_state = 22, .external_lex_state = 1},
  [48] = {.lex_state = 22, .external_lex_state = 1},
  [49] = {.lex_state = 22, .external_lex_state = 1},
  [50] = {.lex_state = 22, .external_lex_state = 1},
  [51] = {.lex_state = 22, .external_lex_state = 1},
  [52] = {.lex_state = 22, .external_lex_state = 1},
  [53] = {.lex_state = 22, .external_lex_state = 1},
  [54] = {.lex_state = 22, .external_lex_state = 1},
  [55] = {.lex_state = 22, .external_lex_state = 1},
  [56] = {.lex_state = 22, .external_lex_state = 1},
  [57] = {.lex_state = 22, .external_lex_state = 1},
  [58] = {.lex_state = 22, .external_lex_state = 1},
  [59] = {.lex_state = 22, .external_lex_state = 1},
  [60] = {.lex_state = 22, .external_lex_state = 1},
  [61] = {.lex_state = 22, .external_lex_state = 1},
  [62] = {.lex_state = 22, .external_lex_state = 1},
  [63] = {.lex_state = 22, .external_lex_state = 1},
  [64] = {.lex_state = 22, .external_lex_state = 1},
  [65] = {.lex_state = 22, .external_lex_state = 1},
  [66] = {.lex_state = 22, .external_lex_state = 1},
  [67] = {.lex_state = 22, .external_lex_state = 1},
  [68] = {.lex_state = 22, .external_lex_state = 1},
  [69] = {.lex_state = 22, .external_lex_state = 1},
  [70] = {.lex_state = 22, .external_lex_state = 1},
  [71] = {.lex_state = 22, .external_lex_state = 1},
  [72] = {.lex_state = 22, .external_lex_state = 1},
  [73] = {.lex_state = 22, .external_lex_state = 1},
  [74] = {.lex_state = 22, .external_lex_state = 1},
  [75] = {.lex_state = 22, .external_lex_state = 1},
  [76] = {.lex_state = 22, .external_lex_state = 1},
  [77] = {.lex_state = 22, .external_lex_state = 1},
  [78] = {.lex_state = 22, .external_lex_state = 1},
  [79] = {.lex_state = 22, .external_lex_state = 1},
  [80] = {.lex_state = 22, .external_lex_state = 1},
  [81] = {.lex_state = 22, .external_lex_state = 1},
  [82] = {.lex_state = 22, .external_lex_state = 1},
  [83] = {.lex_state = 22, .external_lex_state = 1},
  [84] = {.lex_state = 22, .external_lex_state = 1},
  [85] = {.lex_state = 22, .external_lex_state = 1},
  [86] = {.lex_state = 22, .external_lex_state = 1},
  [87] = {.lex_state = 22, .external_lex_state = 1},
  [88] = {.lex_state = 22, .external_lex_state = 1},
  [89] = {.lex_state = 22, .external_lex_state = 1},
  [90] = {.lex_state = 22, .external_lex_state = 1},
  [91] = {.lex_state = 22, .external_lex_state = 1},
  [92] = {.lex_state = 22, .external_lex_state = 1},
  [93] = {.lex_state = 22, .external_lex_state = 1},
  [94] = {.lex_state = 22, .external_lex_state = 1},
  [95] = {.lex_state = 22, .external_lex_state = 1},
  [96] = {.lex_state = 22, .external_lex_state = 1},
  [97] = {.lex_state = 22, .external_lex_state = 1},
  [98] = {.lex_state = 22, .external_lex_state = 1},
  [99] = {.lex_state = 22, .external_lex_state = 1},
  [100] = {.lex_state = 22, .external_lex_state = 1},
  [101] = {.lex_state = 22, .external_lex_state = 1},
  [102] = {.lex_state = 22, .external_lex_state = 1},
  [103] = {.lex_state = 22, .external_lex_state = 1},
  [104] = {.lex_state = 22, .external_lex_state = 1},
  [105] = {.lex_state = 22, .external_lex_state = 1},
  [106] = {.lex_state = 22, .external_lex_state = 1},
  [107] = {.lex_state = 22, .external_lex_state = 1},
  [108] = {.lex_state = 22, .external_lex_state = 1},
  [109] = {.lex_state = 22, .external_lex_state = 1},
  [110] = {.lex_state = 22, .external_lex_state = 1},
  [111] = {.lex_state = 22, .external_lex_state = 1},
  [112] = {.lex_state = 22, .external_lex_state = 1},
  [113] = {.lex_state = 22, .external_lex_state = 1},
  [114] = {.lex_state = 22, .external_lex_state = 1},
  [115] = {.lex_state = 22, .external_lex_state = 1},
  [116] = {.lex_state = 22, .external_lex_state = 1},
  [117] = {.lex_state = 22, .external_lex_state = 1},
  [118] = {.lex_state = 22, .external_lex_state = 1},
  [119] = {.lex_state = 22, .external_lex_state = 1},
  [120] = {.lex_state = 22, .external_lex_state = 1},
  [121] = {.lex_state = 22, .external_lex_state = 1},
  [122] = {.lex_state = 22, .external_lex_state = 1},
  [123] = {.lex_state = 22, .external_lex_state = 1},
  [124] = {.lex_state = 22, .external_lex_state = 1},
  [125] = {.lex_state = 22, .external_lex_state = 1},
  [126] = {.lex_state = 22, .external_lex_state = 1},
  [127] = {.lex_state = 22, .external_lex_state = 1},
  [128] = {.lex_state = 22, .external_lex_state = 1},
  [129] = {.lex_state = 22, .external_lex_state = 1},
  [130] = {.lex_state = 22, .external_lex_state = 1},
  [131] = {.lex_state = 22, .external_lex_state = 1},
  [132] = {.lex_state = 22, .external_lex_state = 1},
  [133] = {.lex_state = 22, .external_lex_state = 1},
  [134] = {.lex_state = 22, .external_lex_state = 1},
  [135] = {.lex_state = 22, .external_lex_state = 1},
  [136] = {.lex_state = 22, .external_lex_state = 1},
  [137] = {.lex_state = 22, .external_lex_state = 1},
  [138] = {.lex_state = 22, .external_lex_state = 1},
  [139] = {.lex_state = 22, .external_lex_state = 1},
  [140] = {.lex_state = 22, .external_lex_state = 1},
  [141] = {.lex_state = 22, .external_lex_state = 1},
  [142] = {.lex_state = 22, .external_lex_state = 1},
  [143] = {.lex_state = 22, .external_lex_state = 1},
  [144] = {.lex_state = 22, .external_lex_state = 1},
  [145] = {.lex_state = 22, .external_lex_state = 1},
  [146] = {.lex_state = 22, .external_lex_state = 1},
  [147] = {.lex_state = 22, .external_lex_state = 1},
  [148] = {.lex_state = 22, .external_lex_state = 1},
  [149] = {.lex_state = 22, .external_lex_state = 1},
  [150] = {.lex_state = 22, .external_lex_state = 1},
  [151] = {.lex_state = 22, .external_lex_state = 1},
  [152] = {.lex_state = 22, .external_lex_state = 1},
  [153] = {.lex_state = 22, .external_lex_state = 1},
  [154] = {.lex_state = 22, .external_lex_state = 1},
  [155] = {.lex_state = 22, .external_lex_state = 1},
  [156] = {.lex_state = 22, .external_lex_state = 1},
  [157] = {.lex_state = 22, .external_lex_state = 1},
  [158] = {.lex_state = 22, .external_lex_state = 1},
  [159] = {.lex_state = 22, .external_lex_state = 1},
  [160] = {.lex_state = 22, .external_lex_state = 1},
  [161] = {.lex_state = 22, .external_lex_state = 1},
  [162] = {.lex_state = 22, .external_lex_state = 1},
  [163] = {.lex_state = 22, .external_lex_state = 1},
  [164] = {.lex_state = 22, .external_lex_state = 1},
  [165] = {.lex_state = 22, .external_lex_state = 1},
  [166] = {.lex_state = 22, .external_lex_state = 1},
  [167] = {.lex_state = 22, .external_lex_state = 1},
  [168] = {.lex_state = 22, .external_lex_state = 1},
  [169] = {.lex_state = 22, .external_lex_state = 1},
  [170] = {.lex_state = 22, .external_lex_state = 1},
  [171] = {.lex_state = 22, .external_lex_state = 1},
  [172] = {.lex_state = 22, .external_lex_state = 1},
  [173] = {.lex_state = 22, .external_lex_state = 1},
  [174] = {.lex_state = 22, .external_lex_state = 1},
  [175] = {.lex_state = 22, .external_lex_state = 1},
  [176] = {.lex_state = 22, .external_lex_state = 1},
  [177] = {.lex_state = 22, .external_lex_state = 1},
  [178] = {.lex_state = 22, .external_lex_state = 1},
  [179] = {.lex_state = 22, .external_lex_state = 1},
  [180] = {.lex_state = 22, .external_lex_state = 1},
  [181] = {.lex_state = 22, .external_lex_state = 1},
  [182] = {.lex_state = 22, .external_lex_state = 1},
  [183] = {.lex_state = 22, .external_lex_state = 1},
  [184] = {.lex_state = 22, .external_lex_state = 1},
  [185] = {.lex_state = 22, .external_lex_state = 1},
  [186] = {.lex_state = 22, .external_lex_state = 1},
  [187] = {.lex_state = 22, .external_lex_state = 1},
  [188] = {.lex_state = 22, .external_lex_state = 1},
  [189] = {.lex_state = 22, .external_lex_state = 1},
  [190] = {.lex_state = 22, .external_lex_state = 1},
  [191] = {.lex_state = 22, .external_lex_state = 1},
  [192] = {.lex_state = 22, .external_lex_state = 1},
  [193] = {.lex_state = 22, .external_lex_state = 1},
  [194] = {.lex_state = 22, .external_lex_state = 1},
  [195] = {.lex_state = 22, .external_lex_state = 1},
  [196] = {.lex_state = 22, .external_lex_state = 1},
  [197] = {.lex_state = 22, .external_lex_state = 1},
  [198] = {.lex_state = 22, .external_lex_state = 1},
  [199] = {.lex_state = 22, .external_lex_state = 1},
  [200] = {.lex_state = 22, .external_lex_state = 1},
  [201] = {.lex_state = 22, .external_lex_state = 1},
  [202] = {.lex_state = 22, .external_lex_state = 1},
  [203] = {.lex_state = 22, .external_lex_state = 1},
  [204] = {.lex_state = 22, .external_lex_state = 1},
  [205] = {.lex_state = 22, .external_lex_state = 1},
  [206] = {.lex_state = 22, .external_lex_state = 1},
  [207] = {.lex_state = 22, .external_lex_state = 1},
  [208] = {.lex_state = 22, .external_lex_state = 1},
  [209] = {.lex_state = 22, .external_lex_state = 1},
  [210] = {.lex_state = 22, .external_lex_state = 1},
  [211] = {.lex_state = 22, .external_lex_state = 1},
  [212] = {.lex_state = 22, .external_lex_state = 1},
  [213] = {.lex_state = 22, .external_lex_state = 1},
  [214] = {.lex_state = 22, .external_lex_state = 1},
  [215] = {.lex_state = 22, .external_lex_state = 1},
  [216] = {.lex_state = 22, .external_lex_state = 1},
  [217] = {.lex_state = 22, .external_lex_state = 1},
  [218] = {.lex_state = 22, .external_lex_state = 1},
  [219] = {.lex_state = 22, .external_lex_state = 1},
  [220] = {.lex_state = 22, .external_lex_state = 1},
  [221] = {.lex_state = 22, .external_lex_state = 1},
  [222] = {.lex_state = 22, .external_lex_state = 1},
  [223] = {.lex_state = 22, .external_lex_state = 1},
  [224] = {.lex_state = 22, .external_lex_state = 1},
  [225] = {.lex_state = 22, .external_lex_state = 1},
  [226] = {.lex_state = 22, .external_lex_state = 1},
  [227] = {.lex_state = 22, .external_lex_state = 1},
  [228] = {.lex_state = 22, .external_lex_state = 1},
  [229] = {.lex_state = 22, .external_lex_state = 1},
  [230] = {.lex_state = 22, .external_lex_state = 1},
  [231] = {.lex_state = 22, .external_lex_state = 1},
  [232] = {.lex_state = 22, .external_lex_state = 1},
  [233] = {.lex_state = 22, .external_lex_state = 1},
  [234] = {.lex_state = 22, .external_lex_state = 1},
  [235] = {.lex_state = 1, .external_lex_state = 1},
  [236] = {.lex_state = 1, .external_lex_state = 1},
  [237] = {.lex_state = 1, .external_lex_state = 1},
  [238] = {.lex_state = 1, .external_lex_state = 1},
  [239] = {.lex_state = 1, .external_lex_state = 1},
  [240] = {.lex_state = 1, .external_lex_state = 1},
  [241] = {.lex_state = 1, .external_lex_state = 1},
  [242] = {.lex_state = 1, .external_lex_state = 1},
  [243] = {.lex_state = 1, .external_lex_state = 1},
  [244] = {.lex_state = 1, .external_lex_state = 1},
  [245] = {.lex_state = 1, .external_lex_state = 1},
  [246] = {.lex_state = 1, .external_lex_state = 1},
  [247] = {.lex_state = 1, .external_lex_state = 1},
  [248] = {.lex_state = 1, .external_lex_state = 1},
  [249] = {.lex_state = 1, .external_lex_state = 1},
  [250] = {.lex_state = 1, .external_lex_state = 1},
  [251] = {.lex_state = 1, .external_lex_state = 1},
  [252] = {.lex_state = 1, .external_lex_state = 1},
  [253] = {.lex_state = 1, .external_lex_state = 1},
  [254] = {.lex_state = 1, .external_lex_state = 1},
  [255] = {.lex_state = 1, .external_lex_state = 1},
  [256] = {.lex_state = 1, .external_lex_state = 1},
  [257] = {.lex_state = 1, .external_lex_state = 1},
  [258] = {.lex_state = 1, .external_lex_state = 1},
  [259] = {.lex_state = 1, .external_lex_state = 1},
  [260] = {.lex_state = 1, .external_lex_state = 1},
  [261] = {.lex_state = 1, .external_lex_state = 1},
  [262] = {.lex_state = 1, .external_lex_state = 1},
  [263] = {.lex_state = 1, .external_lex_state = 1},
  [264] = {.lex_state = 1, .external_lex_state = 1},
  [265] = {.lex_state = 1, .external_lex_state = 1},
  [266] = {.lex_state = 1, .external_lex_state = 1},
  [267] = {.lex_state = 1, .external_lex_state = 1},
  [268] = {.lex_state = 1, .external_lex_state = 1},
  [269] = {.lex_state = 1, .external_lex_state = 1},
  [270] = {.lex_state = 1, .external_lex_state = 1},
  [271] = {.lex_state = 1, .external_lex_state = 1},
  [272] = {.lex_state = 1, .external_lex_state = 1},
  [273] = {.lex_state = 1, .external_lex_state = 1},
  [274] = {.lex_state = 1, .external_lex_state = 1},
  [275] = {.lex_state = 1, .external_lex_state = 1},
  [276] = {.lex_state = 1, .external_lex_state = 1},
  [277] = {.lex_state = 1, .external_lex_state = 1},
  [278] = {.lex_state = 1, .external_lex_state = 1},
  [279] = {.lex_state = 1, .external_lex_state = 1},
  [280] = {.lex_state = 1, .external_lex_state = 1},
  [281] = {.lex_state = 1, .external_lex_state = 1},
  [282] = {.lex_state = 1, .external_lex_state = 1},
  [283] = {.lex_state = 1, .external_lex_state = 1},
  [284] = {.lex_state = 1, .external_lex_state = 1},
  [285] = {.lex_state = 1, .external_lex_state = 1},
  [286] = {.lex_state = 1, .external_lex_state = 1},
  [287] = {.lex_state = 1, .external_lex_state = 1},
  [288] = {.lex_state = 1, .external_lex_state = 1},
  [289] = {.lex_state = 1, .external_lex_state = 1},
  [290] = {.lex_state = 1, .external_lex_state = 1},
  [291] = {.lex_state = 1, .external_lex_state = 1},
  [292] = {.lex_state = 1, .external_lex_state = 1},
  [293] = {.lex_state = 1, .external_lex_state = 1},
  [294] = {.lex_state = 1, .external_lex_state = 1},
  [295] = {.lex_state = 2, .external_lex_state = 2},
  [296] = {.lex_state = 2, .external_lex_state = 2},
  [297] = {.lex_state = 2, .external_lex_state = 2},
  [298] = {.lex_state = 2, .external_lex_state = 2},
  [299] = {.lex_state = 2, .external_lex_state = 2},
  [300] = {.lex_state = 2, .external_lex_state = 2},
  [301] = {.lex_state = 2, .external_lex_state = 2},
  [302] = {.lex_state = 2, .external_lex_state = 2},
  [303] = {.lex_state = 2, .external_lex_state = 2},
  [304] = {.lex_state = 2, .external_lex_state = 2},
  [305] = {.lex_state = 22, .external_lex_state = 1},
  [306] = {.lex_state = 22, .external_lex_state = 1},
  [307] = {.lex_state = 22, .external_lex_state = 1},
  [308] = {.lex_state = 22, .external_lex_state = 1},
  [309] = {.lex_state = 22, .external_lex_state = 1},
  [310] = {.lex_state = 22, .external_lex_state = 1},
  [311] = {.lex_state = 22, .external_lex_state = 1},
  [312] = {.lex_state = 22, .external_lex_state = 1},
  [313] = {.lex_state = 22, .external_lex_state = 1},
  [314] = {.lex_state = 22, .external_lex_state = 1},
  [315] = {.lex_state = 22, .external_lex_state = 1},
  [316] = {.lex_state = 22, .external_lex_state = 1},
  [317] = {.lex_state = 22, .external_lex_state = 1},
  [318] = {.lex_state = 22, .external_lex_state = 1},
  [319] = {.lex_state = 22, .external_lex_state = 1},
  [320] = {.lex_state = 22, .external_lex_state = 1},
  [321] = {.lex_state = 22, .external_lex_state = 1},
  [322] = {.lex_state = 22, .external_lex_state = 1},
  [323] = {.lex_state = 22, .external_lex_state = 1},
  [324] = {.lex_state = 22, .external_lex_state = 1},
  [325] = {.lex_state = 22, .external_lex_state = 1},
  [326] = {.lex_state = 22, .external_lex_state = 1},
  [327] = {.lex_state = 22, .external_lex_state = 1},
  [328] = {.lex_state = 22, .external_lex_state = 1},
  [329] = {.lex_state = 22, .external_lex_state = 1},
  [330] = {.lex_state = 22, .external_lex_state = 1},
  [331] = {.lex_state = 22, .external_lex_state = 1},
  [332] = {.lex_state = 22, .external_lex_state = 1},
  [333] = {.lex_state = 22, .external_lex_state = 1},
  [334] = {.lex_state = 22, .external_lex_state = 1},
  [335] = {.lex_state = 22, .external_lex_state = 1},
  [336] = {.lex_state = 22, .external_lex_state = 1},
  [337] = {.lex_state = 22, .external_lex_state = 1},
  [338] = {.lex_state = 22, .external_lex_state = 1},
  [339] = {.lex_state = 22, .external_lex_state = 1},
  [340] = {.lex_state = 22, .external_lex_state = 1},
  [341] = {.lex_state = 22, .external_lex_state = 1},
  [342] = {.lex_state = 22, .external_lex_state = 1},
  [343] = {.lex_state = 22, .external_lex_state = 1},
  [344] = {.lex_state = 22, .external_lex_state = 1},
  [345] = {.lex_state = 22, .external_lex_state = 1},
  [346] = {.lex_state = 22, .external_lex_state = 1},
  [347] = {.lex_state = 22, .external_lex_state = 1},
  [348] = {.lex_state = 22, .external_lex_state = 1},
  [349] = {.lex_state = 22, .external_lex_state = 1},
  [350] = {.lex_state = 22, .external_lex_state = 1},
  [351] = {.lex_state = 22, .external_lex_state = 1},
  [352] = {.lex_state = 22, .external_lex_state = 1},
  [353] = {.lex_state = 22, .external_lex_state = 1},
  [354] = {.lex_state = 22, .external_lex_state = 1},
  [355] = {.lex_state = 22, .external_lex_state = 1},
  [356] = {.lex_state = 22, .external_lex_state = 1},
  [357] = {.lex_state = 22, .external_lex_state = 1},
  [358] = {.lex_state = 22, .external_lex_state = 1},
  [359] = {.lex_state = 22, .external_lex_state = 1},
  [360] = {.lex_state = 22, .external_lex_state = 1},
  [361] = {.lex_state = 22, .external_lex_state = 1},
  [362] = {.lex_state = 22, .external_lex_state = 1},
  [363] = {.lex_state = 22, .external_lex_state = 1},
  [364] = {.lex_state = 22, .external_lex_state = 1},
  [365] = {.lex_state = 22, .external_lex_state = 1},
  [366] = {.lex_state = 22, .external_lex_state = 1},
  [367] = {.lex_state = 22, .external_lex_state = 1},
  [368] = {.lex_state = 22, .external_lex_state = 1},
  [369] = {.lex_state = 22, .external_lex_state = 1},
  [370] = {.lex_state = 22, .external_lex_state = 1},
  [371] = {.lex_state = 22, .external_lex_state = 1},
  [372] = {.lex_state = 22, .external_lex_state = 1},
  [373] = {.lex_state = 22, .external_lex_state = 1},
  [374] = {.lex_state = 22, .external_lex_state = 1},
  [375] = {.lex_state = 22, .external_lex_state = 1},
  [376] = {.lex_state = 22, .external_lex_state = 1},
  [377] = {.lex_state = 22, .external_lex_state = 1},
  [378] = {.lex_state = 22, .external_lex_state = 1},
  [379] = {.lex_state = 22, .external_lex_state = 1},
  [380] = {.lex_state = 22, .external_lex_state = 1},
  [381] = {.lex_state = 22, .external_lex_state = 1},
  [382] = {.lex_state = 22, .external_lex_state = 1},
  [383] = {.lex_state = 22, .external_lex_state = 1},
  [384] = {.lex_state = 22, .external_lex_state = 1},
  [385] = {.lex_state = 22, .external_lex_state = 1},
  [386] = {.lex_state = 22, .external_lex_state = 1},
  [387] = {.lex_state = 22, .external_lex_state = 1},
  [388] = {.lex_state = 22, .external_lex_state = 1},
  [389] = {.lex_state = 22, .external_lex_state = 1},
  [390] = {.lex_state = 22, .external_lex_state = 1},
  [391] = {.lex_state = 22, .external_lex_state = 1},
  [392] = {.lex_state = 22, .external_lex_state = 1},
  [393] = {.lex_state = 22, .external_lex_state = 1},
  [394] = {.lex_state = 22, .external_lex_state = 1},
  [395] = {.lex_state = 22, .external_lex_state = 1},
  [396] = {.lex_state = 22, .external_lex_state = 1},
  [397] = {.lex_state = 22, .external_lex_state = 1},
  [398] = {.lex_state = 22, .external_lex_state = 1},
  [399] = {.lex_state = 22, .external_lex_state = 1},
  [400] = {.lex_state = 22, .external_lex_state = 1},
  [401] = {.lex_state = 22, .external_lex_state = 1},
  [402] = {.lex_state = 22, .external_lex_state = 1},
  [403] = {.lex_state = 22, .external_lex_state = 1},
  [404] = {.lex_state = 22, .external_lex_state = 1},
  [405] = {.lex_state = 22, .external_lex_state = 1},
  [406] = {.lex_state = 22, .external_lex_state = 1},
  [407] = {.lex_state = 22, .external_lex_state = 1},
  [408] = {.lex_state = 22, .external_lex_state = 1},
  [409] = {.lex_state = 22, .external_lex_state = 1},
  [410] = {.lex_state = 22, .external_lex_state = 1},
  [411] = {.lex_state = 22, .external_lex_state = 1},
  [412] = {.lex_state = 22, .external_lex_state = 1},
  [413] = {.lex_state = 22, .external_lex_state = 1},
  [414] = {.lex_state = 22, .external_lex_state = 1},
  [415] = {.lex_state = 22, .external_lex_state = 1},
  [416] = {.lex_state = 22, .external_lex_state = 1},
  [417] = {.lex_state = 22, .external_lex_state = 1},
  [418] = {.lex_state = 22, .external_lex_state = 1},
  [419] = {.lex_state = 22, .external_lex_state = 1},
  [420] = {.lex_state = 22, .external_lex_state = 1},
  [421] = {.lex_state = 22, .external_lex_state = 1},
  [422] = {.lex_state = 22, .external_lex_state = 1},
  [423] = {.lex_state = 22, .external_lex_state = 1},
  [424] = {.lex_state = 22, .external_lex_state = 1},
  [425] = {.lex_state = 22, .external_lex_state = 1},
  [426] = {.lex_state = 22, .external_lex_state = 1},
  [427] = {.lex_state = 22, .external_lex_state = 1},
  [428] = {.lex_state = 22, .external_lex_state = 1},
  [429] = {.lex_state = 22, .external_lex_state = 1},
  [430] = {.lex_state = 22, .external_lex_state = 1},
  [431] = {.lex_state = 22, .external_lex_state = 1},
  [432] = {.lex_state = 22, .external_lex_state = 1},
  [433] = {.lex_state = 22, .external_lex_state = 1},
  [434] = {.lex_state = 22, .external_lex_state = 1},
  [435] = {.lex_state = 22, .external_lex_state = 1},
  [436] = {.lex_state = 22, .external_lex_state = 1},
  [437] = {.lex_state = 22, .external_lex_state = 1},
  [438] = {.lex_state = 22, .external_lex_state = 1},
  [439] = {.lex_state = 22, .external_lex_state = 1},
  [440] = {.lex_state = 22, .external_lex_state = 1},
  [441] = {.lex_state = 22, .external_lex_state = 1},
  [442] = {.lex_state = 22, .external_lex_state = 1},
  [443] = {.lex_state = 22, .external_lex_state = 1},
  [444] = {.lex_state = 22, .external_lex_state = 1},
  [445] = {.lex_state = 22, .external_lex_state = 1},
  [446] = {.lex_state = 22, .external_lex_state = 1},
  [447] = {.lex_state = 22, .external_lex_state = 1},
  [448] = {.lex_state = 22, .external_lex_state = 1},
  [449] = {.lex_state = 22, .external_lex_state = 1},
  [450] = {.lex_state = 22, .external_lex_state = 1},
  [451] = {.lex_state = 22, .external_lex_state = 1},
  [452] = {.lex_state = 22, .external_lex_state = 1},
  [453] = {.lex_state = 22, .external_lex_state = 1},
  [454] = {.lex_state = 22, .external_lex_state = 1},
  [455] = {.lex_state = 22, .external_lex_state = 1},
  [456] = {.lex_state = 22, .external_lex_state = 1},
  [457] = {.lex_state = 22, .external_lex_state = 1},
  [458] = {.lex_state = 22, .external_lex_state = 1},
  [459] = {.lex_state = 22, .external_lex_state = 1},
  [460] = {.lex_state = 2, .external_lex_state = 2},
  [461] = {.lex_state = 22, .external_lex_state = 1},
  [462] = {.lex_state = 2},
  [463] = {.lex_state = 2},
  [464] = {.lex_state = 2},
  [465] = {.lex_state = 2},
  [466] = {.lex_state = 2},
  [467] = {.lex_state = 2},
  [468] = {.lex_state = 2},
  [469] = {.lex_state = 2},
  [470] = {.lex_state = 2},
  [471] = {.lex_state = 2},
  [472] = {.lex_state = 2},
  [473] = {.lex_state = 2},
  [474] = {.lex_state = 2},
  [475] = {.lex_state = 2},
  [476] = {.lex_state = 2},
  [477] = {.lex_state = 2, .external_lex_state = 2},
  [478] = {.lex_state = 2, .external_lex_state = 2},
  [479] = {.lex_state = 2, .external_lex_state = 2},
  [480] = {.lex_state = 2, .external_lex_state = 2},
  [481] = {.lex_state = 2, .external_lex_state = 2},
  [482] = {.lex_state = 2, .external_lex_state = 2},
  [483] = {.lex_state = 2, .external_lex_state = 2},
  [484] = {.lex_state = 2, .external_lex_state = 2},
  [485] = {.lex_state = 2, .external_lex_state = 2},
  [486] = {.lex_state = 2, .external_lex_state = 2},
  [487] = {.lex_state = 2, .external_lex_state = 2},
  [488] = {.lex_state = 2, .external_lex_state = 2},
  [489] = {.lex_state = 2, .external_lex_state = 2},
  [490] = {.lex_state = 2, .external_lex_state = 2},
  [491] = {.lex_state = 2, .external_lex_state = 2},
  [492] = {.lex_state = 2, .external_lex_state = 2},
  [493] = {.lex_state = 2, .external_lex_state = 2},
  [494] = {.lex_state = 2, .external_lex_state = 2},
  [495] = {.lex_state = 2, .external_lex_state = 2},
  [496] = {.lex_state = 2, .external_lex_state = 2},
  [497] = {.lex_state = 2, .external_lex_state = 2},
  [498] = {.lex_state = 2, .external_lex_state = 2},
  [499] = {.lex_state = 2, .external_lex_state = 2},
  [500] = {.lex_state = 2, .external_lex_state = 2},
  [501] = {.lex_state = 2, .external_lex_state = 2},
  [502] = {.lex_state = 2, .external_lex_state = 2},
  [503] = {.lex_state = 2, .external_lex_state = 2},
  [504] = {.lex_state = 2, .external_lex_state = 2},
  [505] = {.lex_state = 2, .external_lex_state = 2},
  [506] = {.lex_state = 2, .external_lex_state = 2},
  [507] = {.lex_state = 2, .external_lex_state = 2},
  [508] = {.lex_state = 2, .external_lex_state = 2},
  [509] = {.lex_state = 2, .external_lex_state = 2},
  [510] = {.lex_state = 2, .external_lex_state = 2},
  [511] = {.lex_state = 2, .external_lex_state = 2},
  [512] = {.lex_state = 2, .external_lex_state = 2},
  [513] = {.lex_state = 2, .external_lex_state = 2},
  [514] = {.lex_state = 2, .external_lex_state = 2},
  [515] = {.lex_state = 2, .external_lex_state = 2},
  [516] = {.lex_state = 2, .external_lex_state = 2},
  [517] = {.lex_state = 2, .external_lex_state = 2},
  [518] = {.lex_state = 2, .external_lex_state = 2},
  [519] = {.lex_state = 2, .external_lex_state = 2},
  [520] = {.lex_state = 2, .external_lex_state = 2},
  [521] = {.lex_state = 2, .external_lex_state = 2},
  [522] = {.lex_state = 2, .external_lex_state = 2},
  [523] = {.lex_state = 2, .external_lex_state = 2},
  [524] = {.lex_state = 2, .external_lex_state = 2},
  [525] = {.lex_state = 2, .external_lex_state = 2},
  [526] = {.lex_state = 2, .external_lex_state = 2},
  [527] = {.lex_state = 2, .external_lex_state = 2},
  [528] = {.lex_state = 2, .external_lex_state = 2},
  [529] = {.lex_state = 2, .external_lex_state = 2},
  [530] = {.lex_state = 2, .external_lex_state = 2},
  [531] = {.lex_state = 2, .external_lex_state = 2},
  [532] = {.lex_state = 2, .external_lex_state = 2},
  [533] = {.lex_state = 2, .external_lex_state = 2},
  [534] = {.lex_state = 2, .external_lex_state = 2},
  [535] = {.lex_state = 2, .external_lex_state = 2},
  [536] = {.lex_state = 2, .external_lex_state = 2},
  [537] = {.lex_state = 2, .external_lex_state = 2},
  [538] = {.lex_state = 2},
  [539] = {.lex_state = 2},
  [540] = {.lex_state = 0},
  [541] = {.lex_state = 0},
  [542] = {.lex_state = 0},
  [543] = {.lex_state = 0},
  [544] = {.lex_state = 0},
  [545] = {.lex_state = 0},
  [546] = {.lex_state = 0},
  [547] = {.lex_state = 0},
  [548] = {.lex_state = 0},
  [549] = {.lex_state = 0},
  [550] = {.lex_state = 0},
  [551] = {.lex_state = 0},
  [552] = {.lex_state = 0},
  [553] = {.lex_state = 0},
  [554] = {.lex_state = 0},
  [555] = {.lex_state = 0},
  [556] = {.lex_state = 0},
  [557] = {.lex_state = 0},
  [558] = {.lex_state = 0},
  [559] = {.lex_state = 0},
  [560] = {.lex_state = 0},
  [561] = {.lex_state = 0},
  [562] = {.lex_state = 0},
  [563] = {.lex_state = 0},
  [564] = {.lex_state = 0},
  [565] = {.lex_state = 0},
  [566] = {.lex_state = 0},
  [567] = {.lex_state = 0},
  [568] = {.lex_state = 0},
  [569] = {.lex_state = 0},
  [570] = {.lex_state = 0},
  [571] = {.lex_state = 0},
  [572] = {.lex_state = 0},
  [573] = {.lex_state = 0},
  [574] = {.lex_state = 0},
  [575] = {.lex_state = 0},
  [576] = {.lex_state = 0},
  [577] = {.lex_state = 0},
  [578] = {.lex_state = 0},
  [579] = {.lex_state = 0},
  [580] = {.lex_state = 0},
  [581] = {.lex_state = 0},
  [582] = {.lex_state = 0},
  [583] = {.lex_state = 0},
  [584] = {.lex_state = 0},
  [585] = {.lex_state = 0},
  [586] = {.lex_state = 0},
  [587] = {.lex_state = 0},
  [588] = {.lex_state = 0},
  [589] = {.lex_state = 0},
  [590] = {.lex_state = 0},
  [591] = {.lex_state = 0},
  [592] = {.lex_state = 0},
  [593] = {.lex_state = 0},
  [594] = {.lex_state = 0},
  [595] = {.lex_state = 0},
  [596] = {.lex_state = 0},
  [597] = {.lex_state = 0},
  [598] = {.lex_state = 0},
  [599] = {.lex_state = 0},
  [600] = {.lex_state = 0},
  [601] = {.lex_state = 0},
  [602] = {.lex_state = 0},
  [603] = {.lex_state = 0},
  [604] = {.lex_state = 0},
  [605] = {.lex_state = 0},
  [606] = {.lex_state = 0},
  [607] = {.lex_state = 0},
  [608] = {.lex_state = 0},
  [609] = {.lex_state = 0},
  [610] = {.lex_state = 0},
  [611] = {.lex_state = 0},
  [612] = {.lex_state = 0},
  [613] = {.lex_state = 0},
  [614] = {.lex_state = 0},
  [615] = {.lex_state = 0},
  [616] = {.lex_state = 0},
  [617] = {.lex_state = 0},
  [618] = {.lex_state = 0},
  [619] = {.lex_state = 0},
  [620] = {.lex_state = 0},
  [621] = {.lex_state = 0},
  [622] = {.lex_state = 0},
  [623] = {.lex_state = 0},
  [624] = {.lex_state = 0},
  [625] = {.lex_state = 0},
  [626] = {.lex_state = 0},
  [627] = {.lex_state = 0},
  [628] = {.lex_state = 0},
  [629] = {.lex_state = 0},
  [630] = {.lex_state = 0},
  [631] = {.lex_state = 0},
  [632] = {.lex_state = 0},
  [633] = {.lex_state = 0},
  [634] = {.lex_state = 0},
  [635] = {.lex_state = 0},
  [636] = {.lex_state = 0},
  [637] = {.lex_state = 0},
  [638] = {.lex_state = 0},
  [639] = {.lex_state = 0},
  [640] = {.lex_state = 0},
  [641] = {.lex_state = 0},
  [642] = {.lex_state = 0},
  [643] = {.lex_state = 0},
  [644] = {.lex_state = 0},
  [645] = {.lex_state = 0},
  [646] = {.lex_state = 0},
  [647] = {.lex_state = 0},
  [648] = {.lex_state = 0},
  [649] = {.lex_state = 0},
  [650] = {.lex_state = 0},
  [651] = {.lex_state = 0},
  [652] = {.lex_state = 0},
  [653] = {.lex_state = 0},
  [654] = {.lex_state = 0},
  [655] = {.lex_state = 0},
  [656] = {.lex_state = 0},
  [657] = {.lex_state = 0},
  [658] = {.lex_state = 0},
  [659] = {.lex_state = 0},
  [660] = {.lex_state = 0},
  [661] = {.lex_state = 0},
  [662] = {.lex_state = 0},
  [663] = {.lex_state = 0},
  [664] = {.lex_state = 0},
  [665] = {.lex_state = 0},
  [666] = {.lex_state = 0},
  [667] = {.lex_state = 0},
  [668] = {.lex_state = 0},
  [669] = {.lex_state = 0},
  [670] = {.lex_state = 0},
  [671] = {.lex_state = 0},
  [672] = {.lex_state = 0},
  [673] = {.lex_state = 0},
  [674] = {.lex_state = 0},
  [675] = {.lex_state = 0},
  [676] = {.lex_state = 0},
  [677] = {.lex_state = 0},
  [678] = {.lex_state = 0},
  [679] = {.lex_state = 0},
  [680] = {.lex_state = 0},
  [681] = {.lex_state = 0},
  [682] = {.lex_state = 0},
  [683] = {.lex_state = 0},
  [684] = {.lex_state = 0},
};

enum {
  ts_external_token__long_str = 0,
  ts_external_token__long_buffer = 1,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__long_str] = sym__long_str,
  [ts_external_token__long_buffer] = sym__long_buffer,
};

static bool ts_external_scanner_states[3][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__long_str] = true,
    [ts_external_token__long_buffer] = true,
  },
  [2] = {
    [ts_external_token__long_str] = true,
  },
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_symbol] = ACTIONS(1),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_AT_LPAREN] = ACTIONS(1),
    [anon_sym_AT_LBRACK] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_AT_LBRACE] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_def] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_quote] = ACTIONS(1),
    [anon_sym_splice] = ACTIONS(1),
    [anon_sym_quasiquote] = ACTIONS(1),
    [anon_sym_unquote] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_fn] = ACTIONS(1),
    [anon_sym_upscope] = ACTIONS(1),
    [sym_variadic_marker] = ACTIONS(1),
    [sym_optional_marker] = ACTIONS(1),
    [sym_keys_marker] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_defn] = ACTIONS(1),
    [anon_sym_defn_DASH] = ACTIONS(1),
    [anon_sym_varfn] = ACTIONS(1),
    [anon_sym_varfn_DASH] = ACTIONS(1),
    [anon_sym_defmacro] = ACTIONS(1),
    [anon_sym_defmacro_DASH] = ACTIONS(1),
    [sym_str_literal] = ACTIONS(1),
    [sym_buffer_literal] = ACTIONS(1),
    [aux_sym_number_literal_token1] = ACTIONS(1),
    [aux_sym_number_literal_token2] = ACTIONS(1),
    [aux_sym_number_literal_token3] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [sym_nil_literal] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_keyword] = ACTIONS(1),
    [sym__long_str] = ACTIONS(1),
    [sym__long_buffer] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(677),
    [sym__expr] = STATE(138),
    [sym_tuple] = STATE(414),
    [sym_sqr_tuple] = STATE(414),
    [sym_array] = STATE(414),
    [sym_sqr_array] = STATE(414),
    [sym_struct] = STATE(414),
    [sym_table] = STATE(414),
    [sym_peg_set] = STATE(414),
    [sym__special_forms] = STATE(414),
    [sym_def] = STATE(435),
    [sym_var] = STATE(435),
    [sym_quote] = STATE(435),
    [sym_splice] = STATE(435),
    [sym_quasiquote] = STATE(435),
    [sym_unquote] = STATE(435),
    [sym_break] = STATE(435),
    [sym_set] = STATE(435),
    [sym_if] = STATE(435),
    [sym_do] = STATE(435),
    [sym_while] = STATE(435),
    [sym_fn] = STATE(435),
    [sym_upscope] = STATE(435),
    [sym__shorthand] = STATE(414),
    [sym_short_quote] = STATE(436),
    [sym_short_splice] = STATE(436),
    [sym_short_quasiquote] = STATE(436),
    [sym_short_unquote] = STATE(436),
    [sym_short_fn] = STATE(436),
    [sym__specials] = STATE(414),
    [sym_extra_defs] = STATE(438),
    [sym__literals] = STATE(414),
    [sym_long_str_literal] = STATE(398),
    [sym_long_buffer_literal] = STATE(398),
    [sym_number_literal] = STATE(398),
    [sym_bool_literal] = STATE(398),
    [sym__identifier] = STATE(414),
    [aux_sym_source_file_repeat1] = STATE(138),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_symbol] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(31),
    [sym_buffer_literal] = ACTIONS(31),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(37),
    [sym_keyword] = ACTIONS(39),
    [sym__long_str] = ACTIONS(41),
    [sym__long_buffer] = ACTIONS(43),
  },
  [2] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(80),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_def] = ACTIONS(63),
    [anon_sym_var] = ACTIONS(65),
    [anon_sym_quote] = ACTIONS(67),
    [anon_sym_splice] = ACTIONS(69),
    [anon_sym_quasiquote] = ACTIONS(71),
    [anon_sym_unquote] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_fn] = ACTIONS(83),
    [anon_sym_upscope] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_defn] = ACTIONS(97),
    [anon_sym_defn_DASH] = ACTIONS(97),
    [anon_sym_varfn] = ACTIONS(97),
    [anon_sym_varfn_DASH] = ACTIONS(97),
    [anon_sym_defmacro] = ACTIONS(97),
    [anon_sym_defmacro_DASH] = ACTIONS(97),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [3] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(93),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(115),
    [anon_sym_def] = ACTIONS(117),
    [anon_sym_var] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_splice] = ACTIONS(123),
    [anon_sym_quasiquote] = ACTIONS(125),
    [anon_sym_unquote] = ACTIONS(127),
    [anon_sym_break] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_do] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_fn] = ACTIONS(137),
    [anon_sym_upscope] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_defn] = ACTIONS(141),
    [anon_sym_defn_DASH] = ACTIONS(141),
    [anon_sym_varfn] = ACTIONS(141),
    [anon_sym_varfn_DASH] = ACTIONS(141),
    [anon_sym_defmacro] = ACTIONS(141),
    [anon_sym_defmacro_DASH] = ACTIONS(141),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [4] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(124),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(143),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(145),
    [anon_sym_def] = ACTIONS(147),
    [anon_sym_var] = ACTIONS(149),
    [anon_sym_quote] = ACTIONS(151),
    [anon_sym_splice] = ACTIONS(153),
    [anon_sym_quasiquote] = ACTIONS(155),
    [anon_sym_unquote] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_do] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_fn] = ACTIONS(167),
    [anon_sym_upscope] = ACTIONS(169),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_defn] = ACTIONS(171),
    [anon_sym_defn_DASH] = ACTIONS(171),
    [anon_sym_varfn] = ACTIONS(171),
    [anon_sym_varfn_DASH] = ACTIONS(171),
    [anon_sym_defmacro] = ACTIONS(171),
    [anon_sym_defmacro_DASH] = ACTIONS(171),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [5] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(80),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_def] = ACTIONS(63),
    [anon_sym_var] = ACTIONS(65),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_splice] = ACTIONS(123),
    [anon_sym_quasiquote] = ACTIONS(125),
    [anon_sym_unquote] = ACTIONS(127),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_fn] = ACTIONS(83),
    [anon_sym_upscope] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_defn] = ACTIONS(97),
    [anon_sym_defn_DASH] = ACTIONS(97),
    [anon_sym_varfn] = ACTIONS(97),
    [anon_sym_varfn_DASH] = ACTIONS(97),
    [anon_sym_defmacro] = ACTIONS(97),
    [anon_sym_defmacro_DASH] = ACTIONS(97),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [6] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(104),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(175),
    [anon_sym_def] = ACTIONS(177),
    [anon_sym_var] = ACTIONS(179),
    [anon_sym_quote] = ACTIONS(181),
    [anon_sym_splice] = ACTIONS(183),
    [anon_sym_quasiquote] = ACTIONS(185),
    [anon_sym_unquote] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_fn] = ACTIONS(197),
    [anon_sym_upscope] = ACTIONS(199),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_defn] = ACTIONS(201),
    [anon_sym_defn_DASH] = ACTIONS(201),
    [anon_sym_varfn] = ACTIONS(201),
    [anon_sym_varfn_DASH] = ACTIONS(201),
    [anon_sym_defmacro] = ACTIONS(201),
    [anon_sym_defmacro_DASH] = ACTIONS(201),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [7] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(114),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(205),
    [anon_sym_def] = ACTIONS(207),
    [anon_sym_var] = ACTIONS(209),
    [anon_sym_quote] = ACTIONS(211),
    [anon_sym_splice] = ACTIONS(213),
    [anon_sym_quasiquote] = ACTIONS(215),
    [anon_sym_unquote] = ACTIONS(217),
    [anon_sym_break] = ACTIONS(219),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_do] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_fn] = ACTIONS(227),
    [anon_sym_upscope] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_defn] = ACTIONS(231),
    [anon_sym_defn_DASH] = ACTIONS(231),
    [anon_sym_varfn] = ACTIONS(231),
    [anon_sym_varfn_DASH] = ACTIONS(231),
    [anon_sym_defmacro] = ACTIONS(231),
    [anon_sym_defmacro_DASH] = ACTIONS(231),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [8] = {
    [sym__expr] = STATE(248),
    [sym_tuple] = STATE(235),
    [sym_sqr_tuple] = STATE(235),
    [sym_array] = STATE(235),
    [sym_sqr_array] = STATE(235),
    [sym_struct] = STATE(235),
    [sym_table] = STATE(235),
    [sym_peg_set] = STATE(235),
    [sym__special_forms] = STATE(235),
    [sym_def] = STATE(279),
    [sym_var] = STATE(279),
    [sym_quote] = STATE(279),
    [sym_splice] = STATE(279),
    [sym_quasiquote] = STATE(279),
    [sym_unquote] = STATE(279),
    [sym_break] = STATE(279),
    [sym_set] = STATE(279),
    [sym_if] = STATE(279),
    [sym_do] = STATE(279),
    [sym_while] = STATE(279),
    [sym_fn] = STATE(279),
    [sym_upscope] = STATE(279),
    [sym__shorthand] = STATE(235),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(235),
    [sym_extra_defs] = STATE(277),
    [sym__literals] = STATE(235),
    [sym_long_str_literal] = STATE(283),
    [sym_long_buffer_literal] = STATE(283),
    [sym_number_literal] = STATE(283),
    [sym_bool_literal] = STATE(283),
    [sym__identifier] = STATE(235),
    [aux_sym_parameters_repeat1] = STATE(11),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_RPAREN] = ACTIONS(237),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_splice] = ACTIONS(123),
    [anon_sym_quasiquote] = ACTIONS(125),
    [anon_sym_unquote] = ACTIONS(127),
    [sym_variadic_marker] = ACTIONS(249),
    [sym_optional_marker] = ACTIONS(249),
    [sym_keys_marker] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [9] = {
    [sym__expr] = STATE(248),
    [sym_tuple] = STATE(235),
    [sym_sqr_tuple] = STATE(235),
    [sym_array] = STATE(235),
    [sym_sqr_array] = STATE(235),
    [sym_struct] = STATE(235),
    [sym_table] = STATE(235),
    [sym_peg_set] = STATE(235),
    [sym__special_forms] = STATE(235),
    [sym_def] = STATE(279),
    [sym_var] = STATE(279),
    [sym_quote] = STATE(279),
    [sym_splice] = STATE(279),
    [sym_quasiquote] = STATE(279),
    [sym_unquote] = STATE(279),
    [sym_break] = STATE(279),
    [sym_set] = STATE(279),
    [sym_if] = STATE(279),
    [sym_do] = STATE(279),
    [sym_while] = STATE(279),
    [sym_fn] = STATE(279),
    [sym_upscope] = STATE(279),
    [sym__shorthand] = STATE(235),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(235),
    [sym_extra_defs] = STATE(277),
    [sym__literals] = STATE(235),
    [sym_long_str_literal] = STATE(283),
    [sym_long_buffer_literal] = STATE(283),
    [sym_number_literal] = STATE(283),
    [sym_bool_literal] = STATE(283),
    [sym__identifier] = STATE(235),
    [aux_sym_parameters_repeat1] = STATE(9),
    [sym_symbol] = ACTIONS(275),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(278),
    [anon_sym_RPAREN] = ACTIONS(281),
    [anon_sym_LBRACK] = ACTIONS(283),
    [anon_sym_RBRACK] = ACTIONS(281),
    [anon_sym_AT_LPAREN] = ACTIONS(286),
    [anon_sym_AT_LBRACK] = ACTIONS(289),
    [anon_sym_LBRACE] = ACTIONS(292),
    [anon_sym_AT_LBRACE] = ACTIONS(295),
    [sym_variadic_marker] = ACTIONS(298),
    [sym_optional_marker] = ACTIONS(298),
    [sym_keys_marker] = ACTIONS(298),
    [anon_sym_SQUOTE] = ACTIONS(300),
    [anon_sym_SEMI] = ACTIONS(303),
    [anon_sym_TILDE] = ACTIONS(306),
    [anon_sym_COMMA] = ACTIONS(309),
    [anon_sym_PIPE] = ACTIONS(312),
    [sym_str_literal] = ACTIONS(315),
    [sym_buffer_literal] = ACTIONS(315),
    [aux_sym_number_literal_token1] = ACTIONS(318),
    [aux_sym_number_literal_token2] = ACTIONS(318),
    [aux_sym_number_literal_token3] = ACTIONS(318),
    [anon_sym_true] = ACTIONS(321),
    [anon_sym_false] = ACTIONS(321),
    [sym_nil_literal] = ACTIONS(324),
    [sym_keyword] = ACTIONS(327),
    [sym__long_str] = ACTIONS(330),
    [sym__long_buffer] = ACTIONS(333),
  },
  [10] = {
    [sym__expr] = STATE(248),
    [sym_tuple] = STATE(235),
    [sym_sqr_tuple] = STATE(235),
    [sym_array] = STATE(235),
    [sym_sqr_array] = STATE(235),
    [sym_struct] = STATE(235),
    [sym_table] = STATE(235),
    [sym_peg_set] = STATE(235),
    [sym__special_forms] = STATE(235),
    [sym_def] = STATE(279),
    [sym_var] = STATE(279),
    [sym_quote] = STATE(279),
    [sym_splice] = STATE(279),
    [sym_quasiquote] = STATE(279),
    [sym_unquote] = STATE(279),
    [sym_break] = STATE(279),
    [sym_set] = STATE(279),
    [sym_if] = STATE(279),
    [sym_do] = STATE(279),
    [sym_while] = STATE(279),
    [sym_fn] = STATE(279),
    [sym_upscope] = STATE(279),
    [sym__shorthand] = STATE(235),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(235),
    [sym_extra_defs] = STATE(277),
    [sym__literals] = STATE(235),
    [sym_long_str_literal] = STATE(283),
    [sym_long_buffer_literal] = STATE(283),
    [sym_number_literal] = STATE(283),
    [sym_bool_literal] = STATE(283),
    [sym__identifier] = STATE(235),
    [aux_sym_parameters_repeat1] = STATE(9),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_RBRACK] = ACTIONS(336),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [sym_variadic_marker] = ACTIONS(338),
    [sym_optional_marker] = ACTIONS(338),
    [sym_keys_marker] = ACTIONS(338),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [11] = {
    [sym__expr] = STATE(248),
    [sym_tuple] = STATE(235),
    [sym_sqr_tuple] = STATE(235),
    [sym_array] = STATE(235),
    [sym_sqr_array] = STATE(235),
    [sym_struct] = STATE(235),
    [sym_table] = STATE(235),
    [sym_peg_set] = STATE(235),
    [sym__special_forms] = STATE(235),
    [sym_def] = STATE(279),
    [sym_var] = STATE(279),
    [sym_quote] = STATE(279),
    [sym_splice] = STATE(279),
    [sym_quasiquote] = STATE(279),
    [sym_unquote] = STATE(279),
    [sym_break] = STATE(279),
    [sym_set] = STATE(279),
    [sym_if] = STATE(279),
    [sym_do] = STATE(279),
    [sym_while] = STATE(279),
    [sym_fn] = STATE(279),
    [sym_upscope] = STATE(279),
    [sym__shorthand] = STATE(235),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(235),
    [sym_extra_defs] = STATE(277),
    [sym__literals] = STATE(235),
    [sym_long_str_literal] = STATE(283),
    [sym_long_buffer_literal] = STATE(283),
    [sym_number_literal] = STATE(283),
    [sym_bool_literal] = STATE(283),
    [sym__identifier] = STATE(235),
    [aux_sym_parameters_repeat1] = STATE(9),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_RPAREN] = ACTIONS(340),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [sym_variadic_marker] = ACTIONS(342),
    [sym_optional_marker] = ACTIONS(342),
    [sym_keys_marker] = ACTIONS(342),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [12] = {
    [sym__expr] = STATE(248),
    [sym_tuple] = STATE(235),
    [sym_sqr_tuple] = STATE(235),
    [sym_array] = STATE(235),
    [sym_sqr_array] = STATE(235),
    [sym_struct] = STATE(235),
    [sym_table] = STATE(235),
    [sym_peg_set] = STATE(235),
    [sym__special_forms] = STATE(235),
    [sym_def] = STATE(279),
    [sym_var] = STATE(279),
    [sym_quote] = STATE(279),
    [sym_splice] = STATE(279),
    [sym_quasiquote] = STATE(279),
    [sym_unquote] = STATE(279),
    [sym_break] = STATE(279),
    [sym_set] = STATE(279),
    [sym_if] = STATE(279),
    [sym_do] = STATE(279),
    [sym_while] = STATE(279),
    [sym_fn] = STATE(279),
    [sym_upscope] = STATE(279),
    [sym__shorthand] = STATE(235),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(235),
    [sym_extra_defs] = STATE(277),
    [sym__literals] = STATE(235),
    [sym_long_str_literal] = STATE(283),
    [sym_long_buffer_literal] = STATE(283),
    [sym_number_literal] = STATE(283),
    [sym_bool_literal] = STATE(283),
    [sym__identifier] = STATE(235),
    [aux_sym_parameters_repeat1] = STATE(10),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_RBRACK] = ACTIONS(344),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [sym_variadic_marker] = ACTIONS(346),
    [sym_optional_marker] = ACTIONS(346),
    [sym_keys_marker] = ACTIONS(346),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [13] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_struct_repeat1] = STATE(48),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(348),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [14] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_struct_repeat1] = STATE(56),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(350),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [15] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_struct_repeat1] = STATE(29),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(352),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [16] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_struct_repeat1] = STATE(30),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(354),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [17] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_struct_repeat1] = STATE(24),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(356),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [18] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_struct_repeat1] = STATE(25),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(358),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [19] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(554),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(360),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [20] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(557),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(362),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [21] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(546),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(364),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [22] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(651),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(366),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [23] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(647),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(368),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [24] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_struct_repeat1] = STATE(56),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(370),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [25] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_struct_repeat1] = STATE(56),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(372),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [26] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(563),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(374),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [27] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(569),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(376),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [28] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(570),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(378),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [29] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_struct_repeat1] = STATE(56),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(380),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [30] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_struct_repeat1] = STATE(56),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(382),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [31] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(572),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [32] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_struct_repeat1] = STATE(53),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(386),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [33] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(545),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [34] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(541),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(390),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [35] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(392),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(398),
    [anon_sym_LBRACK] = ACTIONS(400),
    [anon_sym_RBRACK] = ACTIONS(398),
    [anon_sym_AT_LPAREN] = ACTIONS(403),
    [anon_sym_AT_LBRACK] = ACTIONS(406),
    [anon_sym_LBRACE] = ACTIONS(409),
    [anon_sym_AT_LBRACE] = ACTIONS(412),
    [anon_sym_SQUOTE] = ACTIONS(415),
    [anon_sym_SEMI] = ACTIONS(418),
    [anon_sym_TILDE] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(424),
    [anon_sym_PIPE] = ACTIONS(427),
    [sym_str_literal] = ACTIONS(430),
    [sym_buffer_literal] = ACTIONS(430),
    [aux_sym_number_literal_token1] = ACTIONS(433),
    [aux_sym_number_literal_token2] = ACTIONS(433),
    [aux_sym_number_literal_token3] = ACTIONS(433),
    [anon_sym_true] = ACTIONS(436),
    [anon_sym_false] = ACTIONS(436),
    [sym_nil_literal] = ACTIONS(439),
    [sym_keyword] = ACTIONS(442),
    [sym__long_str] = ACTIONS(445),
    [sym__long_buffer] = ACTIONS(448),
  },
  [36] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_struct_repeat1] = STATE(46),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(451),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [37] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(637),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [38] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(636),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [39] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(543),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [40] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_struct_repeat1] = STATE(55),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [41] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(631),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [42] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(540),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(463),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [43] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(629),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [44] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(600),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(467),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [45] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(603),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [46] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_struct_repeat1] = STATE(56),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(471),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [47] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(628),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(473),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [48] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_struct_repeat1] = STATE(56),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(475),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [49] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(626),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [50] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(609),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [51] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(615),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(481),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [52] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(616),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(483),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [53] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_struct_repeat1] = STATE(56),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(485),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [54] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(618),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [55] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_struct_repeat1] = STATE(56),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(489),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [56] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_struct_repeat1] = STATE(56),
    [sym_symbol] = ACTIONS(491),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_LBRACK] = ACTIONS(497),
    [anon_sym_AT_LPAREN] = ACTIONS(500),
    [anon_sym_AT_LBRACK] = ACTIONS(503),
    [anon_sym_LBRACE] = ACTIONS(506),
    [anon_sym_RBRACE] = ACTIONS(509),
    [anon_sym_AT_LBRACE] = ACTIONS(511),
    [anon_sym_SQUOTE] = ACTIONS(514),
    [anon_sym_SEMI] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_COMMA] = ACTIONS(523),
    [anon_sym_PIPE] = ACTIONS(526),
    [sym_str_literal] = ACTIONS(529),
    [sym_buffer_literal] = ACTIONS(529),
    [aux_sym_number_literal_token1] = ACTIONS(532),
    [aux_sym_number_literal_token2] = ACTIONS(532),
    [aux_sym_number_literal_token3] = ACTIONS(532),
    [anon_sym_true] = ACTIONS(535),
    [anon_sym_false] = ACTIONS(535),
    [sym_nil_literal] = ACTIONS(538),
    [sym_keyword] = ACTIONS(541),
    [sym__long_str] = ACTIONS(544),
    [sym__long_buffer] = ACTIONS(547),
  },
  [57] = {
    [sym__expr] = STATE(364),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_parameters_repeat1] = STATE(57),
    [sym_symbol] = ACTIONS(550),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_RPAREN] = ACTIONS(281),
    [anon_sym_LBRACK] = ACTIONS(556),
    [anon_sym_RBRACK] = ACTIONS(281),
    [anon_sym_AT_LPAREN] = ACTIONS(559),
    [anon_sym_AT_LBRACK] = ACTIONS(562),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_AT_LBRACE] = ACTIONS(568),
    [anon_sym_SQUOTE] = ACTIONS(571),
    [anon_sym_SEMI] = ACTIONS(574),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_COMMA] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(583),
    [sym_str_literal] = ACTIONS(586),
    [sym_buffer_literal] = ACTIONS(586),
    [aux_sym_number_literal_token1] = ACTIONS(589),
    [aux_sym_number_literal_token2] = ACTIONS(589),
    [aux_sym_number_literal_token3] = ACTIONS(589),
    [anon_sym_true] = ACTIONS(592),
    [anon_sym_false] = ACTIONS(592),
    [sym_nil_literal] = ACTIONS(595),
    [sym_keyword] = ACTIONS(598),
    [sym__long_str] = ACTIONS(601),
    [sym__long_buffer] = ACTIONS(604),
  },
  [58] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_struct_repeat1] = STATE(14),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(607),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [59] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(548),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(609),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [60] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(579),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(611),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [61] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(582),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(613),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [62] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_struct_repeat1] = STATE(64),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(615),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [63] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(556),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(617),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [64] = {
    [sym__expr] = STATE(212),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym__struct_tables_commom] = STATE(447),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_struct_repeat1] = STATE(56),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(619),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [65] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym_body] = STATE(571),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(621),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [66] = {
    [sym__expr] = STATE(605),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(418),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(417),
    [sym_splice] = STATE(417),
    [sym_quasiquote] = STATE(417),
    [sym_unquote] = STATE(417),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(416),
    [sym_short_splice] = STATE(416),
    [sym_short_quasiquote] = STATE(416),
    [sym_short_unquote] = STATE(416),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(420),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym_metadata] = STATE(461),
    [sym__identifier] = STATE(588),
    [aux_sym_def_repeat1] = STATE(116),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(637),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(647),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(649),
  },
  [67] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(139),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [68] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(117),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [69] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(115),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(655),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [70] = {
    [sym__expr] = STATE(560),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(418),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(417),
    [sym_splice] = STATE(417),
    [sym_quasiquote] = STATE(417),
    [sym_unquote] = STATE(417),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(416),
    [sym_short_splice] = STATE(416),
    [sym_short_quasiquote] = STATE(416),
    [sym_short_unquote] = STATE(416),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(420),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym_metadata] = STATE(461),
    [sym__identifier] = STATE(588),
    [aux_sym_def_repeat1] = STATE(97),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(637),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(647),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(649),
  },
  [71] = {
    [sym__expr] = STATE(608),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(418),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(417),
    [sym_splice] = STATE(417),
    [sym_quasiquote] = STATE(417),
    [sym_unquote] = STATE(417),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(416),
    [sym_short_splice] = STATE(416),
    [sym_short_quasiquote] = STATE(416),
    [sym_short_unquote] = STATE(416),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(420),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym_metadata] = STATE(461),
    [sym__identifier] = STATE(588),
    [aux_sym_def_repeat1] = STATE(109),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(637),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(647),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(649),
  },
  [72] = {
    [sym__expr] = STATE(590),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(418),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(417),
    [sym_splice] = STATE(417),
    [sym_quasiquote] = STATE(417),
    [sym_unquote] = STATE(417),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(416),
    [sym_short_splice] = STATE(416),
    [sym_short_quasiquote] = STATE(416),
    [sym_short_unquote] = STATE(416),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(420),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym_metadata] = STATE(461),
    [sym__identifier] = STATE(588),
    [aux_sym_def_repeat1] = STATE(111),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(637),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(647),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(649),
  },
  [73] = {
    [sym__expr] = STATE(559),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(418),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(417),
    [sym_splice] = STATE(417),
    [sym_quasiquote] = STATE(417),
    [sym_unquote] = STATE(417),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(416),
    [sym_short_splice] = STATE(416),
    [sym_short_quasiquote] = STATE(416),
    [sym_short_unquote] = STATE(416),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(420),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym_metadata] = STATE(461),
    [sym__identifier] = STATE(588),
    [aux_sym_def_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(637),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(647),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(649),
  },
  [74] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(118),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(657),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [75] = {
    [sym__expr] = STATE(364),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_parameters_repeat1] = STATE(57),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(659),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [76] = {
    [sym__expr] = STATE(364),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_parameters_repeat1] = STATE(57),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(661),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [77] = {
    [sym__expr] = STATE(544),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(418),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(417),
    [sym_splice] = STATE(417),
    [sym_quasiquote] = STATE(417),
    [sym_unquote] = STATE(417),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(416),
    [sym_short_splice] = STATE(416),
    [sym_short_quasiquote] = STATE(416),
    [sym_short_unquote] = STATE(416),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(420),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym_metadata] = STATE(461),
    [sym__identifier] = STATE(588),
    [aux_sym_def_repeat1] = STATE(234),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(637),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(647),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(649),
  },
  [78] = {
    [sym__expr] = STATE(542),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(418),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(417),
    [sym_splice] = STATE(417),
    [sym_quasiquote] = STATE(417),
    [sym_unquote] = STATE(417),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(416),
    [sym_short_splice] = STATE(416),
    [sym_short_quasiquote] = STATE(416),
    [sym_short_unquote] = STATE(416),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(420),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym_metadata] = STATE(461),
    [sym__identifier] = STATE(588),
    [aux_sym_def_repeat1] = STATE(234),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(637),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(647),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(649),
  },
  [79] = {
    [sym__expr] = STATE(641),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(418),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(417),
    [sym_splice] = STATE(417),
    [sym_quasiquote] = STATE(417),
    [sym_unquote] = STATE(417),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(416),
    [sym_short_splice] = STATE(416),
    [sym_short_quasiquote] = STATE(416),
    [sym_short_unquote] = STATE(416),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(420),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym_metadata] = STATE(461),
    [sym__identifier] = STATE(588),
    [aux_sym_def_repeat1] = STATE(88),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(637),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(647),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(649),
  },
  [80] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(663),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [81] = {
    [sym__expr] = STATE(576),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(418),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(417),
    [sym_splice] = STATE(417),
    [sym_quasiquote] = STATE(417),
    [sym_unquote] = STATE(417),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(416),
    [sym_short_splice] = STATE(416),
    [sym_short_quasiquote] = STATE(416),
    [sym_short_unquote] = STATE(416),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(420),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym_metadata] = STATE(461),
    [sym__identifier] = STATE(588),
    [aux_sym_def_repeat1] = STATE(77),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(637),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(647),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(649),
  },
  [82] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(665),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [83] = {
    [sym__expr] = STATE(577),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(418),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(417),
    [sym_splice] = STATE(417),
    [sym_quasiquote] = STATE(417),
    [sym_unquote] = STATE(417),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(416),
    [sym_short_splice] = STATE(416),
    [sym_short_quasiquote] = STATE(416),
    [sym_short_unquote] = STATE(416),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(420),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym_metadata] = STATE(461),
    [sym__identifier] = STATE(588),
    [aux_sym_def_repeat1] = STATE(78),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(637),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(647),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(649),
  },
  [84] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [85] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(669),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [86] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(119),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [87] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(121),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [88] = {
    [sym__expr] = STATE(632),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(418),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(417),
    [sym_splice] = STATE(417),
    [sym_quasiquote] = STATE(417),
    [sym_unquote] = STATE(417),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(416),
    [sym_short_splice] = STATE(416),
    [sym_short_quasiquote] = STATE(416),
    [sym_short_unquote] = STATE(416),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(420),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym_metadata] = STATE(461),
    [sym__identifier] = STATE(588),
    [aux_sym_def_repeat1] = STATE(234),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(637),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(647),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(649),
  },
  [89] = {
    [sym__expr] = STATE(633),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(418),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(417),
    [sym_splice] = STATE(417),
    [sym_quasiquote] = STATE(417),
    [sym_unquote] = STATE(417),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(416),
    [sym_short_splice] = STATE(416),
    [sym_short_quasiquote] = STATE(416),
    [sym_short_unquote] = STATE(416),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(420),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym_metadata] = STATE(461),
    [sym__identifier] = STATE(588),
    [aux_sym_def_repeat1] = STATE(234),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(637),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(647),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(649),
  },
  [90] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(95),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [91] = {
    [sym__expr] = STATE(606),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(418),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(417),
    [sym_splice] = STATE(417),
    [sym_quasiquote] = STATE(417),
    [sym_unquote] = STATE(417),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(416),
    [sym_short_splice] = STATE(416),
    [sym_short_quasiquote] = STATE(416),
    [sym_short_unquote] = STATE(416),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(420),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym_metadata] = STATE(461),
    [sym__identifier] = STATE(588),
    [aux_sym_def_repeat1] = STATE(128),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(637),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(647),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(649),
  },
  [92] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(110),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(677),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [93] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [94] = {
    [sym__expr] = STATE(643),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(418),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(417),
    [sym_splice] = STATE(417),
    [sym_quasiquote] = STATE(417),
    [sym_unquote] = STATE(417),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(416),
    [sym_short_splice] = STATE(416),
    [sym_short_quasiquote] = STATE(416),
    [sym_short_unquote] = STATE(416),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(420),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym_metadata] = STATE(461),
    [sym__identifier] = STATE(588),
    [aux_sym_def_repeat1] = STATE(89),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(637),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(647),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(649),
  },
  [95] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(119),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(681),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [96] = {
    [sym__expr] = STATE(566),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(418),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(417),
    [sym_splice] = STATE(417),
    [sym_quasiquote] = STATE(417),
    [sym_unquote] = STATE(417),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(416),
    [sym_short_splice] = STATE(416),
    [sym_short_quasiquote] = STATE(416),
    [sym_short_unquote] = STATE(416),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(420),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym_metadata] = STATE(461),
    [sym__identifier] = STATE(588),
    [aux_sym_def_repeat1] = STATE(234),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(637),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(647),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(649),
  },
  [97] = {
    [sym__expr] = STATE(567),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(418),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(417),
    [sym_splice] = STATE(417),
    [sym_quasiquote] = STATE(417),
    [sym_unquote] = STATE(417),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(416),
    [sym_short_splice] = STATE(416),
    [sym_short_quasiquote] = STATE(416),
    [sym_short_unquote] = STATE(416),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(420),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym_metadata] = STATE(461),
    [sym__identifier] = STATE(588),
    [aux_sym_def_repeat1] = STATE(234),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(637),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(647),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(649),
  },
  [98] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(683),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [99] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(120),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(685),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [100] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(84),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [101] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(82),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(689),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [102] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(142),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(691),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [103] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(119),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(693),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [104] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(695),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [105] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(697),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [106] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(103),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [107] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(701),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [108] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(703),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [109] = {
    [sym__expr] = STATE(573),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(418),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(417),
    [sym_splice] = STATE(417),
    [sym_quasiquote] = STATE(417),
    [sym_unquote] = STATE(417),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(416),
    [sym_short_splice] = STATE(416),
    [sym_short_quasiquote] = STATE(416),
    [sym_short_unquote] = STATE(416),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(420),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym_metadata] = STATE(461),
    [sym__identifier] = STATE(588),
    [aux_sym_def_repeat1] = STATE(234),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(637),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(647),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(649),
  },
  [110] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(705),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [111] = {
    [sym__expr] = STATE(565),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(418),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(417),
    [sym_splice] = STATE(417),
    [sym_quasiquote] = STATE(417),
    [sym_unquote] = STATE(417),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(416),
    [sym_short_splice] = STATE(416),
    [sym_short_quasiquote] = STATE(416),
    [sym_short_unquote] = STATE(416),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(420),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym_metadata] = STATE(461),
    [sym__identifier] = STATE(588),
    [aux_sym_def_repeat1] = STATE(234),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(637),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(647),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(649),
  },
  [112] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(707),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [113] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(709),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [114] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(711),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [115] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(713),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [116] = {
    [sym__expr] = STATE(612),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(418),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(417),
    [sym_splice] = STATE(417),
    [sym_quasiquote] = STATE(417),
    [sym_unquote] = STATE(417),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(416),
    [sym_short_splice] = STATE(416),
    [sym_short_quasiquote] = STATE(416),
    [sym_short_unquote] = STATE(416),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(420),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym_metadata] = STATE(461),
    [sym__identifier] = STATE(588),
    [aux_sym_def_repeat1] = STATE(234),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(637),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(647),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(649),
  },
  [117] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [118] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(717),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [119] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(119),
    [sym_symbol] = ACTIONS(719),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(725),
    [anon_sym_LBRACK] = ACTIONS(727),
    [anon_sym_AT_LPAREN] = ACTIONS(730),
    [anon_sym_AT_LBRACK] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(736),
    [anon_sym_AT_LBRACE] = ACTIONS(739),
    [anon_sym_SQUOTE] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_PIPE] = ACTIONS(754),
    [sym_str_literal] = ACTIONS(757),
    [sym_buffer_literal] = ACTIONS(757),
    [aux_sym_number_literal_token1] = ACTIONS(760),
    [aux_sym_number_literal_token2] = ACTIONS(760),
    [aux_sym_number_literal_token3] = ACTIONS(760),
    [anon_sym_true] = ACTIONS(763),
    [anon_sym_false] = ACTIONS(763),
    [sym_nil_literal] = ACTIONS(766),
    [sym_keyword] = ACTIONS(769),
    [sym__long_str] = ACTIONS(772),
    [sym__long_buffer] = ACTIONS(775),
  },
  [120] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(778),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [121] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(119),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(780),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [122] = {
    [sym__expr] = STATE(364),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_parameters_repeat1] = STATE(75),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(782),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [123] = {
    [sym__expr] = STATE(364),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_parameters_repeat1] = STATE(135),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(340),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [124] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [125] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(129),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(786),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [126] = {
    [sym__expr] = STATE(364),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_parameters_repeat1] = STATE(57),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(782),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [127] = {
    [sym__expr] = STATE(364),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_parameters_repeat1] = STATE(126),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(336),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [128] = {
    [sym__expr] = STATE(613),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(418),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(417),
    [sym_splice] = STATE(417),
    [sym_quasiquote] = STATE(417),
    [sym_unquote] = STATE(417),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(416),
    [sym_short_splice] = STATE(416),
    [sym_short_quasiquote] = STATE(416),
    [sym_short_unquote] = STATE(416),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(420),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym_metadata] = STATE(461),
    [sym__identifier] = STATE(588),
    [aux_sym_def_repeat1] = STATE(234),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(637),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(647),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(649),
  },
  [129] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(788),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [130] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(105),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(790),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [131] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(119),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(792),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [132] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(108),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(794),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [133] = {
    [sym__expr] = STATE(364),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_parameters_repeat1] = STATE(76),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(796),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [134] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(112),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(798),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [135] = {
    [sym__expr] = STATE(364),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_parameters_repeat1] = STATE(57),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(796),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [136] = {
    [sym__expr] = STATE(136),
    [sym_tuple] = STATE(414),
    [sym_sqr_tuple] = STATE(414),
    [sym_array] = STATE(414),
    [sym_sqr_array] = STATE(414),
    [sym_struct] = STATE(414),
    [sym_table] = STATE(414),
    [sym_peg_set] = STATE(414),
    [sym__special_forms] = STATE(414),
    [sym_def] = STATE(435),
    [sym_var] = STATE(435),
    [sym_quote] = STATE(435),
    [sym_splice] = STATE(435),
    [sym_quasiquote] = STATE(435),
    [sym_unquote] = STATE(435),
    [sym_break] = STATE(435),
    [sym_set] = STATE(435),
    [sym_if] = STATE(435),
    [sym_do] = STATE(435),
    [sym_while] = STATE(435),
    [sym_fn] = STATE(435),
    [sym_upscope] = STATE(435),
    [sym__shorthand] = STATE(414),
    [sym_short_quote] = STATE(436),
    [sym_short_splice] = STATE(436),
    [sym_short_quasiquote] = STATE(436),
    [sym_short_unquote] = STATE(436),
    [sym_short_fn] = STATE(436),
    [sym__specials] = STATE(414),
    [sym_extra_defs] = STATE(438),
    [sym__literals] = STATE(414),
    [sym_long_str_literal] = STATE(398),
    [sym_long_buffer_literal] = STATE(398),
    [sym_number_literal] = STATE(398),
    [sym_bool_literal] = STATE(398),
    [sym__identifier] = STATE(414),
    [aux_sym_source_file_repeat1] = STATE(136),
    [ts_builtin_sym_end] = ACTIONS(800),
    [sym_symbol] = ACTIONS(802),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(805),
    [anon_sym_LBRACK] = ACTIONS(808),
    [anon_sym_AT_LPAREN] = ACTIONS(811),
    [anon_sym_AT_LBRACK] = ACTIONS(814),
    [anon_sym_LBRACE] = ACTIONS(817),
    [anon_sym_AT_LBRACE] = ACTIONS(820),
    [anon_sym_SQUOTE] = ACTIONS(823),
    [anon_sym_SEMI] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_COMMA] = ACTIONS(832),
    [anon_sym_PIPE] = ACTIONS(835),
    [sym_str_literal] = ACTIONS(838),
    [sym_buffer_literal] = ACTIONS(838),
    [aux_sym_number_literal_token1] = ACTIONS(841),
    [aux_sym_number_literal_token2] = ACTIONS(841),
    [aux_sym_number_literal_token3] = ACTIONS(841),
    [anon_sym_true] = ACTIONS(844),
    [anon_sym_false] = ACTIONS(844),
    [sym_nil_literal] = ACTIONS(847),
    [sym_keyword] = ACTIONS(850),
    [sym__long_str] = ACTIONS(853),
    [sym__long_buffer] = ACTIONS(856),
  },
  [137] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(113),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(859),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [138] = {
    [sym__expr] = STATE(136),
    [sym_tuple] = STATE(414),
    [sym_sqr_tuple] = STATE(414),
    [sym_array] = STATE(414),
    [sym_sqr_array] = STATE(414),
    [sym_struct] = STATE(414),
    [sym_table] = STATE(414),
    [sym_peg_set] = STATE(414),
    [sym__special_forms] = STATE(414),
    [sym_def] = STATE(435),
    [sym_var] = STATE(435),
    [sym_quote] = STATE(435),
    [sym_splice] = STATE(435),
    [sym_quasiquote] = STATE(435),
    [sym_unquote] = STATE(435),
    [sym_break] = STATE(435),
    [sym_set] = STATE(435),
    [sym_if] = STATE(435),
    [sym_do] = STATE(435),
    [sym_while] = STATE(435),
    [sym_fn] = STATE(435),
    [sym_upscope] = STATE(435),
    [sym__shorthand] = STATE(414),
    [sym_short_quote] = STATE(436),
    [sym_short_splice] = STATE(436),
    [sym_short_quasiquote] = STATE(436),
    [sym_short_unquote] = STATE(436),
    [sym_short_fn] = STATE(436),
    [sym__specials] = STATE(414),
    [sym_extra_defs] = STATE(438),
    [sym__literals] = STATE(414),
    [sym_long_str_literal] = STATE(398),
    [sym_long_buffer_literal] = STATE(398),
    [sym_number_literal] = STATE(398),
    [sym_bool_literal] = STATE(398),
    [sym__identifier] = STATE(414),
    [aux_sym_source_file_repeat1] = STATE(136),
    [ts_builtin_sym_end] = ACTIONS(861),
    [sym_symbol] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(31),
    [sym_buffer_literal] = ACTIONS(31),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(37),
    [sym_keyword] = ACTIONS(39),
    [sym__long_str] = ACTIONS(41),
    [sym__long_buffer] = ACTIONS(43),
  },
  [139] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(119),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(863),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [140] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(107),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(865),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [141] = {
    [sym__expr] = STATE(431),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_while_repeat1] = STATE(131),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [142] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(869),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [143] = {
    [sym__expr] = STATE(614),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [144] = {
    [sym__expr] = STATE(642),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [145] = {
    [sym__expr] = STATE(649),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(891),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [146] = {
    [sym__expr] = STATE(652),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [147] = {
    [sym__expr] = STATE(656),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [148] = {
    [sym__expr] = STATE(639),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [149] = {
    [sym__expr] = STATE(630),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [150] = {
    [sym__expr] = STATE(595),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [151] = {
    [sym__expr] = STATE(596),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [152] = {
    [sym__expr] = STATE(597),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [153] = {
    [sym__expr] = STATE(598),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [154] = {
    [sym__expr] = STATE(599),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [155] = {
    [sym__expr] = STATE(562),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(911),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [156] = {
    [sym__expr] = STATE(547),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [157] = {
    [sym__expr] = STATE(646),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [158] = {
    [sym__expr] = STATE(568),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(917),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [159] = {
    [sym__expr] = STATE(644),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [160] = {
    [sym__expr] = STATE(653),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(921),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [161] = {
    [sym__expr] = STATE(553),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [162] = {
    [sym__expr] = STATE(552),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [163] = {
    [sym__expr] = STATE(583),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(927),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [164] = {
    [sym__expr] = STATE(551),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(929),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [165] = {
    [sym__expr] = STATE(584),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [166] = {
    [sym__expr] = STATE(550),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(933),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [167] = {
    [sym__expr] = STATE(549),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [168] = {
    [sym__expr] = STATE(654),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [169] = {
    [sym__expr] = STATE(655),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [170] = {
    [sym__expr] = STATE(585),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(941),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [171] = {
    [sym__expr] = STATE(586),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(943),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [172] = {
    [sym__expr] = STATE(587),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(945),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [173] = {
    [sym__expr] = STATE(149),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [174] = {
    [sym__expr] = STATE(156),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [175] = {
    [sym__expr] = STATE(339),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [176] = {
    [sym__expr] = STATE(338),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [177] = {
    [sym__expr] = STATE(337),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [178] = {
    [sym__expr] = STATE(306),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [179] = {
    [sym__expr] = STATE(331),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [180] = {
    [sym__expr] = STATE(286),
    [sym_tuple] = STATE(235),
    [sym_sqr_tuple] = STATE(235),
    [sym_array] = STATE(235),
    [sym_sqr_array] = STATE(235),
    [sym_struct] = STATE(235),
    [sym_table] = STATE(235),
    [sym_peg_set] = STATE(235),
    [sym__special_forms] = STATE(235),
    [sym_def] = STATE(279),
    [sym_var] = STATE(279),
    [sym_quote] = STATE(279),
    [sym_splice] = STATE(279),
    [sym_quasiquote] = STATE(279),
    [sym_unquote] = STATE(279),
    [sym_break] = STATE(279),
    [sym_set] = STATE(279),
    [sym_if] = STATE(279),
    [sym_do] = STATE(279),
    [sym_while] = STATE(279),
    [sym_fn] = STATE(279),
    [sym_upscope] = STATE(279),
    [sym__shorthand] = STATE(235),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(235),
    [sym_extra_defs] = STATE(277),
    [sym__literals] = STATE(235),
    [sym_long_str_literal] = STATE(283),
    [sym_long_buffer_literal] = STATE(283),
    [sym_number_literal] = STATE(283),
    [sym_bool_literal] = STATE(283),
    [sym__identifier] = STATE(235),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [181] = {
    [sym__expr] = STATE(280),
    [sym_tuple] = STATE(235),
    [sym_sqr_tuple] = STATE(235),
    [sym_array] = STATE(235),
    [sym_sqr_array] = STATE(235),
    [sym_struct] = STATE(235),
    [sym_table] = STATE(235),
    [sym_peg_set] = STATE(235),
    [sym__special_forms] = STATE(235),
    [sym_def] = STATE(279),
    [sym_var] = STATE(279),
    [sym_quote] = STATE(279),
    [sym_splice] = STATE(279),
    [sym_quasiquote] = STATE(279),
    [sym_unquote] = STATE(279),
    [sym_break] = STATE(279),
    [sym_set] = STATE(279),
    [sym_if] = STATE(279),
    [sym_do] = STATE(279),
    [sym_while] = STATE(279),
    [sym_fn] = STATE(279),
    [sym_upscope] = STATE(279),
    [sym__shorthand] = STATE(235),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(235),
    [sym_extra_defs] = STATE(277),
    [sym__literals] = STATE(235),
    [sym_long_str_literal] = STATE(283),
    [sym_long_buffer_literal] = STATE(283),
    [sym_number_literal] = STATE(283),
    [sym_bool_literal] = STATE(283),
    [sym__identifier] = STATE(235),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [182] = {
    [sym__expr] = STATE(270),
    [sym_tuple] = STATE(235),
    [sym_sqr_tuple] = STATE(235),
    [sym_array] = STATE(235),
    [sym_sqr_array] = STATE(235),
    [sym_struct] = STATE(235),
    [sym_table] = STATE(235),
    [sym_peg_set] = STATE(235),
    [sym__special_forms] = STATE(235),
    [sym_def] = STATE(279),
    [sym_var] = STATE(279),
    [sym_quote] = STATE(279),
    [sym_splice] = STATE(279),
    [sym_quasiquote] = STATE(279),
    [sym_unquote] = STATE(279),
    [sym_break] = STATE(279),
    [sym_set] = STATE(279),
    [sym_if] = STATE(279),
    [sym_do] = STATE(279),
    [sym_while] = STATE(279),
    [sym_fn] = STATE(279),
    [sym_upscope] = STATE(279),
    [sym__shorthand] = STATE(235),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(235),
    [sym_extra_defs] = STATE(277),
    [sym__literals] = STATE(235),
    [sym_long_str_literal] = STATE(283),
    [sym_long_buffer_literal] = STATE(283),
    [sym_number_literal] = STATE(283),
    [sym_bool_literal] = STATE(283),
    [sym__identifier] = STATE(235),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [183] = {
    [sym__expr] = STATE(269),
    [sym_tuple] = STATE(235),
    [sym_sqr_tuple] = STATE(235),
    [sym_array] = STATE(235),
    [sym_sqr_array] = STATE(235),
    [sym_struct] = STATE(235),
    [sym_table] = STATE(235),
    [sym_peg_set] = STATE(235),
    [sym__special_forms] = STATE(235),
    [sym_def] = STATE(279),
    [sym_var] = STATE(279),
    [sym_quote] = STATE(279),
    [sym_splice] = STATE(279),
    [sym_quasiquote] = STATE(279),
    [sym_unquote] = STATE(279),
    [sym_break] = STATE(279),
    [sym_set] = STATE(279),
    [sym_if] = STATE(279),
    [sym_do] = STATE(279),
    [sym_while] = STATE(279),
    [sym_fn] = STATE(279),
    [sym_upscope] = STATE(279),
    [sym__shorthand] = STATE(235),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(235),
    [sym_extra_defs] = STATE(277),
    [sym__literals] = STATE(235),
    [sym_long_str_literal] = STATE(283),
    [sym_long_buffer_literal] = STATE(283),
    [sym_number_literal] = STATE(283),
    [sym_bool_literal] = STATE(283),
    [sym__identifier] = STATE(235),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [184] = {
    [sym__expr] = STATE(506),
    [sym_tuple] = STATE(525),
    [sym_sqr_tuple] = STATE(525),
    [sym_array] = STATE(525),
    [sym_sqr_array] = STATE(525),
    [sym_struct] = STATE(525),
    [sym_table] = STATE(525),
    [sym_peg_set] = STATE(525),
    [sym__special_forms] = STATE(525),
    [sym_def] = STATE(524),
    [sym_var] = STATE(524),
    [sym_quote] = STATE(524),
    [sym_splice] = STATE(524),
    [sym_quasiquote] = STATE(524),
    [sym_unquote] = STATE(524),
    [sym_break] = STATE(524),
    [sym_set] = STATE(524),
    [sym_if] = STATE(524),
    [sym_do] = STATE(524),
    [sym_while] = STATE(524),
    [sym_fn] = STATE(524),
    [sym_upscope] = STATE(524),
    [sym__shorthand] = STATE(525),
    [sym_short_quote] = STATE(519),
    [sym_short_splice] = STATE(519),
    [sym_short_quasiquote] = STATE(519),
    [sym_short_unquote] = STATE(519),
    [sym_short_fn] = STATE(519),
    [sym__specials] = STATE(525),
    [sym_extra_defs] = STATE(518),
    [sym__literals] = STATE(525),
    [sym_long_str_literal] = STATE(528),
    [sym_long_buffer_literal] = STATE(528),
    [sym_number_literal] = STATE(528),
    [sym_bool_literal] = STATE(528),
    [sym__identifier] = STATE(525),
    [sym_symbol] = ACTIONS(947),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_LBRACK] = ACTIONS(951),
    [anon_sym_AT_LPAREN] = ACTIONS(953),
    [anon_sym_AT_LBRACK] = ACTIONS(955),
    [anon_sym_LBRACE] = ACTIONS(957),
    [anon_sym_AT_LBRACE] = ACTIONS(959),
    [anon_sym_SQUOTE] = ACTIONS(961),
    [anon_sym_SEMI] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(965),
    [anon_sym_COMMA] = ACTIONS(967),
    [anon_sym_PIPE] = ACTIONS(969),
    [sym_str_literal] = ACTIONS(971),
    [sym_buffer_literal] = ACTIONS(971),
    [aux_sym_number_literal_token1] = ACTIONS(973),
    [aux_sym_number_literal_token2] = ACTIONS(973),
    [aux_sym_number_literal_token3] = ACTIONS(973),
    [anon_sym_true] = ACTIONS(975),
    [anon_sym_false] = ACTIONS(975),
    [sym_nil_literal] = ACTIONS(977),
    [sym_keyword] = ACTIONS(979),
    [sym__long_str] = ACTIONS(981),
    [sym__long_buffer] = ACTIONS(983),
  },
  [185] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(235),
    [sym_sqr_tuple] = STATE(235),
    [sym_array] = STATE(235),
    [sym_sqr_array] = STATE(235),
    [sym_struct] = STATE(235),
    [sym_table] = STATE(235),
    [sym_peg_set] = STATE(235),
    [sym__special_forms] = STATE(235),
    [sym_def] = STATE(279),
    [sym_var] = STATE(279),
    [sym_quote] = STATE(279),
    [sym_splice] = STATE(279),
    [sym_quasiquote] = STATE(279),
    [sym_unquote] = STATE(279),
    [sym_break] = STATE(279),
    [sym_set] = STATE(279),
    [sym_if] = STATE(279),
    [sym_do] = STATE(279),
    [sym_while] = STATE(279),
    [sym_fn] = STATE(279),
    [sym_upscope] = STATE(279),
    [sym__shorthand] = STATE(235),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(235),
    [sym_extra_defs] = STATE(277),
    [sym__literals] = STATE(235),
    [sym_long_str_literal] = STATE(283),
    [sym_long_buffer_literal] = STATE(283),
    [sym_number_literal] = STATE(283),
    [sym_bool_literal] = STATE(283),
    [sym__identifier] = STATE(235),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [186] = {
    [sym__expr] = STATE(480),
    [sym_tuple] = STATE(525),
    [sym_sqr_tuple] = STATE(525),
    [sym_array] = STATE(525),
    [sym_sqr_array] = STATE(525),
    [sym_struct] = STATE(525),
    [sym_table] = STATE(525),
    [sym_peg_set] = STATE(525),
    [sym__special_forms] = STATE(525),
    [sym_def] = STATE(524),
    [sym_var] = STATE(524),
    [sym_quote] = STATE(524),
    [sym_splice] = STATE(524),
    [sym_quasiquote] = STATE(524),
    [sym_unquote] = STATE(524),
    [sym_break] = STATE(524),
    [sym_set] = STATE(524),
    [sym_if] = STATE(524),
    [sym_do] = STATE(524),
    [sym_while] = STATE(524),
    [sym_fn] = STATE(524),
    [sym_upscope] = STATE(524),
    [sym__shorthand] = STATE(525),
    [sym_short_quote] = STATE(519),
    [sym_short_splice] = STATE(519),
    [sym_short_quasiquote] = STATE(519),
    [sym_short_unquote] = STATE(519),
    [sym_short_fn] = STATE(519),
    [sym__specials] = STATE(525),
    [sym_extra_defs] = STATE(518),
    [sym__literals] = STATE(525),
    [sym_long_str_literal] = STATE(528),
    [sym_long_buffer_literal] = STATE(528),
    [sym_number_literal] = STATE(528),
    [sym_bool_literal] = STATE(528),
    [sym__identifier] = STATE(525),
    [sym_symbol] = ACTIONS(947),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_LBRACK] = ACTIONS(951),
    [anon_sym_AT_LPAREN] = ACTIONS(953),
    [anon_sym_AT_LBRACK] = ACTIONS(955),
    [anon_sym_LBRACE] = ACTIONS(957),
    [anon_sym_AT_LBRACE] = ACTIONS(959),
    [anon_sym_SQUOTE] = ACTIONS(961),
    [anon_sym_SEMI] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(965),
    [anon_sym_COMMA] = ACTIONS(967),
    [anon_sym_PIPE] = ACTIONS(969),
    [sym_str_literal] = ACTIONS(971),
    [sym_buffer_literal] = ACTIONS(971),
    [aux_sym_number_literal_token1] = ACTIONS(973),
    [aux_sym_number_literal_token2] = ACTIONS(973),
    [aux_sym_number_literal_token3] = ACTIONS(973),
    [anon_sym_true] = ACTIONS(975),
    [anon_sym_false] = ACTIONS(975),
    [sym_nil_literal] = ACTIONS(977),
    [sym_keyword] = ACTIONS(979),
    [sym__long_str] = ACTIONS(981),
    [sym__long_buffer] = ACTIONS(983),
  },
  [187] = {
    [sym__expr] = STATE(520),
    [sym_tuple] = STATE(525),
    [sym_sqr_tuple] = STATE(525),
    [sym_array] = STATE(525),
    [sym_sqr_array] = STATE(525),
    [sym_struct] = STATE(525),
    [sym_table] = STATE(525),
    [sym_peg_set] = STATE(525),
    [sym__special_forms] = STATE(525),
    [sym_def] = STATE(524),
    [sym_var] = STATE(524),
    [sym_quote] = STATE(524),
    [sym_splice] = STATE(524),
    [sym_quasiquote] = STATE(524),
    [sym_unquote] = STATE(524),
    [sym_break] = STATE(524),
    [sym_set] = STATE(524),
    [sym_if] = STATE(524),
    [sym_do] = STATE(524),
    [sym_while] = STATE(524),
    [sym_fn] = STATE(524),
    [sym_upscope] = STATE(524),
    [sym__shorthand] = STATE(525),
    [sym_short_quote] = STATE(519),
    [sym_short_splice] = STATE(519),
    [sym_short_quasiquote] = STATE(519),
    [sym_short_unquote] = STATE(519),
    [sym_short_fn] = STATE(519),
    [sym__specials] = STATE(525),
    [sym_extra_defs] = STATE(518),
    [sym__literals] = STATE(525),
    [sym_long_str_literal] = STATE(528),
    [sym_long_buffer_literal] = STATE(528),
    [sym_number_literal] = STATE(528),
    [sym_bool_literal] = STATE(528),
    [sym__identifier] = STATE(525),
    [sym_symbol] = ACTIONS(947),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_LBRACK] = ACTIONS(951),
    [anon_sym_AT_LPAREN] = ACTIONS(953),
    [anon_sym_AT_LBRACK] = ACTIONS(955),
    [anon_sym_LBRACE] = ACTIONS(957),
    [anon_sym_AT_LBRACE] = ACTIONS(959),
    [anon_sym_SQUOTE] = ACTIONS(961),
    [anon_sym_SEMI] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(965),
    [anon_sym_COMMA] = ACTIONS(967),
    [anon_sym_PIPE] = ACTIONS(969),
    [sym_str_literal] = ACTIONS(971),
    [sym_buffer_literal] = ACTIONS(971),
    [aux_sym_number_literal_token1] = ACTIONS(973),
    [aux_sym_number_literal_token2] = ACTIONS(973),
    [aux_sym_number_literal_token3] = ACTIONS(973),
    [anon_sym_true] = ACTIONS(975),
    [anon_sym_false] = ACTIONS(975),
    [sym_nil_literal] = ACTIONS(977),
    [sym_keyword] = ACTIONS(979),
    [sym__long_str] = ACTIONS(981),
    [sym__long_buffer] = ACTIONS(983),
  },
  [188] = {
    [sym__expr] = STATE(509),
    [sym_tuple] = STATE(525),
    [sym_sqr_tuple] = STATE(525),
    [sym_array] = STATE(525),
    [sym_sqr_array] = STATE(525),
    [sym_struct] = STATE(525),
    [sym_table] = STATE(525),
    [sym_peg_set] = STATE(525),
    [sym__special_forms] = STATE(525),
    [sym_def] = STATE(524),
    [sym_var] = STATE(524),
    [sym_quote] = STATE(524),
    [sym_splice] = STATE(524),
    [sym_quasiquote] = STATE(524),
    [sym_unquote] = STATE(524),
    [sym_break] = STATE(524),
    [sym_set] = STATE(524),
    [sym_if] = STATE(524),
    [sym_do] = STATE(524),
    [sym_while] = STATE(524),
    [sym_fn] = STATE(524),
    [sym_upscope] = STATE(524),
    [sym__shorthand] = STATE(525),
    [sym_short_quote] = STATE(519),
    [sym_short_splice] = STATE(519),
    [sym_short_quasiquote] = STATE(519),
    [sym_short_unquote] = STATE(519),
    [sym_short_fn] = STATE(519),
    [sym__specials] = STATE(525),
    [sym_extra_defs] = STATE(518),
    [sym__literals] = STATE(525),
    [sym_long_str_literal] = STATE(528),
    [sym_long_buffer_literal] = STATE(528),
    [sym_number_literal] = STATE(528),
    [sym_bool_literal] = STATE(528),
    [sym__identifier] = STATE(525),
    [sym_symbol] = ACTIONS(947),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_LBRACK] = ACTIONS(951),
    [anon_sym_AT_LPAREN] = ACTIONS(953),
    [anon_sym_AT_LBRACK] = ACTIONS(955),
    [anon_sym_LBRACE] = ACTIONS(957),
    [anon_sym_AT_LBRACE] = ACTIONS(959),
    [anon_sym_SQUOTE] = ACTIONS(961),
    [anon_sym_SEMI] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(965),
    [anon_sym_COMMA] = ACTIONS(967),
    [anon_sym_PIPE] = ACTIONS(969),
    [sym_str_literal] = ACTIONS(971),
    [sym_buffer_literal] = ACTIONS(971),
    [aux_sym_number_literal_token1] = ACTIONS(973),
    [aux_sym_number_literal_token2] = ACTIONS(973),
    [aux_sym_number_literal_token3] = ACTIONS(973),
    [anon_sym_true] = ACTIONS(975),
    [anon_sym_false] = ACTIONS(975),
    [sym_nil_literal] = ACTIONS(977),
    [sym_keyword] = ACTIONS(979),
    [sym__long_str] = ACTIONS(981),
    [sym__long_buffer] = ACTIONS(983),
  },
  [189] = {
    [sym__expr] = STATE(478),
    [sym_tuple] = STATE(525),
    [sym_sqr_tuple] = STATE(525),
    [sym_array] = STATE(525),
    [sym_sqr_array] = STATE(525),
    [sym_struct] = STATE(525),
    [sym_table] = STATE(525),
    [sym_peg_set] = STATE(525),
    [sym__special_forms] = STATE(525),
    [sym_def] = STATE(524),
    [sym_var] = STATE(524),
    [sym_quote] = STATE(524),
    [sym_splice] = STATE(524),
    [sym_quasiquote] = STATE(524),
    [sym_unquote] = STATE(524),
    [sym_break] = STATE(524),
    [sym_set] = STATE(524),
    [sym_if] = STATE(524),
    [sym_do] = STATE(524),
    [sym_while] = STATE(524),
    [sym_fn] = STATE(524),
    [sym_upscope] = STATE(524),
    [sym__shorthand] = STATE(525),
    [sym_short_quote] = STATE(519),
    [sym_short_splice] = STATE(519),
    [sym_short_quasiquote] = STATE(519),
    [sym_short_unquote] = STATE(519),
    [sym_short_fn] = STATE(519),
    [sym__specials] = STATE(525),
    [sym_extra_defs] = STATE(518),
    [sym__literals] = STATE(525),
    [sym_long_str_literal] = STATE(528),
    [sym_long_buffer_literal] = STATE(528),
    [sym_number_literal] = STATE(528),
    [sym_bool_literal] = STATE(528),
    [sym__identifier] = STATE(525),
    [sym_symbol] = ACTIONS(947),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_LBRACK] = ACTIONS(951),
    [anon_sym_AT_LPAREN] = ACTIONS(953),
    [anon_sym_AT_LBRACK] = ACTIONS(955),
    [anon_sym_LBRACE] = ACTIONS(957),
    [anon_sym_AT_LBRACE] = ACTIONS(959),
    [anon_sym_SQUOTE] = ACTIONS(961),
    [anon_sym_SEMI] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(965),
    [anon_sym_COMMA] = ACTIONS(967),
    [anon_sym_PIPE] = ACTIONS(969),
    [sym_str_literal] = ACTIONS(971),
    [sym_buffer_literal] = ACTIONS(971),
    [aux_sym_number_literal_token1] = ACTIONS(973),
    [aux_sym_number_literal_token2] = ACTIONS(973),
    [aux_sym_number_literal_token3] = ACTIONS(973),
    [anon_sym_true] = ACTIONS(975),
    [anon_sym_false] = ACTIONS(975),
    [sym_nil_literal] = ACTIONS(977),
    [sym_keyword] = ACTIONS(979),
    [sym__long_str] = ACTIONS(981),
    [sym__long_buffer] = ACTIONS(983),
  },
  [190] = {
    [sym__expr] = STATE(91),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [191] = {
    [sym__expr] = STATE(449),
    [sym_tuple] = STATE(414),
    [sym_sqr_tuple] = STATE(414),
    [sym_array] = STATE(414),
    [sym_sqr_array] = STATE(414),
    [sym_struct] = STATE(414),
    [sym_table] = STATE(414),
    [sym_peg_set] = STATE(414),
    [sym__special_forms] = STATE(414),
    [sym_def] = STATE(435),
    [sym_var] = STATE(435),
    [sym_quote] = STATE(435),
    [sym_splice] = STATE(435),
    [sym_quasiquote] = STATE(435),
    [sym_unquote] = STATE(435),
    [sym_break] = STATE(435),
    [sym_set] = STATE(435),
    [sym_if] = STATE(435),
    [sym_do] = STATE(435),
    [sym_while] = STATE(435),
    [sym_fn] = STATE(435),
    [sym_upscope] = STATE(435),
    [sym__shorthand] = STATE(414),
    [sym_short_quote] = STATE(436),
    [sym_short_splice] = STATE(436),
    [sym_short_quasiquote] = STATE(436),
    [sym_short_unquote] = STATE(436),
    [sym_short_fn] = STATE(436),
    [sym__specials] = STATE(414),
    [sym_extra_defs] = STATE(438),
    [sym__literals] = STATE(414),
    [sym_long_str_literal] = STATE(398),
    [sym_long_buffer_literal] = STATE(398),
    [sym_number_literal] = STATE(398),
    [sym_bool_literal] = STATE(398),
    [sym__identifier] = STATE(414),
    [sym_symbol] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(31),
    [sym_buffer_literal] = ACTIONS(31),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(37),
    [sym_keyword] = ACTIONS(39),
    [sym__long_str] = ACTIONS(41),
    [sym__long_buffer] = ACTIONS(43),
  },
  [192] = {
    [sym__expr] = STATE(451),
    [sym_tuple] = STATE(414),
    [sym_sqr_tuple] = STATE(414),
    [sym_array] = STATE(414),
    [sym_sqr_array] = STATE(414),
    [sym_struct] = STATE(414),
    [sym_table] = STATE(414),
    [sym_peg_set] = STATE(414),
    [sym__special_forms] = STATE(414),
    [sym_def] = STATE(435),
    [sym_var] = STATE(435),
    [sym_quote] = STATE(435),
    [sym_splice] = STATE(435),
    [sym_quasiquote] = STATE(435),
    [sym_unquote] = STATE(435),
    [sym_break] = STATE(435),
    [sym_set] = STATE(435),
    [sym_if] = STATE(435),
    [sym_do] = STATE(435),
    [sym_while] = STATE(435),
    [sym_fn] = STATE(435),
    [sym_upscope] = STATE(435),
    [sym__shorthand] = STATE(414),
    [sym_short_quote] = STATE(436),
    [sym_short_splice] = STATE(436),
    [sym_short_quasiquote] = STATE(436),
    [sym_short_unquote] = STATE(436),
    [sym_short_fn] = STATE(436),
    [sym__specials] = STATE(414),
    [sym_extra_defs] = STATE(438),
    [sym__literals] = STATE(414),
    [sym_long_str_literal] = STATE(398),
    [sym_long_buffer_literal] = STATE(398),
    [sym_number_literal] = STATE(398),
    [sym_bool_literal] = STATE(398),
    [sym__identifier] = STATE(414),
    [sym_symbol] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(31),
    [sym_buffer_literal] = ACTIONS(31),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(37),
    [sym_keyword] = ACTIONS(39),
    [sym__long_str] = ACTIONS(41),
    [sym__long_buffer] = ACTIONS(43),
  },
  [193] = {
    [sym__expr] = STATE(452),
    [sym_tuple] = STATE(414),
    [sym_sqr_tuple] = STATE(414),
    [sym_array] = STATE(414),
    [sym_sqr_array] = STATE(414),
    [sym_struct] = STATE(414),
    [sym_table] = STATE(414),
    [sym_peg_set] = STATE(414),
    [sym__special_forms] = STATE(414),
    [sym_def] = STATE(435),
    [sym_var] = STATE(435),
    [sym_quote] = STATE(435),
    [sym_splice] = STATE(435),
    [sym_quasiquote] = STATE(435),
    [sym_unquote] = STATE(435),
    [sym_break] = STATE(435),
    [sym_set] = STATE(435),
    [sym_if] = STATE(435),
    [sym_do] = STATE(435),
    [sym_while] = STATE(435),
    [sym_fn] = STATE(435),
    [sym_upscope] = STATE(435),
    [sym__shorthand] = STATE(414),
    [sym_short_quote] = STATE(436),
    [sym_short_splice] = STATE(436),
    [sym_short_quasiquote] = STATE(436),
    [sym_short_unquote] = STATE(436),
    [sym_short_fn] = STATE(436),
    [sym__specials] = STATE(414),
    [sym_extra_defs] = STATE(438),
    [sym__literals] = STATE(414),
    [sym_long_str_literal] = STATE(398),
    [sym_long_buffer_literal] = STATE(398),
    [sym_number_literal] = STATE(398),
    [sym_bool_literal] = STATE(398),
    [sym__identifier] = STATE(414),
    [sym_symbol] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(31),
    [sym_buffer_literal] = ACTIONS(31),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(37),
    [sym_keyword] = ACTIONS(39),
    [sym__long_str] = ACTIONS(41),
    [sym__long_buffer] = ACTIONS(43),
  },
  [194] = {
    [sym__expr] = STATE(453),
    [sym_tuple] = STATE(414),
    [sym_sqr_tuple] = STATE(414),
    [sym_array] = STATE(414),
    [sym_sqr_array] = STATE(414),
    [sym_struct] = STATE(414),
    [sym_table] = STATE(414),
    [sym_peg_set] = STATE(414),
    [sym__special_forms] = STATE(414),
    [sym_def] = STATE(435),
    [sym_var] = STATE(435),
    [sym_quote] = STATE(435),
    [sym_splice] = STATE(435),
    [sym_quasiquote] = STATE(435),
    [sym_unquote] = STATE(435),
    [sym_break] = STATE(435),
    [sym_set] = STATE(435),
    [sym_if] = STATE(435),
    [sym_do] = STATE(435),
    [sym_while] = STATE(435),
    [sym_fn] = STATE(435),
    [sym_upscope] = STATE(435),
    [sym__shorthand] = STATE(414),
    [sym_short_quote] = STATE(436),
    [sym_short_splice] = STATE(436),
    [sym_short_quasiquote] = STATE(436),
    [sym_short_unquote] = STATE(436),
    [sym_short_fn] = STATE(436),
    [sym__specials] = STATE(414),
    [sym_extra_defs] = STATE(438),
    [sym__literals] = STATE(414),
    [sym_long_str_literal] = STATE(398),
    [sym_long_buffer_literal] = STATE(398),
    [sym_number_literal] = STATE(398),
    [sym_bool_literal] = STATE(398),
    [sym__identifier] = STATE(414),
    [sym_symbol] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(31),
    [sym_buffer_literal] = ACTIONS(31),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(37),
    [sym_keyword] = ACTIONS(39),
    [sym__long_str] = ACTIONS(41),
    [sym__long_buffer] = ACTIONS(43),
  },
  [195] = {
    [sym__expr] = STATE(457),
    [sym_tuple] = STATE(414),
    [sym_sqr_tuple] = STATE(414),
    [sym_array] = STATE(414),
    [sym_sqr_array] = STATE(414),
    [sym_struct] = STATE(414),
    [sym_table] = STATE(414),
    [sym_peg_set] = STATE(414),
    [sym__special_forms] = STATE(414),
    [sym_def] = STATE(435),
    [sym_var] = STATE(435),
    [sym_quote] = STATE(435),
    [sym_splice] = STATE(435),
    [sym_quasiquote] = STATE(435),
    [sym_unquote] = STATE(435),
    [sym_break] = STATE(435),
    [sym_set] = STATE(435),
    [sym_if] = STATE(435),
    [sym_do] = STATE(435),
    [sym_while] = STATE(435),
    [sym_fn] = STATE(435),
    [sym_upscope] = STATE(435),
    [sym__shorthand] = STATE(414),
    [sym_short_quote] = STATE(436),
    [sym_short_splice] = STATE(436),
    [sym_short_quasiquote] = STATE(436),
    [sym_short_unquote] = STATE(436),
    [sym_short_fn] = STATE(436),
    [sym__specials] = STATE(414),
    [sym_extra_defs] = STATE(438),
    [sym__literals] = STATE(414),
    [sym_long_str_literal] = STATE(398),
    [sym_long_buffer_literal] = STATE(398),
    [sym_number_literal] = STATE(398),
    [sym_bool_literal] = STATE(398),
    [sym__identifier] = STATE(414),
    [sym_symbol] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(31),
    [sym_buffer_literal] = ACTIONS(31),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(37),
    [sym_keyword] = ACTIONS(39),
    [sym__long_str] = ACTIONS(41),
    [sym__long_buffer] = ACTIONS(43),
  },
  [196] = {
    [sym__expr] = STATE(66),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [197] = {
    [sym__expr] = STATE(217),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [198] = {
    [sym__expr] = STATE(70),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [199] = {
    [sym__expr] = STATE(73),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [200] = {
    [sym__expr] = STATE(174),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [201] = {
    [sym__expr] = STATE(81),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [202] = {
    [sym__expr] = STATE(83),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [203] = {
    [sym__expr] = STATE(173),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [204] = {
    [sym__expr] = STATE(79),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [205] = {
    [sym__expr] = STATE(94),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [206] = {
    [sym__expr] = STATE(216),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(450),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(445),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(458),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(985),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [207] = {
    [sym__expr] = STATE(71),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [208] = {
    [sym__expr] = STATE(72),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [209] = {
    [sym__expr] = STATE(224),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [210] = {
    [sym__expr] = STATE(87),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [211] = {
    [sym__expr] = STATE(143),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [212] = {
    [sym__expr] = STATE(424),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [213] = {
    [sym__expr] = STATE(604),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [214] = {
    [sym__expr] = STATE(106),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [215] = {
    [sym__expr] = STATE(213),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(413),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(415),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(410),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(987),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [216] = {
    [sym__expr] = STATE(617),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [217] = {
    [sym__expr] = STATE(158),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [218] = {
    [sym__expr] = STATE(67),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [219] = {
    [sym__expr] = STATE(558),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [220] = {
    [sym__expr] = STATE(219),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(368),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(408),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(369),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(989),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [221] = {
    [sym__expr] = STATE(223),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(404),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(403),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(405),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(991),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [222] = {
    [sym__expr] = STATE(90),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [223] = {
    [sym__expr] = STATE(578),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [224] = {
    [sym__expr] = STATE(155),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [225] = {
    [sym__expr] = STATE(233),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(455),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(456),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(454),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(993),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [226] = {
    [sym__expr] = STATE(141),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [227] = {
    [sym__expr] = STATE(211),
    [sym_tuple] = STATE(347),
    [sym_sqr_tuple] = STATE(347),
    [sym_array] = STATE(347),
    [sym_sqr_array] = STATE(347),
    [sym_struct] = STATE(347),
    [sym_table] = STATE(347),
    [sym_peg_set] = STATE(347),
    [sym__special_forms] = STATE(347),
    [sym_def] = STATE(335),
    [sym_var] = STATE(335),
    [sym_quote] = STATE(335),
    [sym_splice] = STATE(335),
    [sym_quasiquote] = STATE(335),
    [sym_unquote] = STATE(335),
    [sym_break] = STATE(335),
    [sym_set] = STATE(335),
    [sym_if] = STATE(335),
    [sym_do] = STATE(335),
    [sym_while] = STATE(335),
    [sym_fn] = STATE(335),
    [sym_upscope] = STATE(335),
    [sym__shorthand] = STATE(347),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(347),
    [sym_extra_defs] = STATE(312),
    [sym__literals] = STATE(347),
    [sym_long_str_literal] = STATE(334),
    [sym_long_buffer_literal] = STATE(334),
    [sym_number_literal] = STATE(334),
    [sym_bool_literal] = STATE(334),
    [sym__identifier] = STATE(347),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [228] = {
    [sym__expr] = STATE(610),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [229] = {
    [sym__expr] = STATE(611),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [230] = {
    [sym__expr] = STATE(619),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [231] = {
    [sym__expr] = STATE(620),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [232] = {
    [sym__expr] = STATE(621),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
  [233] = {
    [sym__expr] = STATE(645),
    [sym_tuple] = STATE(588),
    [sym_sqr_tuple] = STATE(588),
    [sym_array] = STATE(588),
    [sym_sqr_array] = STATE(588),
    [sym_struct] = STATE(588),
    [sym_table] = STATE(588),
    [sym_peg_set] = STATE(588),
    [sym__special_forms] = STATE(588),
    [sym_def] = STATE(589),
    [sym_var] = STATE(589),
    [sym_quote] = STATE(589),
    [sym_splice] = STATE(589),
    [sym_quasiquote] = STATE(589),
    [sym_unquote] = STATE(589),
    [sym_break] = STATE(589),
    [sym_set] = STATE(589),
    [sym_if] = STATE(589),
    [sym_do] = STATE(589),
    [sym_while] = STATE(589),
    [sym_fn] = STATE(589),
    [sym_upscope] = STATE(589),
    [sym__shorthand] = STATE(588),
    [sym_short_quote] = STATE(591),
    [sym_short_splice] = STATE(591),
    [sym_short_quasiquote] = STATE(591),
    [sym_short_unquote] = STATE(591),
    [sym_short_fn] = STATE(591),
    [sym__specials] = STATE(588),
    [sym_extra_defs] = STATE(592),
    [sym__literals] = STATE(588),
    [sym_long_str_literal] = STATE(574),
    [sym_long_buffer_literal] = STATE(574),
    [sym_number_literal] = STATE(574),
    [sym_bool_literal] = STATE(574),
    [sym__identifier] = STATE(588),
    [sym_symbol] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_AT_LPAREN] = ACTIONS(629),
    [anon_sym_AT_LBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT_LBRACE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(635),
    [sym_str_literal] = ACTIONS(639),
    [sym_buffer_literal] = ACTIONS(639),
    [aux_sym_number_literal_token1] = ACTIONS(641),
    [aux_sym_number_literal_token2] = ACTIONS(641),
    [aux_sym_number_literal_token3] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(643),
    [anon_sym_false] = ACTIONS(643),
    [sym_nil_literal] = ACTIONS(645),
    [sym_keyword] = ACTIONS(885),
    [sym__long_str] = ACTIONS(887),
    [sym__long_buffer] = ACTIONS(649),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(997), 1,
      anon_sym_LPAREN,
    ACTIONS(1002), 1,
      anon_sym_LBRACE,
    ACTIONS(1005), 1,
      anon_sym_SQUOTE,
    ACTIONS(1008), 1,
      anon_sym_SEMI,
    ACTIONS(1011), 1,
      anon_sym_TILDE,
    ACTIONS(1014), 1,
      anon_sym_COMMA,
    ACTIONS(1020), 1,
      sym__long_str,
    STATE(234), 1,
      aux_sym_def_repeat1,
    STATE(461), 1,
      sym_metadata,
    ACTIONS(1017), 2,
      sym_str_literal,
      sym_keyword,
    ACTIONS(995), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1000), 7,
      sym__long_buffer,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_AT_LBRACE,
      anon_sym_PIPE,
      sym_buffer_literal,
    STATE(459), 10,
      sym_struct,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym_long_str_literal,
  [65] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1023), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1025), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [101] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1027), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1029), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [137] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1031), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1033), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [173] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1035), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1037), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [209] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1039), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1041), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [245] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1043), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1045), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [281] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1047), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1049), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [317] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1051), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1053), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [353] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1055), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1057), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [389] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1059), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1061), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [425] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1063), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1065), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [461] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1067), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1069), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [497] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1071), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1073), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [533] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1075), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1077), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [569] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1079), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1081), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [605] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1083), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1085), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [641] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1087), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1089), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [677] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1091), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1093), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [713] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1095), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1097), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [749] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1099), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1101), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [785] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1103), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1105), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [821] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1107), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1109), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [857] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1111), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1113), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [893] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1115), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1117), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [929] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1119), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1121), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [965] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1123), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1125), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1001] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1127), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1129), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1037] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1131), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1133), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1073] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1135), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1137), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1109] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1139), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1141), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1145] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1143), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1145), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1181] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1147), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1149), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1217] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1151), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1153), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1253] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1155), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1157), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1289] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1159), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1161), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1325] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1163), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1165), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1361] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1167), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1169), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1397] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1171), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1173), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1433] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1175), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1177), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1469] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1179), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1181), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1505] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1183), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1185), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1541] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1187), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1189), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1577] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1191), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1193), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1613] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1195), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1197), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1649] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1199), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1201), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1685] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1203), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1205), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1721] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1207), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1209), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1757] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1211), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1213), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1793] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1215), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1217), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1829] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1219), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1221), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1865] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1223), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1225), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1901] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1227), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1229), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1937] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1231), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1233), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1973] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1235), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1237), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2009] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1239), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1241), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2045] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1243), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1245), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2081] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1247), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1249), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2117] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1251), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1253), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2153] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1255), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1257), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2189] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1259), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1261), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2225] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(957), 1,
      anon_sym_LBRACE,
    ACTIONS(981), 1,
      sym__long_str,
    ACTIONS(1263), 1,
      anon_sym_LPAREN,
    ACTIONS(1265), 1,
      anon_sym_LBRACK,
    ACTIONS(1267), 1,
      sym_str_literal,
    ACTIONS(1269), 1,
      sym_keyword,
    STATE(460), 1,
      aux_sym_def_repeat1,
    STATE(523), 1,
      sym_metadata,
    STATE(512), 2,
      sym_struct,
      sym_long_str_literal,
    STATE(54), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(390), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [2288] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(957), 1,
      anon_sym_LBRACE,
    ACTIONS(981), 1,
      sym__long_str,
    ACTIONS(1263), 1,
      anon_sym_LPAREN,
    ACTIONS(1265), 1,
      anon_sym_LBRACK,
    ACTIONS(1267), 1,
      sym_str_literal,
    ACTIONS(1269), 1,
      sym_keyword,
    STATE(303), 1,
      aux_sym_def_repeat1,
    STATE(523), 1,
      sym_metadata,
    STATE(512), 2,
      sym_struct,
      sym_long_str_literal,
    STATE(34), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(390), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [2351] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(957), 1,
      anon_sym_LBRACE,
    ACTIONS(981), 1,
      sym__long_str,
    ACTIONS(1263), 1,
      anon_sym_LPAREN,
    ACTIONS(1265), 1,
      anon_sym_LBRACK,
    ACTIONS(1267), 1,
      sym_str_literal,
    ACTIONS(1269), 1,
      sym_keyword,
    STATE(298), 1,
      aux_sym_def_repeat1,
    STATE(523), 1,
      sym_metadata,
    STATE(512), 2,
      sym_struct,
      sym_long_str_literal,
    STATE(47), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(390), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [2414] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(957), 1,
      anon_sym_LBRACE,
    ACTIONS(981), 1,
      sym__long_str,
    ACTIONS(1263), 1,
      anon_sym_LPAREN,
    ACTIONS(1265), 1,
      anon_sym_LBRACK,
    ACTIONS(1267), 1,
      sym_str_literal,
    ACTIONS(1269), 1,
      sym_keyword,
    STATE(460), 1,
      aux_sym_def_repeat1,
    STATE(523), 1,
      sym_metadata,
    STATE(512), 2,
      sym_struct,
      sym_long_str_literal,
    STATE(49), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(390), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [2477] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(957), 1,
      anon_sym_LBRACE,
    ACTIONS(981), 1,
      sym__long_str,
    ACTIONS(1263), 1,
      anon_sym_LPAREN,
    ACTIONS(1265), 1,
      anon_sym_LBRACK,
    ACTIONS(1267), 1,
      sym_str_literal,
    ACTIONS(1269), 1,
      sym_keyword,
    STATE(300), 1,
      aux_sym_def_repeat1,
    STATE(523), 1,
      sym_metadata,
    STATE(512), 2,
      sym_struct,
      sym_long_str_literal,
    STATE(42), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(390), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [2540] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(957), 1,
      anon_sym_LBRACE,
    ACTIONS(981), 1,
      sym__long_str,
    ACTIONS(1263), 1,
      anon_sym_LPAREN,
    ACTIONS(1265), 1,
      anon_sym_LBRACK,
    ACTIONS(1267), 1,
      sym_str_literal,
    ACTIONS(1269), 1,
      sym_keyword,
    STATE(460), 1,
      aux_sym_def_repeat1,
    STATE(523), 1,
      sym_metadata,
    STATE(512), 2,
      sym_struct,
      sym_long_str_literal,
    STATE(33), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(390), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [2603] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(957), 1,
      anon_sym_LBRACE,
    ACTIONS(981), 1,
      sym__long_str,
    ACTIONS(1263), 1,
      anon_sym_LPAREN,
    ACTIONS(1265), 1,
      anon_sym_LBRACK,
    ACTIONS(1267), 1,
      sym_str_literal,
    ACTIONS(1269), 1,
      sym_keyword,
    STATE(302), 1,
      aux_sym_def_repeat1,
    STATE(523), 1,
      sym_metadata,
    STATE(512), 2,
      sym_struct,
      sym_long_str_literal,
    STATE(28), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(390), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [2666] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(957), 1,
      anon_sym_LBRACE,
    ACTIONS(981), 1,
      sym__long_str,
    ACTIONS(1263), 1,
      anon_sym_LPAREN,
    ACTIONS(1265), 1,
      anon_sym_LBRACK,
    ACTIONS(1267), 1,
      sym_str_literal,
    ACTIONS(1269), 1,
      sym_keyword,
    STATE(460), 1,
      aux_sym_def_repeat1,
    STATE(523), 1,
      sym_metadata,
    STATE(512), 2,
      sym_struct,
      sym_long_str_literal,
    STATE(31), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(390), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [2729] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(957), 1,
      anon_sym_LBRACE,
    ACTIONS(981), 1,
      sym__long_str,
    ACTIONS(1263), 1,
      anon_sym_LPAREN,
    ACTIONS(1265), 1,
      anon_sym_LBRACK,
    ACTIONS(1267), 1,
      sym_str_literal,
    ACTIONS(1269), 1,
      sym_keyword,
    STATE(460), 1,
      aux_sym_def_repeat1,
    STATE(523), 1,
      sym_metadata,
    STATE(512), 2,
      sym_struct,
      sym_long_str_literal,
    STATE(21), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(390), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [2792] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(957), 1,
      anon_sym_LBRACE,
    ACTIONS(981), 1,
      sym__long_str,
    ACTIONS(1263), 1,
      anon_sym_LPAREN,
    ACTIONS(1265), 1,
      anon_sym_LBRACK,
    ACTIONS(1267), 1,
      sym_str_literal,
    ACTIONS(1269), 1,
      sym_keyword,
    STATE(295), 1,
      aux_sym_def_repeat1,
    STATE(523), 1,
      sym_metadata,
    STATE(512), 2,
      sym_struct,
      sym_long_str_literal,
    STATE(52), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(390), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [2855] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1247), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1249), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2889] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1227), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1229), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2923] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1135), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1137), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2957] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1131), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1133), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2991] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1179), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1181), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3025] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1183), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1185), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3059] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1187), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1189), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3093] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1191), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1193), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3127] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1195), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1197), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3161] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1127), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1129), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3195] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1123), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1125), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3229] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1115), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1117), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3263] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1111), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1113), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3297] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1219), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1221), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3331] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1107), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1109), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3365] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1103), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1105), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3399] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1099), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1101), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3433] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1171), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1173), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3467] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1091), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1093), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3501] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1239), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1241), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3535] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1095), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1097), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3569] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1223), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1225), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3603] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1235), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1237), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3637] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1167), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1169), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3671] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1251), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1253), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3705] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1231), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1233), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3739] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1027), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1029), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3773] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1259), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1261), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3807] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1255), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1257), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3841] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1215), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1217), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3875] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1199), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1201), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3909] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1243), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1245), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3943] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1203), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1205), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3977] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1163), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1165), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4011] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1159), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1161), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4045] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1175), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1177), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4079] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1143), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1145), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4113] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1147), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1149), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4147] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1151), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1153), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4181] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1155), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1157), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4215] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1119), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1121), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4249] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1031), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1033), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4283] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1023), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1025), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4317] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1139), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1141), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4351] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1207), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1209), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4385] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1211), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1213), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4419] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1035), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1037), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4453] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1039), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1041), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4487] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1043), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1045), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4521] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1047), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1049), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4555] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1051), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1053), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4589] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1055), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1057), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4623] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1059), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1061), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4657] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1063), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1065), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4691] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1067), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1069), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4725] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1071), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1073), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4759] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1079), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1081), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4793] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1087), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1089), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4827] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1083), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1085), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4861] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1075), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1077), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4894] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1271), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1273), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4927] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1275), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1277), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4959] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1247), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1249), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4991] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1279), 1,
      anon_sym_RPAREN,
    ACTIONS(1199), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1201), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5025] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1279), 1,
      anon_sym_RPAREN,
    ACTIONS(1215), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1217), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5059] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1047), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1049), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5091] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1043), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1045), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5123] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1039), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1041), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5155] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1035), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1037), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5187] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1031), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1033), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5219] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1119), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1121), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5251] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1281), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1283), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5283] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1285), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1287), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5315] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1155), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1157), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5347] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1151), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1153), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5379] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1147), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1149), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5411] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1289), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1291), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5443] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1143), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1145), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5475] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1293), 1,
      sym_symbol,
    ACTIONS(1139), 6,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
    ACTIONS(1141), 7,
      sym__long_buffer,
      anon_sym_RPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_AT_LBRACE,
      anon_sym_PIPE,
      sym_buffer_literal,
    ACTIONS(1295), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5511] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1297), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1299), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5543] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1051), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1053), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5575] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1055), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1057), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5607] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1059), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1061), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5639] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1063), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1065), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5671] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1067), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1069), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5703] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1293), 1,
      sym_symbol,
    ACTIONS(1303), 6,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
    ACTIONS(1301), 7,
      sym__long_buffer,
      anon_sym_RPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_AT_LBRACE,
      anon_sym_PIPE,
      sym_buffer_literal,
    ACTIONS(1295), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5739] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1071), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1073), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5771] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1223), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1225), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5803] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1079), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1081), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5835] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1305), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1307), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5867] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1309), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1311), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5899] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1083), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1085), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5931] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1219), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1221), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5963] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1215), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1217), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5995] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1211), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1213), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6027] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1087), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1089), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6059] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1091), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1093), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6091] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1259), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1261), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6123] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1313), 1,
      anon_sym_RPAREN,
    ACTIONS(1195), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1197), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6157] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1313), 1,
      anon_sym_RPAREN,
    ACTIONS(1199), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1201), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6191] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1313), 1,
      anon_sym_RPAREN,
    ACTIONS(1215), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1217), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6225] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1255), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1257), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6257] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1251), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1253), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6289] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1279), 1,
      anon_sym_RPAREN,
    ACTIONS(1195), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1197), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6323] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1315), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1317), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6355] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1319), 1,
      anon_sym_RPAREN,
    ACTIONS(1215), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1217), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6389] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1207), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1209), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6421] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1139), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1141), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6453] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1319), 1,
      anon_sym_RPAREN,
    ACTIONS(1199), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1201), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6487] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1023), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1025), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6519] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1319), 1,
      anon_sym_RPAREN,
    ACTIONS(1195), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1197), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6553] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1197), 1,
      anon_sym_RPAREN,
    ACTIONS(1293), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1295), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6587] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1201), 1,
      anon_sym_RPAREN,
    ACTIONS(1293), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1295), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6621] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1025), 1,
      anon_sym_RPAREN,
    ACTIONS(1293), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1295), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6655] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1141), 1,
      anon_sym_RPAREN,
    ACTIONS(1293), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1295), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6689] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1217), 1,
      anon_sym_RPAREN,
    ACTIONS(1293), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1295), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6723] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1095), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1097), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6755] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1099), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1101), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6787] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1103), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1105), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6819] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1321), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1323), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6851] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1107), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1109), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6883] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1111), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1113), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6915] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1115), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1117), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6947] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1123), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1125), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6979] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1127), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1129), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7011] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1325), 1,
      sym_symbol,
    ACTIONS(1303), 6,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
    ACTIONS(1327), 7,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_keyword,
    ACTIONS(1301), 10,
      sym__long_str,
      sym__long_buffer,
      anon_sym_RPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
  [7047] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1329), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1331), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7079] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1131), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1133), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7111] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1135), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1137), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7143] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1243), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1245), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7175] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1199), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1201), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7207] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1195), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1197), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7239] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1239), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1241), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7271] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1191), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1193), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7303] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1187), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1189), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7335] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1235), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1237), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7367] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1231), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1233), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7399] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1183), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1185), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7431] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1179), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1181), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7463] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1175), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1177), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7495] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1333), 1,
      anon_sym_RPAREN,
    ACTIONS(1195), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1197), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7529] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1171), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1173), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7561] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1335), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1337), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7593] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1167), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1169), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7625] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1159), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1161), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7657] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1333), 1,
      anon_sym_RPAREN,
    ACTIONS(1199), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1201), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7691] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1163), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1165), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7723] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1203), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1205), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7755] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1227), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1229), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7787] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1339), 1,
      anon_sym_RPAREN,
    ACTIONS(1215), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1217), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7821] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1339), 1,
      anon_sym_RPAREN,
    ACTIONS(1199), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1201), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7855] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1339), 1,
      anon_sym_RPAREN,
    ACTIONS(1195), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1197), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7889] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1027), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1029), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7921] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1333), 1,
      anon_sym_RPAREN,
    ACTIONS(1215), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1217), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7955] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1293), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1295), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7986] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(995), 1,
      sym_symbol,
    ACTIONS(1000), 1,
      anon_sym_LBRACK,
    ACTIONS(1341), 1,
      anon_sym_LPAREN,
    ACTIONS(1344), 1,
      anon_sym_LBRACE,
    ACTIONS(1347), 1,
      anon_sym_SQUOTE,
    ACTIONS(1350), 1,
      anon_sym_SEMI,
    ACTIONS(1353), 1,
      anon_sym_TILDE,
    ACTIONS(1356), 1,
      anon_sym_COMMA,
    ACTIONS(1362), 1,
      sym__long_str,
    STATE(460), 1,
      aux_sym_def_repeat1,
    STATE(523), 1,
      sym_metadata,
    ACTIONS(1359), 2,
      sym_str_literal,
      sym_keyword,
    STATE(512), 10,
      sym_struct,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym_long_str_literal,
  [8039] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1365), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1367), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [8070] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1263), 1,
      anon_sym_LPAREN,
    ACTIONS(1265), 1,
      anon_sym_LBRACK,
    STATE(470), 1,
      sym__name,
    STATE(63), 3,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
    STATE(430), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8117] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1263), 1,
      anon_sym_LPAREN,
    ACTIONS(1265), 1,
      anon_sym_LBRACK,
    STATE(467), 1,
      sym__name,
    STATE(26), 3,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
    STATE(430), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8164] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1263), 1,
      anon_sym_LPAREN,
    ACTIONS(1265), 1,
      anon_sym_LBRACK,
    STATE(469), 1,
      sym__name,
    STATE(65), 3,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
    STATE(430), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8211] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1263), 1,
      anon_sym_LPAREN,
    ACTIONS(1265), 1,
      anon_sym_LBRACK,
    STATE(468), 1,
      sym__name,
    STATE(50), 3,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
    STATE(430), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8258] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1263), 1,
      anon_sym_LPAREN,
    ACTIONS(1265), 1,
      anon_sym_LBRACK,
    STATE(471), 1,
      sym__name,
    STATE(37), 3,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
    STATE(430), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8305] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1263), 1,
      anon_sym_LPAREN,
    ACTIONS(1265), 1,
      anon_sym_LBRACK,
    STATE(27), 12,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8347] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1263), 1,
      anon_sym_LPAREN,
    ACTIONS(1265), 1,
      anon_sym_LBRACK,
    STATE(51), 12,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8389] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1263), 1,
      anon_sym_LPAREN,
    ACTIONS(1265), 1,
      anon_sym_LBRACK,
    STATE(59), 12,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8431] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1263), 1,
      anon_sym_LPAREN,
    ACTIONS(1265), 1,
      anon_sym_LBRACK,
    STATE(39), 12,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8473] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1263), 1,
      anon_sym_LPAREN,
    ACTIONS(1265), 1,
      anon_sym_LBRACK,
    STATE(43), 12,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8515] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(947), 1,
      sym_symbol,
    ACTIONS(961), 1,
      anon_sym_SQUOTE,
    ACTIONS(963), 1,
      anon_sym_SEMI,
    ACTIONS(965), 1,
      anon_sym_TILDE,
    ACTIONS(967), 1,
      anon_sym_COMMA,
    ACTIONS(979), 1,
      sym_keyword,
    ACTIONS(1369), 1,
      anon_sym_LPAREN,
    STATE(299), 10,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__name,
      sym__identifier,
  [8552] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(947), 1,
      sym_symbol,
    ACTIONS(961), 1,
      anon_sym_SQUOTE,
    ACTIONS(963), 1,
      anon_sym_SEMI,
    ACTIONS(965), 1,
      anon_sym_TILDE,
    ACTIONS(967), 1,
      anon_sym_COMMA,
    ACTIONS(979), 1,
      sym_keyword,
    ACTIONS(1369), 1,
      anon_sym_LPAREN,
    STATE(296), 10,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__name,
      sym__identifier,
  [8589] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(947), 1,
      sym_symbol,
    ACTIONS(961), 1,
      anon_sym_SQUOTE,
    ACTIONS(963), 1,
      anon_sym_SEMI,
    ACTIONS(965), 1,
      anon_sym_TILDE,
    ACTIONS(967), 1,
      anon_sym_COMMA,
    ACTIONS(979), 1,
      sym_keyword,
    ACTIONS(1369), 1,
      anon_sym_LPAREN,
    STATE(297), 10,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__name,
      sym__identifier,
  [8626] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(947), 1,
      sym_symbol,
    ACTIONS(961), 1,
      anon_sym_SQUOTE,
    ACTIONS(963), 1,
      anon_sym_SEMI,
    ACTIONS(965), 1,
      anon_sym_TILDE,
    ACTIONS(967), 1,
      anon_sym_COMMA,
    ACTIONS(979), 1,
      sym_keyword,
    ACTIONS(1369), 1,
      anon_sym_LPAREN,
    STATE(304), 10,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__name,
      sym__identifier,
  [8663] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(947), 1,
      sym_symbol,
    ACTIONS(961), 1,
      anon_sym_SQUOTE,
    ACTIONS(963), 1,
      anon_sym_SEMI,
    ACTIONS(965), 1,
      anon_sym_TILDE,
    ACTIONS(967), 1,
      anon_sym_COMMA,
    ACTIONS(979), 1,
      sym_keyword,
    ACTIONS(1369), 1,
      anon_sym_LPAREN,
    STATE(301), 10,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__name,
      sym__identifier,
  [8700] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1111), 1,
      sym_symbol,
    ACTIONS(1113), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8719] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1159), 1,
      sym_symbol,
    ACTIONS(1161), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8738] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1035), 1,
      sym_symbol,
    ACTIONS(1037), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8757] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1227), 1,
      sym_symbol,
    ACTIONS(1229), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8776] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1039), 1,
      sym_symbol,
    ACTIONS(1041), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8795] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1043), 1,
      sym_symbol,
    ACTIONS(1045), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8814] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1047), 1,
      sym_symbol,
    ACTIONS(1049), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8833] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1051), 1,
      sym_symbol,
    ACTIONS(1053), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8852] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1055), 1,
      sym_symbol,
    ACTIONS(1057), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8871] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1059), 1,
      sym_symbol,
    ACTIONS(1061), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8890] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1063), 1,
      sym_symbol,
    ACTIONS(1065), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8909] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1067), 1,
      sym_symbol,
    ACTIONS(1069), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8928] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1071), 1,
      sym_symbol,
    ACTIONS(1073), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8947] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1079), 1,
      sym_symbol,
    ACTIONS(1081), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8966] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1083), 1,
      sym_symbol,
    ACTIONS(1085), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [8985] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1087), 1,
      sym_symbol,
    ACTIONS(1089), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9004] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9023] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1095), 1,
      sym_symbol,
    ACTIONS(1097), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9042] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1099), 1,
      sym_symbol,
    ACTIONS(1101), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9061] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1143), 1,
      sym_symbol,
    ACTIONS(1145), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9080] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1103), 1,
      sym_symbol,
    ACTIONS(1105), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9099] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1107), 1,
      sym_symbol,
    ACTIONS(1109), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9118] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1031), 1,
      sym_symbol,
    ACTIONS(1033), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9137] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1115), 1,
      sym_symbol,
    ACTIONS(1117), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9156] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1123), 1,
      sym_symbol,
    ACTIONS(1125), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9175] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1127), 1,
      sym_symbol,
    ACTIONS(1129), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9194] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1131), 1,
      sym_symbol,
    ACTIONS(1133), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9213] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1135), 1,
      sym_symbol,
    ACTIONS(1137), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9232] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1119), 1,
      sym_symbol,
    ACTIONS(1121), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9251] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1027), 1,
      sym_symbol,
    ACTIONS(1029), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9270] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1139), 1,
      sym_symbol,
    ACTIONS(1141), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9289] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1231), 1,
      sym_symbol,
    ACTIONS(1233), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9308] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1163), 1,
      sym_symbol,
    ACTIONS(1165), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9327] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1155), 1,
      sym_symbol,
    ACTIONS(1157), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9346] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1167), 1,
      sym_symbol,
    ACTIONS(1169), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9365] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1293), 1,
      sym_symbol,
    ACTIONS(1295), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9384] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1171), 1,
      sym_symbol,
    ACTIONS(1173), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9403] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1175), 1,
      sym_symbol,
    ACTIONS(1177), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9422] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1179), 1,
      sym_symbol,
    ACTIONS(1181), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9441] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1183), 1,
      sym_symbol,
    ACTIONS(1185), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9460] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1187), 1,
      sym_symbol,
    ACTIONS(1189), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9479] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1191), 1,
      sym_symbol,
    ACTIONS(1193), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9498] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1195), 1,
      sym_symbol,
    ACTIONS(1197), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9517] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1203), 1,
      sym_symbol,
    ACTIONS(1205), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9536] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1151), 1,
      sym_symbol,
    ACTIONS(1153), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9555] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1147), 1,
      sym_symbol,
    ACTIONS(1149), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9574] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1365), 1,
      sym_symbol,
    ACTIONS(1367), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9593] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1199), 1,
      sym_symbol,
    ACTIONS(1201), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9612] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1023), 1,
      sym_symbol,
    ACTIONS(1025), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9631] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1207), 1,
      sym_symbol,
    ACTIONS(1209), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9650] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1211), 1,
      sym_symbol,
    ACTIONS(1213), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9669] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1215), 1,
      sym_symbol,
    ACTIONS(1217), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9688] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1219), 1,
      sym_symbol,
    ACTIONS(1221), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9707] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1223), 1,
      sym_symbol,
    ACTIONS(1225), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9726] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1259), 1,
      sym_symbol,
    ACTIONS(1261), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9745] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1255), 1,
      sym_symbol,
    ACTIONS(1257), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9764] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1251), 1,
      sym_symbol,
    ACTIONS(1253), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9783] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1247), 1,
      sym_symbol,
    ACTIONS(1249), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9802] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1243), 1,
      sym_symbol,
    ACTIONS(1245), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9821] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1239), 1,
      sym_symbol,
    ACTIONS(1241), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9840] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1235), 1,
      sym_symbol,
    ACTIONS(1237), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9859] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1371), 1,
      anon_sym_quote,
    ACTIONS(1373), 1,
      anon_sym_splice,
    ACTIONS(1375), 1,
      anon_sym_quasiquote,
    ACTIONS(1377), 1,
      anon_sym_unquote,
  [9875] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1379), 1,
      anon_sym_quote,
    ACTIONS(1381), 1,
      anon_sym_splice,
    ACTIONS(1383), 1,
      anon_sym_quasiquote,
    ACTIONS(1385), 1,
      anon_sym_unquote,
  [9891] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1387), 1,
      anon_sym_RPAREN,
  [9898] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1389), 1,
      anon_sym_RPAREN,
  [9905] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1391), 1,
      anon_sym_RPAREN,
  [9912] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1393), 1,
      anon_sym_RPAREN,
  [9919] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1395), 1,
      anon_sym_RPAREN,
  [9926] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1397), 1,
      anon_sym_RPAREN,
  [9933] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1399), 1,
      anon_sym_RPAREN,
  [9940] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1401), 1,
      anon_sym_RPAREN,
  [9947] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1403), 1,
      anon_sym_RPAREN,
  [9954] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1405), 1,
      anon_sym_RPAREN,
  [9961] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1407), 1,
      anon_sym_RPAREN,
  [9968] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1409), 1,
      anon_sym_RPAREN,
  [9975] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1411), 1,
      anon_sym_RPAREN,
  [9982] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1413), 1,
      anon_sym_RPAREN,
  [9989] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1415), 1,
      anon_sym_RPAREN,
  [9996] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1225), 1,
      anon_sym_RPAREN,
  [10003] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1417), 1,
      anon_sym_RPAREN,
  [10010] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1419), 1,
      anon_sym_RPAREN,
  [10017] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1421), 1,
      anon_sym_RPAREN,
  [10024] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1423), 1,
      anon_sym_RPAREN,
  [10031] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1425), 1,
      anon_sym_RPAREN,
  [10038] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1045), 1,
      anon_sym_RPAREN,
  [10045] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1427), 1,
      anon_sym_RPAREN,
  [10052] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1429), 1,
      anon_sym_RPAREN,
  [10059] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1221), 1,
      anon_sym_RPAREN,
  [10066] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1431), 1,
      anon_sym_RPAREN,
  [10073] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1433), 1,
      anon_sym_RPAREN,
  [10080] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1435), 1,
      anon_sym_RPAREN,
  [10087] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1437), 1,
      anon_sym_RPAREN,
  [10094] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1439), 1,
      anon_sym_RPAREN,
  [10101] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1441), 1,
      anon_sym_RPAREN,
  [10108] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1443), 1,
      anon_sym_RPAREN,
  [10115] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1445), 1,
      anon_sym_RPAREN,
  [10122] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1447), 1,
      anon_sym_RPAREN,
  [10129] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1217), 1,
      anon_sym_RPAREN,
  [10136] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1213), 1,
      anon_sym_RPAREN,
  [10143] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1449), 1,
      anon_sym_RPAREN,
  [10150] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1451), 1,
      anon_sym_RPAREN,
  [10157] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1453), 1,
      anon_sym_RPAREN,
  [10164] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1455), 1,
      anon_sym_RPAREN,
  [10171] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1209), 1,
      anon_sym_RPAREN,
  [10178] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1141), 1,
      anon_sym_RPAREN,
  [10185] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1457), 1,
      anon_sym_RPAREN,
  [10192] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1459), 1,
      anon_sym_RPAREN,
  [10199] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1461), 1,
      anon_sym_RPAREN,
  [10206] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1463), 1,
      anon_sym_RPAREN,
  [10213] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1465), 1,
      anon_sym_RPAREN,
  [10220] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1467), 1,
      anon_sym_RPAREN,
  [10227] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1025), 1,
      anon_sym_RPAREN,
  [10234] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1201), 1,
      anon_sym_RPAREN,
  [10241] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1469), 1,
      anon_sym_RPAREN,
  [10248] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1197), 1,
      anon_sym_RPAREN,
  [10255] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1193), 1,
      anon_sym_RPAREN,
  [10262] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1185), 1,
      anon_sym_RPAREN,
  [10269] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1181), 1,
      anon_sym_RPAREN,
  [10276] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1471), 1,
      anon_sym_RPAREN,
  [10283] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1473), 1,
      anon_sym_RPAREN,
  [10290] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1475), 1,
      anon_sym_RPAREN,
  [10297] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1477), 1,
      anon_sym_RPAREN,
  [10304] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1479), 1,
      anon_sym_RPAREN,
  [10311] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1481), 1,
      anon_sym_RPAREN,
  [10318] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1177), 1,
      anon_sym_RPAREN,
  [10325] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1173), 1,
      anon_sym_RPAREN,
  [10332] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1483), 1,
      anon_sym_RPAREN,
  [10339] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1485), 1,
      anon_sym_RPAREN,
  [10346] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1487), 1,
      anon_sym_RPAREN,
  [10353] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1489), 1,
      anon_sym_RPAREN,
  [10360] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1169), 1,
      anon_sym_RPAREN,
  [10367] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1491), 1,
      anon_sym_RPAREN,
  [10374] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1493), 1,
      anon_sym_RPAREN,
  [10381] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1161), 1,
      anon_sym_RPAREN,
  [10388] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1165), 1,
      anon_sym_RPAREN,
  [10395] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1495), 1,
      anon_sym_RPAREN,
  [10402] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1497), 1,
      anon_sym_RPAREN,
  [10409] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1499), 1,
      anon_sym_RPAREN,
  [10416] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1501), 1,
      anon_sym_RPAREN,
  [10423] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1503), 1,
      anon_sym_RPAREN,
  [10430] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1505), 1,
      anon_sym_RPAREN,
  [10437] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1507), 1,
      anon_sym_RPAREN,
  [10444] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1205), 1,
      anon_sym_RPAREN,
  [10451] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1229), 1,
      anon_sym_RPAREN,
  [10458] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1029), 1,
      anon_sym_RPAREN,
  [10465] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1233), 1,
      anon_sym_RPAREN,
  [10472] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1237), 1,
      anon_sym_RPAREN,
  [10479] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1241), 1,
      anon_sym_RPAREN,
  [10486] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1245), 1,
      anon_sym_RPAREN,
  [10493] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1509), 1,
      anon_sym_RPAREN,
  [10500] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1137), 1,
      anon_sym_RPAREN,
  [10507] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1511), 1,
      anon_sym_RPAREN,
  [10514] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1513), 1,
      anon_sym_RPAREN,
  [10521] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1515), 1,
      anon_sym_RPAREN,
  [10528] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1517), 1,
      anon_sym_RPAREN,
  [10535] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1519), 1,
      anon_sym_RPAREN,
  [10542] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1521), 1,
      anon_sym_RPAREN,
  [10549] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1133), 1,
      anon_sym_RPAREN,
  [10556] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1129), 1,
      anon_sym_RPAREN,
  [10563] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1523), 1,
      anon_sym_RPAREN,
  [10570] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1525), 1,
      anon_sym_RPAREN,
  [10577] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1125), 1,
      anon_sym_RPAREN,
  [10584] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1527), 1,
      anon_sym_RPAREN,
  [10591] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1117), 1,
      anon_sym_RPAREN,
  [10598] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1529), 1,
      anon_sym_RPAREN,
  [10605] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1531), 1,
      anon_sym_RPAREN,
  [10612] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1533), 1,
      anon_sym_RPAREN,
  [10619] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1535), 1,
      anon_sym_RPAREN,
  [10626] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1537), 1,
      anon_sym_RPAREN,
  [10633] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1539), 1,
      anon_sym_RPAREN,
  [10640] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1541), 1,
      anon_sym_RPAREN,
  [10647] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1113), 1,
      anon_sym_RPAREN,
  [10654] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1543), 1,
      anon_sym_RPAREN,
  [10661] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1109), 1,
      anon_sym_RPAREN,
  [10668] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1545), 1,
      anon_sym_RPAREN,
  [10675] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1547), 1,
      anon_sym_RPAREN,
  [10682] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1549), 1,
      anon_sym_RPAREN,
  [10689] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1551), 1,
      anon_sym_RPAREN,
  [10696] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1553), 1,
      anon_sym_RPAREN,
  [10703] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1555), 1,
      anon_sym_RPAREN,
  [10710] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1105), 1,
      anon_sym_RPAREN,
  [10717] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1101), 1,
      anon_sym_RPAREN,
  [10724] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1097), 1,
      anon_sym_RPAREN,
  [10731] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1249), 1,
      anon_sym_RPAREN,
  [10738] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1253), 1,
      anon_sym_RPAREN,
  [10745] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1257), 1,
      anon_sym_RPAREN,
  [10752] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1261), 1,
      anon_sym_RPAREN,
  [10759] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1093), 1,
      anon_sym_RPAREN,
  [10766] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1089), 1,
      anon_sym_RPAREN,
  [10773] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1085), 1,
      anon_sym_RPAREN,
  [10780] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1081), 1,
      anon_sym_RPAREN,
  [10787] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1073), 1,
      anon_sym_RPAREN,
  [10794] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1069), 1,
      anon_sym_RPAREN,
  [10801] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1065), 1,
      anon_sym_RPAREN,
  [10808] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1061), 1,
      anon_sym_RPAREN,
  [10815] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1057), 1,
      anon_sym_RPAREN,
  [10822] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1053), 1,
      anon_sym_RPAREN,
  [10829] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1049), 1,
      anon_sym_RPAREN,
  [10836] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1189), 1,
      anon_sym_RPAREN,
  [10843] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1041), 1,
      anon_sym_RPAREN,
  [10850] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1557), 1,
      ts_builtin_sym_end,
  [10857] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1037), 1,
      anon_sym_RPAREN,
  [10864] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1033), 1,
      anon_sym_RPAREN,
  [10871] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1121), 1,
      anon_sym_RPAREN,
  [10878] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1157), 1,
      anon_sym_RPAREN,
  [10885] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1153), 1,
      anon_sym_RPAREN,
  [10892] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1149), 1,
      anon_sym_RPAREN,
  [10899] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1145), 1,
      anon_sym_RPAREN,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(234)] = 0,
  [SMALL_STATE(235)] = 65,
  [SMALL_STATE(236)] = 101,
  [SMALL_STATE(237)] = 137,
  [SMALL_STATE(238)] = 173,
  [SMALL_STATE(239)] = 209,
  [SMALL_STATE(240)] = 245,
  [SMALL_STATE(241)] = 281,
  [SMALL_STATE(242)] = 317,
  [SMALL_STATE(243)] = 353,
  [SMALL_STATE(244)] = 389,
  [SMALL_STATE(245)] = 425,
  [SMALL_STATE(246)] = 461,
  [SMALL_STATE(247)] = 497,
  [SMALL_STATE(248)] = 533,
  [SMALL_STATE(249)] = 569,
  [SMALL_STATE(250)] = 605,
  [SMALL_STATE(251)] = 641,
  [SMALL_STATE(252)] = 677,
  [SMALL_STATE(253)] = 713,
  [SMALL_STATE(254)] = 749,
  [SMALL_STATE(255)] = 785,
  [SMALL_STATE(256)] = 821,
  [SMALL_STATE(257)] = 857,
  [SMALL_STATE(258)] = 893,
  [SMALL_STATE(259)] = 929,
  [SMALL_STATE(260)] = 965,
  [SMALL_STATE(261)] = 1001,
  [SMALL_STATE(262)] = 1037,
  [SMALL_STATE(263)] = 1073,
  [SMALL_STATE(264)] = 1109,
  [SMALL_STATE(265)] = 1145,
  [SMALL_STATE(266)] = 1181,
  [SMALL_STATE(267)] = 1217,
  [SMALL_STATE(268)] = 1253,
  [SMALL_STATE(269)] = 1289,
  [SMALL_STATE(270)] = 1325,
  [SMALL_STATE(271)] = 1361,
  [SMALL_STATE(272)] = 1397,
  [SMALL_STATE(273)] = 1433,
  [SMALL_STATE(274)] = 1469,
  [SMALL_STATE(275)] = 1505,
  [SMALL_STATE(276)] = 1541,
  [SMALL_STATE(277)] = 1577,
  [SMALL_STATE(278)] = 1613,
  [SMALL_STATE(279)] = 1649,
  [SMALL_STATE(280)] = 1685,
  [SMALL_STATE(281)] = 1721,
  [SMALL_STATE(282)] = 1757,
  [SMALL_STATE(283)] = 1793,
  [SMALL_STATE(284)] = 1829,
  [SMALL_STATE(285)] = 1865,
  [SMALL_STATE(286)] = 1901,
  [SMALL_STATE(287)] = 1937,
  [SMALL_STATE(288)] = 1973,
  [SMALL_STATE(289)] = 2009,
  [SMALL_STATE(290)] = 2045,
  [SMALL_STATE(291)] = 2081,
  [SMALL_STATE(292)] = 2117,
  [SMALL_STATE(293)] = 2153,
  [SMALL_STATE(294)] = 2189,
  [SMALL_STATE(295)] = 2225,
  [SMALL_STATE(296)] = 2288,
  [SMALL_STATE(297)] = 2351,
  [SMALL_STATE(298)] = 2414,
  [SMALL_STATE(299)] = 2477,
  [SMALL_STATE(300)] = 2540,
  [SMALL_STATE(301)] = 2603,
  [SMALL_STATE(302)] = 2666,
  [SMALL_STATE(303)] = 2729,
  [SMALL_STATE(304)] = 2792,
  [SMALL_STATE(305)] = 2855,
  [SMALL_STATE(306)] = 2889,
  [SMALL_STATE(307)] = 2923,
  [SMALL_STATE(308)] = 2957,
  [SMALL_STATE(309)] = 2991,
  [SMALL_STATE(310)] = 3025,
  [SMALL_STATE(311)] = 3059,
  [SMALL_STATE(312)] = 3093,
  [SMALL_STATE(313)] = 3127,
  [SMALL_STATE(314)] = 3161,
  [SMALL_STATE(315)] = 3195,
  [SMALL_STATE(316)] = 3229,
  [SMALL_STATE(317)] = 3263,
  [SMALL_STATE(318)] = 3297,
  [SMALL_STATE(319)] = 3331,
  [SMALL_STATE(320)] = 3365,
  [SMALL_STATE(321)] = 3399,
  [SMALL_STATE(322)] = 3433,
  [SMALL_STATE(323)] = 3467,
  [SMALL_STATE(324)] = 3501,
  [SMALL_STATE(325)] = 3535,
  [SMALL_STATE(326)] = 3569,
  [SMALL_STATE(327)] = 3603,
  [SMALL_STATE(328)] = 3637,
  [SMALL_STATE(329)] = 3671,
  [SMALL_STATE(330)] = 3705,
  [SMALL_STATE(331)] = 3739,
  [SMALL_STATE(332)] = 3773,
  [SMALL_STATE(333)] = 3807,
  [SMALL_STATE(334)] = 3841,
  [SMALL_STATE(335)] = 3875,
  [SMALL_STATE(336)] = 3909,
  [SMALL_STATE(337)] = 3943,
  [SMALL_STATE(338)] = 3977,
  [SMALL_STATE(339)] = 4011,
  [SMALL_STATE(340)] = 4045,
  [SMALL_STATE(341)] = 4079,
  [SMALL_STATE(342)] = 4113,
  [SMALL_STATE(343)] = 4147,
  [SMALL_STATE(344)] = 4181,
  [SMALL_STATE(345)] = 4215,
  [SMALL_STATE(346)] = 4249,
  [SMALL_STATE(347)] = 4283,
  [SMALL_STATE(348)] = 4317,
  [SMALL_STATE(349)] = 4351,
  [SMALL_STATE(350)] = 4385,
  [SMALL_STATE(351)] = 4419,
  [SMALL_STATE(352)] = 4453,
  [SMALL_STATE(353)] = 4487,
  [SMALL_STATE(354)] = 4521,
  [SMALL_STATE(355)] = 4555,
  [SMALL_STATE(356)] = 4589,
  [SMALL_STATE(357)] = 4623,
  [SMALL_STATE(358)] = 4657,
  [SMALL_STATE(359)] = 4691,
  [SMALL_STATE(360)] = 4725,
  [SMALL_STATE(361)] = 4759,
  [SMALL_STATE(362)] = 4793,
  [SMALL_STATE(363)] = 4827,
  [SMALL_STATE(364)] = 4861,
  [SMALL_STATE(365)] = 4894,
  [SMALL_STATE(366)] = 4927,
  [SMALL_STATE(367)] = 4959,
  [SMALL_STATE(368)] = 4991,
  [SMALL_STATE(369)] = 5025,
  [SMALL_STATE(370)] = 5059,
  [SMALL_STATE(371)] = 5091,
  [SMALL_STATE(372)] = 5123,
  [SMALL_STATE(373)] = 5155,
  [SMALL_STATE(374)] = 5187,
  [SMALL_STATE(375)] = 5219,
  [SMALL_STATE(376)] = 5251,
  [SMALL_STATE(377)] = 5283,
  [SMALL_STATE(378)] = 5315,
  [SMALL_STATE(379)] = 5347,
  [SMALL_STATE(380)] = 5379,
  [SMALL_STATE(381)] = 5411,
  [SMALL_STATE(382)] = 5443,
  [SMALL_STATE(383)] = 5475,
  [SMALL_STATE(384)] = 5511,
  [SMALL_STATE(385)] = 5543,
  [SMALL_STATE(386)] = 5575,
  [SMALL_STATE(387)] = 5607,
  [SMALL_STATE(388)] = 5639,
  [SMALL_STATE(389)] = 5671,
  [SMALL_STATE(390)] = 5703,
  [SMALL_STATE(391)] = 5739,
  [SMALL_STATE(392)] = 5771,
  [SMALL_STATE(393)] = 5803,
  [SMALL_STATE(394)] = 5835,
  [SMALL_STATE(395)] = 5867,
  [SMALL_STATE(396)] = 5899,
  [SMALL_STATE(397)] = 5931,
  [SMALL_STATE(398)] = 5963,
  [SMALL_STATE(399)] = 5995,
  [SMALL_STATE(400)] = 6027,
  [SMALL_STATE(401)] = 6059,
  [SMALL_STATE(402)] = 6091,
  [SMALL_STATE(403)] = 6123,
  [SMALL_STATE(404)] = 6157,
  [SMALL_STATE(405)] = 6191,
  [SMALL_STATE(406)] = 6225,
  [SMALL_STATE(407)] = 6257,
  [SMALL_STATE(408)] = 6289,
  [SMALL_STATE(409)] = 6323,
  [SMALL_STATE(410)] = 6355,
  [SMALL_STATE(411)] = 6389,
  [SMALL_STATE(412)] = 6421,
  [SMALL_STATE(413)] = 6453,
  [SMALL_STATE(414)] = 6487,
  [SMALL_STATE(415)] = 6519,
  [SMALL_STATE(416)] = 6553,
  [SMALL_STATE(417)] = 6587,
  [SMALL_STATE(418)] = 6621,
  [SMALL_STATE(419)] = 6655,
  [SMALL_STATE(420)] = 6689,
  [SMALL_STATE(421)] = 6723,
  [SMALL_STATE(422)] = 6755,
  [SMALL_STATE(423)] = 6787,
  [SMALL_STATE(424)] = 6819,
  [SMALL_STATE(425)] = 6851,
  [SMALL_STATE(426)] = 6883,
  [SMALL_STATE(427)] = 6915,
  [SMALL_STATE(428)] = 6947,
  [SMALL_STATE(429)] = 6979,
  [SMALL_STATE(430)] = 7011,
  [SMALL_STATE(431)] = 7047,
  [SMALL_STATE(432)] = 7079,
  [SMALL_STATE(433)] = 7111,
  [SMALL_STATE(434)] = 7143,
  [SMALL_STATE(435)] = 7175,
  [SMALL_STATE(436)] = 7207,
  [SMALL_STATE(437)] = 7239,
  [SMALL_STATE(438)] = 7271,
  [SMALL_STATE(439)] = 7303,
  [SMALL_STATE(440)] = 7335,
  [SMALL_STATE(441)] = 7367,
  [SMALL_STATE(442)] = 7399,
  [SMALL_STATE(443)] = 7431,
  [SMALL_STATE(444)] = 7463,
  [SMALL_STATE(445)] = 7495,
  [SMALL_STATE(446)] = 7529,
  [SMALL_STATE(447)] = 7561,
  [SMALL_STATE(448)] = 7593,
  [SMALL_STATE(449)] = 7625,
  [SMALL_STATE(450)] = 7657,
  [SMALL_STATE(451)] = 7691,
  [SMALL_STATE(452)] = 7723,
  [SMALL_STATE(453)] = 7755,
  [SMALL_STATE(454)] = 7787,
  [SMALL_STATE(455)] = 7821,
  [SMALL_STATE(456)] = 7855,
  [SMALL_STATE(457)] = 7889,
  [SMALL_STATE(458)] = 7921,
  [SMALL_STATE(459)] = 7955,
  [SMALL_STATE(460)] = 7986,
  [SMALL_STATE(461)] = 8039,
  [SMALL_STATE(462)] = 8070,
  [SMALL_STATE(463)] = 8117,
  [SMALL_STATE(464)] = 8164,
  [SMALL_STATE(465)] = 8211,
  [SMALL_STATE(466)] = 8258,
  [SMALL_STATE(467)] = 8305,
  [SMALL_STATE(468)] = 8347,
  [SMALL_STATE(469)] = 8389,
  [SMALL_STATE(470)] = 8431,
  [SMALL_STATE(471)] = 8473,
  [SMALL_STATE(472)] = 8515,
  [SMALL_STATE(473)] = 8552,
  [SMALL_STATE(474)] = 8589,
  [SMALL_STATE(475)] = 8626,
  [SMALL_STATE(476)] = 8663,
  [SMALL_STATE(477)] = 8700,
  [SMALL_STATE(478)] = 8719,
  [SMALL_STATE(479)] = 8738,
  [SMALL_STATE(480)] = 8757,
  [SMALL_STATE(481)] = 8776,
  [SMALL_STATE(482)] = 8795,
  [SMALL_STATE(483)] = 8814,
  [SMALL_STATE(484)] = 8833,
  [SMALL_STATE(485)] = 8852,
  [SMALL_STATE(486)] = 8871,
  [SMALL_STATE(487)] = 8890,
  [SMALL_STATE(488)] = 8909,
  [SMALL_STATE(489)] = 8928,
  [SMALL_STATE(490)] = 8947,
  [SMALL_STATE(491)] = 8966,
  [SMALL_STATE(492)] = 8985,
  [SMALL_STATE(493)] = 9004,
  [SMALL_STATE(494)] = 9023,
  [SMALL_STATE(495)] = 9042,
  [SMALL_STATE(496)] = 9061,
  [SMALL_STATE(497)] = 9080,
  [SMALL_STATE(498)] = 9099,
  [SMALL_STATE(499)] = 9118,
  [SMALL_STATE(500)] = 9137,
  [SMALL_STATE(501)] = 9156,
  [SMALL_STATE(502)] = 9175,
  [SMALL_STATE(503)] = 9194,
  [SMALL_STATE(504)] = 9213,
  [SMALL_STATE(505)] = 9232,
  [SMALL_STATE(506)] = 9251,
  [SMALL_STATE(507)] = 9270,
  [SMALL_STATE(508)] = 9289,
  [SMALL_STATE(509)] = 9308,
  [SMALL_STATE(510)] = 9327,
  [SMALL_STATE(511)] = 9346,
  [SMALL_STATE(512)] = 9365,
  [SMALL_STATE(513)] = 9384,
  [SMALL_STATE(514)] = 9403,
  [SMALL_STATE(515)] = 9422,
  [SMALL_STATE(516)] = 9441,
  [SMALL_STATE(517)] = 9460,
  [SMALL_STATE(518)] = 9479,
  [SMALL_STATE(519)] = 9498,
  [SMALL_STATE(520)] = 9517,
  [SMALL_STATE(521)] = 9536,
  [SMALL_STATE(522)] = 9555,
  [SMALL_STATE(523)] = 9574,
  [SMALL_STATE(524)] = 9593,
  [SMALL_STATE(525)] = 9612,
  [SMALL_STATE(526)] = 9631,
  [SMALL_STATE(527)] = 9650,
  [SMALL_STATE(528)] = 9669,
  [SMALL_STATE(529)] = 9688,
  [SMALL_STATE(530)] = 9707,
  [SMALL_STATE(531)] = 9726,
  [SMALL_STATE(532)] = 9745,
  [SMALL_STATE(533)] = 9764,
  [SMALL_STATE(534)] = 9783,
  [SMALL_STATE(535)] = 9802,
  [SMALL_STATE(536)] = 9821,
  [SMALL_STATE(537)] = 9840,
  [SMALL_STATE(538)] = 9859,
  [SMALL_STATE(539)] = 9875,
  [SMALL_STATE(540)] = 9891,
  [SMALL_STATE(541)] = 9898,
  [SMALL_STATE(542)] = 9905,
  [SMALL_STATE(543)] = 9912,
  [SMALL_STATE(544)] = 9919,
  [SMALL_STATE(545)] = 9926,
  [SMALL_STATE(546)] = 9933,
  [SMALL_STATE(547)] = 9940,
  [SMALL_STATE(548)] = 9947,
  [SMALL_STATE(549)] = 9954,
  [SMALL_STATE(550)] = 9961,
  [SMALL_STATE(551)] = 9968,
  [SMALL_STATE(552)] = 9975,
  [SMALL_STATE(553)] = 9982,
  [SMALL_STATE(554)] = 9989,
  [SMALL_STATE(555)] = 9996,
  [SMALL_STATE(556)] = 10003,
  [SMALL_STATE(557)] = 10010,
  [SMALL_STATE(558)] = 10017,
  [SMALL_STATE(559)] = 10024,
  [SMALL_STATE(560)] = 10031,
  [SMALL_STATE(561)] = 10038,
  [SMALL_STATE(562)] = 10045,
  [SMALL_STATE(563)] = 10052,
  [SMALL_STATE(564)] = 10059,
  [SMALL_STATE(565)] = 10066,
  [SMALL_STATE(566)] = 10073,
  [SMALL_STATE(567)] = 10080,
  [SMALL_STATE(568)] = 10087,
  [SMALL_STATE(569)] = 10094,
  [SMALL_STATE(570)] = 10101,
  [SMALL_STATE(571)] = 10108,
  [SMALL_STATE(572)] = 10115,
  [SMALL_STATE(573)] = 10122,
  [SMALL_STATE(574)] = 10129,
  [SMALL_STATE(575)] = 10136,
  [SMALL_STATE(576)] = 10143,
  [SMALL_STATE(577)] = 10150,
  [SMALL_STATE(578)] = 10157,
  [SMALL_STATE(579)] = 10164,
  [SMALL_STATE(580)] = 10171,
  [SMALL_STATE(581)] = 10178,
  [SMALL_STATE(582)] = 10185,
  [SMALL_STATE(583)] = 10192,
  [SMALL_STATE(584)] = 10199,
  [SMALL_STATE(585)] = 10206,
  [SMALL_STATE(586)] = 10213,
  [SMALL_STATE(587)] = 10220,
  [SMALL_STATE(588)] = 10227,
  [SMALL_STATE(589)] = 10234,
  [SMALL_STATE(590)] = 10241,
  [SMALL_STATE(591)] = 10248,
  [SMALL_STATE(592)] = 10255,
  [SMALL_STATE(593)] = 10262,
  [SMALL_STATE(594)] = 10269,
  [SMALL_STATE(595)] = 10276,
  [SMALL_STATE(596)] = 10283,
  [SMALL_STATE(597)] = 10290,
  [SMALL_STATE(598)] = 10297,
  [SMALL_STATE(599)] = 10304,
  [SMALL_STATE(600)] = 10311,
  [SMALL_STATE(601)] = 10318,
  [SMALL_STATE(602)] = 10325,
  [SMALL_STATE(603)] = 10332,
  [SMALL_STATE(604)] = 10339,
  [SMALL_STATE(605)] = 10346,
  [SMALL_STATE(606)] = 10353,
  [SMALL_STATE(607)] = 10360,
  [SMALL_STATE(608)] = 10367,
  [SMALL_STATE(609)] = 10374,
  [SMALL_STATE(610)] = 10381,
  [SMALL_STATE(611)] = 10388,
  [SMALL_STATE(612)] = 10395,
  [SMALL_STATE(613)] = 10402,
  [SMALL_STATE(614)] = 10409,
  [SMALL_STATE(615)] = 10416,
  [SMALL_STATE(616)] = 10423,
  [SMALL_STATE(617)] = 10430,
  [SMALL_STATE(618)] = 10437,
  [SMALL_STATE(619)] = 10444,
  [SMALL_STATE(620)] = 10451,
  [SMALL_STATE(621)] = 10458,
  [SMALL_STATE(622)] = 10465,
  [SMALL_STATE(623)] = 10472,
  [SMALL_STATE(624)] = 10479,
  [SMALL_STATE(625)] = 10486,
  [SMALL_STATE(626)] = 10493,
  [SMALL_STATE(627)] = 10500,
  [SMALL_STATE(628)] = 10507,
  [SMALL_STATE(629)] = 10514,
  [SMALL_STATE(630)] = 10521,
  [SMALL_STATE(631)] = 10528,
  [SMALL_STATE(632)] = 10535,
  [SMALL_STATE(633)] = 10542,
  [SMALL_STATE(634)] = 10549,
  [SMALL_STATE(635)] = 10556,
  [SMALL_STATE(636)] = 10563,
  [SMALL_STATE(637)] = 10570,
  [SMALL_STATE(638)] = 10577,
  [SMALL_STATE(639)] = 10584,
  [SMALL_STATE(640)] = 10591,
  [SMALL_STATE(641)] = 10598,
  [SMALL_STATE(642)] = 10605,
  [SMALL_STATE(643)] = 10612,
  [SMALL_STATE(644)] = 10619,
  [SMALL_STATE(645)] = 10626,
  [SMALL_STATE(646)] = 10633,
  [SMALL_STATE(647)] = 10640,
  [SMALL_STATE(648)] = 10647,
  [SMALL_STATE(649)] = 10654,
  [SMALL_STATE(650)] = 10661,
  [SMALL_STATE(651)] = 10668,
  [SMALL_STATE(652)] = 10675,
  [SMALL_STATE(653)] = 10682,
  [SMALL_STATE(654)] = 10689,
  [SMALL_STATE(655)] = 10696,
  [SMALL_STATE(656)] = 10703,
  [SMALL_STATE(657)] = 10710,
  [SMALL_STATE(658)] = 10717,
  [SMALL_STATE(659)] = 10724,
  [SMALL_STATE(660)] = 10731,
  [SMALL_STATE(661)] = 10738,
  [SMALL_STATE(662)] = 10745,
  [SMALL_STATE(663)] = 10752,
  [SMALL_STATE(664)] = 10759,
  [SMALL_STATE(665)] = 10766,
  [SMALL_STATE(666)] = 10773,
  [SMALL_STATE(667)] = 10780,
  [SMALL_STATE(668)] = 10787,
  [SMALL_STATE(669)] = 10794,
  [SMALL_STATE(670)] = 10801,
  [SMALL_STATE(671)] = 10808,
  [SMALL_STATE(672)] = 10815,
  [SMALL_STATE(673)] = 10822,
  [SMALL_STATE(674)] = 10829,
  [SMALL_STATE(675)] = 10836,
  [SMALL_STATE(676)] = 10843,
  [SMALL_STATE(677)] = 10850,
  [SMALL_STATE(678)] = 10857,
  [SMALL_STATE(679)] = 10864,
  [SMALL_STATE(680)] = 10871,
  [SMALL_STATE(681)] = 10878,
  [SMALL_STATE(682)] = 10885,
  [SMALL_STATE(683)] = 10892,
  [SMALL_STATE(684)] = 10899,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(399),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(398),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(147),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(160),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(23),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(474),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(207),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(148),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(41),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(473),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(476),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(44),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(282),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(281),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [275] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(264),
  [278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(6),
  [281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22),
  [283] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(130),
  [286] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(68),
  [289] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(74),
  [292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(17),
  [295] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(18),
  [298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22),
  [300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(183),
  [303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(182),
  [306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(181),
  [309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(180),
  [312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(185),
  [315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(283),
  [318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(282),
  [321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(281),
  [324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(283),
  [327] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(264),
  [330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(285),
  [333] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(284),
  [336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(133),
  [344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [392] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(348),
  [395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(3),
  [398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7),
  [400] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(99),
  [403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(125),
  [406] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(102),
  [409] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(15),
  [412] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(16),
  [415] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(175),
  [418] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(176),
  [421] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(177),
  [424] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(178),
  [427] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(179),
  [430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(334),
  [433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(350),
  [436] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(349),
  [439] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(334),
  [442] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(348),
  [445] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(326),
  [448] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(318),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(348),
  [494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(3),
  [497] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(99),
  [500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(125),
  [503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(102),
  [506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(15),
  [509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10),
  [511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(16),
  [514] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(175),
  [517] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(176),
  [520] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(177),
  [523] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(178),
  [526] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(179),
  [529] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(334),
  [532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(350),
  [535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(349),
  [538] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(334),
  [541] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(348),
  [544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(326),
  [547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(318),
  [550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(348),
  [553] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(3),
  [556] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(99),
  [559] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(125),
  [562] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(102),
  [565] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(15),
  [568] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(16),
  [571] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(175),
  [574] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(176),
  [577] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(177),
  [580] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(178),
  [583] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(179),
  [586] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(334),
  [589] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(350),
  [592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(349),
  [595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(334),
  [598] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(348),
  [601] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(326),
  [604] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(318),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(581),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(575),
  [643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(580),
  [645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(574),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_body, 1, .production_id = 5),
  [673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [719] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(348),
  [722] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(3),
  [725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13),
  [727] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(99),
  [730] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(125),
  [733] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(102),
  [736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(15),
  [739] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(16),
  [742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(175),
  [745] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(176),
  [748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(177),
  [751] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(178),
  [754] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(179),
  [757] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(334),
  [760] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(350),
  [763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(349),
  [766] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(334),
  [769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(348),
  [772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(326),
  [775] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(318),
  [778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(412),
  [805] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(4),
  [808] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(69),
  [811] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(132),
  [814] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(140),
  [817] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(32),
  [820] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(40),
  [823] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(191),
  [826] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(192),
  [829] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(193),
  [832] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(194),
  [835] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(195),
  [838] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(398),
  [841] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(399),
  [844] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(411),
  [847] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(398),
  [850] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(412),
  [853] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(392),
  [856] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(397),
  [859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1),
  [863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(507),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19),
  [997] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(539),
  [1000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19),
  [1002] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(15),
  [1005] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(175),
  [1008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(176),
  [1011] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(177),
  [1014] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(178),
  [1017] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(459),
  [1020] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(326),
  [1023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expr, 1),
  [1025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expr, 1),
  [1027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_short_fn, 2, .production_id = 3),
  [1029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_fn, 2, .production_id = 3),
  [1031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var, 6, .production_id = 25),
  [1033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var, 6, .production_id = 25),
  [1035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_def, 6, .production_id = 25),
  [1037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_def, 6, .production_id = 25),
  [1039] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extra_defs, 5, .production_id = 24),
  [1041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extra_defs, 5, .production_id = 24),
  [1043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fn, 5, .production_id = 24),
  [1045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fn, 5, .production_id = 24),
  [1047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fn, 5, .production_id = 23),
  [1049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fn, 5, .production_id = 23),
  [1051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while, 5, .production_id = 21),
  [1053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while, 5, .production_id = 21),
  [1055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 5, .production_id = 20),
  [1057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 5, .production_id = 20),
  [1059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var, 5, .production_id = 18),
  [1061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var, 5, .production_id = 18),
  [1063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_def, 5, .production_id = 18),
  [1065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_def, 5, .production_id = 18),
  [1067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set, 5, .production_id = 17),
  [1069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set, 5, .production_id = 17),
  [1071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_upscope, 4, .production_id = 12),
  [1073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_upscope, 4, .production_id = 12),
  [1075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 1, .production_id = 15),
  [1077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 1, .production_id = 15),
  [1079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fn, 4, .production_id = 16),
  [1081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fn, 4, .production_id = 16),
  [1083] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while, 4, .production_id = 14),
  [1085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while, 4, .production_id = 14),
  [1087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do, 4, .production_id = 12),
  [1089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do, 4, .production_id = 12),
  [1091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break, 4),
  [1093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break, 4),
  [1095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_peg_set, 4),
  [1097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_peg_set, 4),
  [1099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table, 3, .production_id = 9),
  [1101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table, 3, .production_id = 9),
  [1103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct, 3, .production_id = 9),
  [1105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct, 3, .production_id = 9),
  [1107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sqr_array, 3, .production_id = 6),
  [1109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sqr_array, 3, .production_id = 6),
  [1111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3, .production_id = 6),
  [1113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3, .production_id = 6),
  [1115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sqr_tuple, 3, .production_id = 6),
  [1117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sqr_tuple, 3, .production_id = 6),
  [1119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 6, .production_id = 26),
  [1121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 6, .production_id = 26),
  [1123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 3, .production_id = 6),
  [1125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 3, .production_id = 6),
  [1127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_upscope, 3),
  [1129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_upscope, 3),
  [1131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do, 3),
  [1133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do, 3),
  [1135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break, 3),
  [1137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break, 3),
  [1139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__identifier, 1),
  [1141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier, 1),
  [1143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extra_defs, 7, .production_id = 31),
  [1145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extra_defs, 7, .production_id = 31),
  [1147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extra_defs, 6, .production_id = 29),
  [1149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extra_defs, 6, .production_id = 29),
  [1151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extra_defs, 6, .production_id = 28),
  [1153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extra_defs, 6, .production_id = 28),
  [1155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fn, 6, .production_id = 28),
  [1157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fn, 6, .production_id = 28),
  [1159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_short_quote, 2),
  [1161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_quote, 2),
  [1163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_short_splice, 2),
  [1165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_splice, 2),
  [1167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table, 2),
  [1169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table, 2),
  [1171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct, 2),
  [1173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct, 2),
  [1175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sqr_array, 2),
  [1177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sqr_array, 2),
  [1179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2),
  [1181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2),
  [1183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sqr_tuple, 2),
  [1185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sqr_tuple, 2),
  [1187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 2),
  [1189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 2),
  [1191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__specials, 1),
  [1193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__specials, 1),
  [1195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__shorthand, 1),
  [1197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__shorthand, 1),
  [1199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__special_forms, 1),
  [1201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__special_forms, 1),
  [1203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_short_quasiquote, 2),
  [1205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_quasiquote, 2),
  [1207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bool_literal, 1),
  [1209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bool_literal, 1),
  [1211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_number_literal, 1),
  [1213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_number_literal, 1),
  [1215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__literals, 1),
  [1217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__literals, 1),
  [1219] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_long_buffer_literal, 1),
  [1221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_long_buffer_literal, 1),
  [1223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_long_str_literal, 1),
  [1225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_long_str_literal, 1),
  [1227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_short_unquote, 2),
  [1229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_unquote, 2),
  [1231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quote, 3),
  [1233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quote, 3),
  [1235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splice, 3),
  [1237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splice, 3),
  [1239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quasiquote, 3),
  [1241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quasiquote, 3),
  [1243] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unquote, 3),
  [1245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unquote, 3),
  [1247] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quote, 4),
  [1249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quote, 4),
  [1251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splice, 4),
  [1253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splice, 4),
  [1255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quasiquote, 4),
  [1257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quasiquote, 4),
  [1259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unquote, 4),
  [1261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unquote, 4),
  [1263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [1271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_tuple_repeat1, 1, .production_id = 1),
  [1273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 1, .production_id = 1),
  [1275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 5, .production_id = 30),
  [1277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 5, .production_id = 30),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [1281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_parameters, 4, .production_id = 27),
  [1283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameters, 4, .production_id = 27),
  [1285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 4, .production_id = 27),
  [1287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 4, .production_id = 27),
  [1289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_parameters, 5, .production_id = 30),
  [1291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameters, 5, .production_id = 30),
  [1293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_metadata, 1),
  [1295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_metadata, 1),
  [1297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 3),
  [1299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3),
  [1301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 1),
  [1303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameters, 1),
  [1305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 2),
  [1307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2),
  [1309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_parameters, 2),
  [1311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameters, 2),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [1315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_parameters, 3),
  [1317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameters, 3),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [1321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__struct_tables_commom, 2, .production_id = 8),
  [1323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__struct_tables_commom, 2, .production_id = 8),
  [1325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__name, 1),
  [1327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__name, 1),
  [1329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_while_repeat1, 1, .production_id = 4),
  [1331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 1, .production_id = 4),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [1335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_struct_repeat1, 1, .production_id = 2),
  [1337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 1, .production_id = 2),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [1341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(538),
  [1344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(36),
  [1347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(189),
  [1350] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(188),
  [1353] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(187),
  [1356] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(186),
  [1359] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(512),
  [1362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(530),
  [1365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_def_repeat1, 1, .production_id = 11),
  [1367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 1, .production_id = 11),
  [1369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [1383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [1385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [1393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [1401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [1413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [1417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [1421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [1469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [1473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [1481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [1491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [1497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [1499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [1503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [1505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [1509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [1513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [1515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [1517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [1519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [1521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [1523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [1525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [1527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [1529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [1531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [1533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [1535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [1537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [1539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [1541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [1543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [1545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [1547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [1549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [1551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [1553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [1555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [1557] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_janet_external_scanner_create(void);
void tree_sitter_janet_external_scanner_destroy(void *);
bool tree_sitter_janet_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_janet_external_scanner_serialize(void *, char *);
void tree_sitter_janet_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_janet(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .symbol_names = ts_symbol_names,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const uint16_t *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_symbol,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_janet_external_scanner_create,
      tree_sitter_janet_external_scanner_destroy,
      tree_sitter_janet_external_scanner_scan,
      tree_sitter_janet_external_scanner_serialize,
      tree_sitter_janet_external_scanner_deserialize,
    },
    .field_count = FIELD_COUNT,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .field_names = ts_field_names,
    .large_state_count = LARGE_STATE_COUNT,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .state_count = STATE_COUNT,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
